
Code     SEGMENT
         ASSUME    cs:Code,ds:Code
         ORG       100h

; ------ zobrazen vodnho textu

Start:   mov       dx,offset UvTxt
         mov       ah,9
         int       21h

; ------ pprava k rozboru pkazovho dku

         mov       si,81h                   ; zatek pkazovho dku
         mov       cl,ds:[si-1]             ; dlka pkazovho dku
         mov       ch,0
         cld

; ------ nalezen oznaen disku

Start1:  jcxz      Start2                   ; nen dal znak
         lodsb                              ; naten znaku
         dec       cx                       ; snen tae znak
         cmp       al," "
         jbe       Start1                   ; vyputn mezery

; ------ test platnosti znaku

         or        al,20h                   ; konverze na mal psmeno
         sub       al,"a"
         jb        Start2                   ; neplatn disk
         cmp       al,32                    ; maximln slo disku
         jb        Start3                   ; slo disku je OK

; ------ zobrazen npovdy

Start2:  mov       dx,offset HelpTxt
Chyba:   mov       ah,9
         int       21h
         int       20h

; ------ pprava parametr disku

Start3:  mov       ds:[Disk],al             ; schova sla disku
         add       ds:[OemTxt1],al          ; oznaen disku
         add       ds:[ReadTxt1],al         ; oznaen disku

; ------ naten sektoru bnou slubou INT 25h

         mov       bx,offset Buffer         ; buffer k naten sektoru
         mov       cx,1                     ; poet sektor k naten
         xor       dx,dx                    ; slo sektoru BOOT
         mov       ds:[Zasobnik],sp         ; schova registru SP
         int       25h                      ; pokus o naten BOOT sektoru
         push      cs
         pop       ds
         mov       sp,ds:[Zasobnik]         ; nvrat registru SP
         jnc       Start4                   ; sektor naten OK

; ------ naten sektoru rozenou slubou INT 25h

         mov       al,ds:[Disk]             ; slo disku
         mov       cx,-1                    ; pznak rozen sluby
         mov       bx,offset Paket          ; paket rozench informac
         mov       ds:[PaketDS],ds          ; segment adresy bufferu
         int       25h                      ; druh pokus o naten BOOT sektoru
         push      cs
         pop       ds
         mov       sp,ds:[Zasobnik]         ; nvrat registru SP
         mov       dx,offset ReadTxt        ; chyba ten
         jc        Chyba                    ; chyba ten sektoru

; ------ penos OEM textu

Start4:  push      cs
         pop       es                       ; ES <- CS
         mov       cx,8                     ; poet znak k penosu
         mov       si,offset Buffer + 3     ; text OEM
         mov       di,offset OEMTxt2
         cld
         rep       movsb                    ; penos textu

; ------ zobrazen informac OEM

         mov       dx,offset OEMTxt
         mov       ah,9
         int       21h
         int       20h

Zasobnik dw        0                        ; uschovan registr SP

Disk     db        0                        ; poadovan disk

UvTxt    db        'OEMDISK V1.0 - zobrazeni firemni identifikace disku; (c) Miroslav Nemecek',13,10,'$'

HelpTxt  db        '   Zadejte oznaceni disku (napr. OEMDISK D:),',13,10
         db        '   jehoz identifikaci chcete zobrazit.',13,10,'$'

ReadTxt  db        'CHYBA - disk '
ReadTxt1 db        'A: neni pristupny !',13,10,'$'

OemTxt   db        'Firemni identifikace disku '
OemTxt1  db        'A: je "'
OemTxt2  db        8 dup(" "),'".',13,10,'$'

Paket    label     word                     ; paket pro rozen informace
         dd        0                        ; slo sektoru
         dw        1                        ; poet sektor
         dw        Buffer                   ; adresa bufferu - offset
PaketDS  dw        0                        ; adresa bufferu - segment

Buffer   db        512 dup(" ")             ; buffer k naten BOOT sektoru

Code     ENDS
         END       Start
