
Code     SEGMENT
         ASSUME    cs:Code,ds:Code
         ORG       100h

; ------ pprava pkazovho dku

Start:   mov       si,81h                   ; zatek pkazovho dku
         mov       cl,ds:[si-1]             ; dlka pkazovho dku
         mov       ch,0
         cld

; ------ nalezen znaku v pkazovm dku

Start1:  jcxz      Start4
         lodsb                              ; naten znaku
         dec       cx                       ; snen tae znak
         cmp       al," "
         jbe       Start1                   ; vyputn znaku mezery

; ------ test, zda je oznaen disku

         or        al,20h                   ; korekce na mal psmeno
         sub       al,"a"                   ; slo disku
         jc        Start4                   ; neplatn oznaen disku
         cmp       al,1
         jbe       Start5                   ; slo disku je OK

; ------ chyba zadn - zobrazen npovdy

Start4:  mov       dx,offset HelpTxt
         mov       ah,9
         int       21h
         mov       ax,4c00h
         int       21h

; ------ naten typu disku AL z CMOS

Start5:  add       byte ptr ds:[DiskTxtX],al
         call      GetTDisk                 ; ten typu disku z CMOS
         jnc       Start6                   ; disk detekovn OK
         call      TestCMOS                 ; je pam CMOS ?
         mov       al,1                     ; mechanika 360 KB (asi je XT)
         jc        Start6                   ; nen pam CMOS, asi je XT
         mov       al,0                     ; neplatn disk

; ------ vodn st hlen

Start6:  push      ax
         mov       dx,offset DiskTxt
         mov       ah,9
         int       21h
         pop       ax

; ------ text disku

         push      ax
         mov       ah,0
         mov       dx,offset DiskTxt1
         dec       ax
         jz        Start7
         mov       dx,offset DiskTxt2
         dec       ax
         jz        Start7
         mov       dx,offset DiskTxt3
         dec       ax
         jz        Start7
         mov       dx,offset DiskTxt4
         dec       ax
         jz        Start7
         mov       dx,offset DiskTxt5
         dec       ax
         jz        Start7
         mov       dx,offset DiskTxt0
Start7:  mov       ah,9
         int       21h
         pop       ax

; ------ nvrat s nvratovm kdem AL

         mov       ah,4ch
         int       21h

; -----------------------------------------------------------------------------
;        naten typu mechaniky AL z CMOS -> AL (CY=neplatn disk)
; -----------------------------------------------------------------------------

GetTDisk PROC      NEAR

         call      TestCMOS                 ; test pamti CMOS
         jc        GetTDsk3                 ; neplatn CMOS

         inc       ax                       ; 1=A:, 2=B:
         shl       al,1
         shl       al,1                     ; 4=A:, 8=B:
         xchg      ax,cx                    ; CL <- 4=A:, 8=B:

         mov       ah,10h                   ; slo registru CMOS
         call      ReadCMOS                 ; naten registru z CMOS -> AL
         rol       al,cl                    ; rotace sla na pozici
         and       al,0fh                   ; slo mechaniky

         cmp       al,1                     ; minimln slo 1
         jb        GetTDsk3                 ; neplatn disk
         cmp       al,6                     ; maximln slo 5
         cmc

GetTDsk3:ret

GetTDisk ENDP

; -----------------------------------------------------------------------------
;        test kontrolnho soutu pamti CMOS -> CY=neplatn pam
; -----------------------------------------------------------------------------

TestCMOS PROC      NEAR

; ------ schova registr

         push      ax
         push      dx

; ------ kontroln souet CMOS

         xor       dx,dx                    ; stada kontrolnho soutu
         mov       ah,10h                   ; ukazatel sla registru
TestCMS2:call      ReadCMOS                 ; ten bajtu
         add       dl,al                    ; piten
         adc       dh,0
         inc       ah                       ; zven ukazatele
         cmp       ah,2eh
         jne       TestCMS2                 ; dal bajt

; ------ kontrola kontrolnho soutu

         call      ReadCMOS                 ; ten bajtu 2Eh
         cmp       al,dh                    ; souhlas souet HIGH ?
         jne       TestCMS8                 ; nesouhlas
         inc       ah
         call      ReadCMOS                 ; ten bajtu 2Fh
         cmp       al,dl                    ; souhlas souet LOW ?
         je        TestCMS9                 ; souhlas OK
TestCMS8:stc                                ; pznak chyby

; ------ nvrat registr

TestCMS9:pop       dx
         pop       ax
         ret

TestCMOS ENDP

; -----------------------------------------------------------------------------
;        ten bajtu z pamti CMOS (adresa AH) -> AL
; -----------------------------------------------------------------------------

ReadCMOS PROC      NEAR

         xchg      al,ah
         out       [70h],al                 ; nastaven adresy
         xchg      al,ah
         jmp       short $+2
         jmp       short $+2
         jmp       short $+2
         in        al,[71h]                 ; naten hodnoty CMOS
         ret

ReadCMOS ENDP

; -----------------------------------------------------------------------------
;        data
; -----------------------------------------------------------------------------

HelpTxt  db        'TYPFLOP V1.0 - detekce typu disketove mechaniky; (c) Miroslav Nemecek',13,10
         db        ' Zadejte oznaceni disku A nebo B, ktery chcete detekovat.',13,10
         db        ' Navraceny kod (ERRORLEVEL):   0 ..... disk neni nainstalovan',13,10
         db        '                               1 ..... mechanika 360 KB DD 5 1/4"',13,10
         db        '                               2 ..... mechanika 1.2 MB HD 5 1/4"',13,10
         db        '                               3 ..... mechanika 720 KB DD 3 1/2"',13,10
         db        '                               4 ..... mechanika 1.44 MB HD 3 1/2"',13,10
         db        '                               5 ..... mechanika 2.88 MB QD 3 1/2"',13,10
         db        '$'

DiskTxt  db        'Disk '
DiskTxtX db        'A: detekovan jako $'

DiskTxt0 db        'neplatny.',13,10,'$'
DiskTxt1 db        '360 KB DD 5 1/4".',13,10,'$'
DiskTxt2 db        '1.2 MB HD 5 1/4".',13,10,'$'
DiskTxt3 db        '720 KB DD 3 1/2".',13,10,'$'
DiskTxt4 db        '1.44 MB HD 3 1/2".',13,10,'$'
DiskTxt5 db        '2.88 MB QD 3 1/2".',13,10,'$'

Code     ENDS
         END       Start
