
; 
;
;                                XFLOP.ASM
;                          (c) Miroslav Nmeek
;                   Ovlada rozench formt disket.
;
; Tento program lze po pekladu spustit jako program typu COM nebo jej umstit
; jako BOOT sektor diskety (je nutno ovem pepsat zhlav parametr diskety).
; Lze jej t zalenit do zdrojovho textu programu - v tom ppad se uvede:
;
; NOCOM   EQU       1                        ; pznak pro peklad jako INCLUDE
; INCLUDE XFLOP.ASM                          ; vnoen souboru XFLOP.ASM
;
; Jako program COM se program pelo pomoc pkaz:
;
;  TASM XFLOP
;  TLINK XFLOP,XFLOP.COM /t
;
; Vsledn program XFLOP.COM mus mt po pekladu velikost 512 bajt !
; Program XFLOP.COM lze spustit se zadnm parametru "1" nebo "2".
;
; Pozn.: Antivirov kontrola BIOS kontroluje BOOT sektor, jestli se neprovd
;        modifikace adresy DS:[413h] (velikost pamti v KB), proto je zde
;        tato operace skryt adresovnm s SI.
;
; 


IFNDEF   NOCOM

Code     SEGMENT
         ASSUME    cs:Code,ds:Code
         ORG       100h

ENDIF

; -----------------------------------------------------------------------------
;        data BOOT sektoru (inicializan nastaveny parametry diskety 1.2 MB)
; -----------------------------------------------------------------------------

BootBeg  label     byte                     ; zatek BOOT sektoru

         jmp       BootInit                 ; start a inicializace programu

IFDEF    DEMO
BootOEM  db        'XFORM1D1'               ; identifikace
ELSE

IFDEF    SHARE
BootOEM  db        'XFORM1S1'               ; identifikace
ELSE
BootOEM  db        'XFORM1.1'               ; identifikace
ENDIF

ENDIF

BootBytS dw        512                      ; dlka sektoru
BootClst db        1                        ; poet sektor na alokan blok
BootRezS dw        1                        ; poet rezervovanch sektor
BootFATN db        2                        ; poet alok. tabulek FAT
BootRoot dw        224                      ; maximln poet poloek ROOT
BootSumS dw        80*15*2                  ; celkov poet sektor disku
BootMedD db        0f9h                     ; popisova mdia
BootFATS dw        7                        ; poet sektor na FAT
BootSekt dw        15                       ; poet sektor na stopu
BootSide dw        2                        ; poet stran disku
BootHidS dd        0                        ; skrytch sektor (2 nebo 4 bajty)
BootSumM dd        0                        ; celkem sektor (4 bajty)

BootDisk db        0                        ; disk (pracovn)
BootHead db        0                        ; hlava (pracovn)

Boot29   db        29h                      ; identifiktor
BootSerN dd        0                        ; sriov slo disku

BootLabl db        'NO NAME    '            ; nvt disku
BootLab0 label     byte                     ; adresa konce nvt disku
BootFATT db        'FAT12   '               ; typ FAT

; -----------------------------------------------------------------------------
;        text vzvy k instalaci
; Nepemisovat jinam - mus bt ped BootIntX, aby tam skonil registr SI !
; -----------------------------------------------------------------------------

BootTxt  db        13,10
         db        'Zvolte:',13,10
         db        ' [1] zvysene formaty disket',13,10
         db        ' [2] zamena A/B',13,10
         db        0

; -----------------------------------------------------------------------------
;        obsluha INT 13h - zmna disk
; -----------------------------------------------------------------------------

BootIntX PROC      FAR

; ------ test, zda to je disketa A: nebo B:

         cmp       dl,1                     ; maximln slo diskety
         ja        BootInt2
;         ja        BootExec                 ; pokraovn pvodn obsluhou

; ------ pro funkci 8 nen poteba nvrat

         cmp       ah,8                     ; funkce poskytnut parametr ?
         je        BootInt1                 ; nebude se provdt nvrat

; ------ obsluha poadovan funkce

         push      dx                       ; schova sla disku
         pushf
         push      cs
         call      near ptr BootInt1        ; obsluha poadovan funkce
         pop       dx                       ; nvrat pvodnho sla disku
         ret       2

; ------ zmna disketovch mechanik A: a B:

BootInt1:xor       dl,1                     ; zmna disketovch mechanik

BootIntX ENDP
                                          ;* pokrauje BootIntY !

; -----------------------------------------------------------------------------
;        obsluha INT 13h - zven formty disket
; -----------------------------------------------------------------------------

BootIntY PROC      FAR

; ------ kontrola, zda to je mechanika A: nebo B:

         cmp       dl,1                     ; maximln slo diskety
BootInt2:ja        BootExec                 ; pokraovn pvodn obsluhou

; ------ kontrola, zda je funkce 2 a 4 (ten, zpis, verifikace)

         cmp       ah,4
         ja        BootExec                 ; nen funkce 2 a 4
         cmp       ah,2
         jb        BootExec                 ; nen funkce 2 a 4

; ------ schova registr

         push      es
         push      cx
         push      bx
         push      ax

; ------ zven potu sektor na stopu

         mov       al,46                    ; nastav se na velk poet sektor
         call      BootIntS                 ; nastaven novho potu sektor
         mov       cs:[BootOldS],al         ; schova potu sektor na stopu

; ------ inicializace registr na data BIOS

         mov       bx,40h                   ; BX <- 40h
         mov       es,bx                    ; ES <- 40h

; ------ test, zda je mdium ji ureno

         add       bl,dl                    ; korekce na slo disku
         test      byte ptr es:[bx-40h+90h],10h ; je mdium ji ureno ?
         jnz       BootInt8                 ; je ji ureno

; ------ mdium ureno

         or        byte ptr es:[bx-40h+90h],10h ; te ji je ureno

; ------ test, zda je rychlost nastavena OK (nyn je ES=40h, BX=40h a 41h)

         mov       cx,200h                  ; CH <- stopa, CL <- sektor
BootInt3:inc       cx                       ; CL <- zven sla sektoru
         mov       ax,401h                  ; verifikace 1 sektoru
         push      bx                       ; schova offsetu v BIOS
         push      cx                       ; schova stopy a sektoru
         push      dx                       ; schova disku a strany
         pushf                              ; simulace instrukce INT ...
         push      cs                       ; simulace instrukce CALL FAR ...
         call      BootExec                 ; verifikace sektoru
         pop       dx                       ; nvrat disku a strany
         pop       cx                       ; nvrat stopy a sektoru
         pop       bx                       ; nvrat offsety v BIOS
         jnc       Bootint8                 ; rychlost detekovna OK

; ------ chyba vmny mdia nebo disk nepipraven - okamit ukonen

         cmp       ah,6
         je        BootInt9                 ; vmna diskety
         or        ah,ah                    ; chyba 80h ?
         js        BootInt9                 ; mechanika nepipravena

; ------ zven rychlosti (cyklus 500 > 300 > 250 > 1000)

         add       byte ptr es:[bx-40h+90h],40h ; zven rychlosti
         test      cl,3                     ; je sektor 4 nebo 8 ?
         jnz       BootInt3                 ; nen sektor 4 ani 8

; ------ zmna krokovn (pi sektorech 4 a 8) (dvojit a jednoduch)
; Krokovn se mn a po zmnch rychlosti, aby pod nevystavovala mechanika

         xor       byte ptr es:[bx-40h+90h],20h ; zmna krokovn
         cmp       cl,8                     ; je ji maximum test ?
         jb        BootInt3                 ; nen jet maximum test

; ------ mdium neureno

         and       byte ptr es:[bx-40h+90h],not 10h ; mdium neureno

; ------ nvrat registr

BootInt8:pop       ax
         pop       bx
         pop       cx
         pop       es

; ------ pokraovn pvodn obsluhou

         pushf                              ; simulace instrukce INT ...
         push      cs                       ; simulace instrukce CALL FAR ...
         call      BootExec                 ; pvodn funkce

         push      ax
         mov       al,cs:[BootOldS]         ; pvodn poet sektor
         call      BootIntS                 ; nvrat potu sektor
         pop       ax
         ret       2

; ------ pokraovn pvodn obsluhou

BootExec:db        0eah                     ; instrukce JMP FAR
BootOld  dd        0                        ; pvodn adresa INT 13h

; ------ nvrat pi chyb 6 (vmna diskety) a 80h (nen vloena disketa)

BootInt9:and       byte ptr es:[bx-40h+90h],not 10h ; mdium neureno
         pop       bx                       ; ponech se reg. AX - chybov kd
         pop       bx
         pop       cx
         pop       es
         stc                                ; pznak chyby
         ret       2                        ; tento nvrat pouv i BIOS

BootIntY ENDP

BootOldS db        46                       ; uschovan poet sektor na stopu

; -----------------------------------------------------------------------------
;        nastaven potu sektor na stopu na AL -> vrac v AL pvodn obsah
; -----------------------------------------------------------------------------

BootIntS PROC      NEAR

         push      bx
         push      es

         mov       bx,0                     ; BX <- 0
         mov       es,bx                    ; ES <- 0
         les       bx,es:[bx+4*1eh]         ; adresa tabulky INT 1Eh
         xchg      al,es:[bx+4]             ; zmna potu sektor na stopu

         pop       es
         pop       bx
         ret

BootIntS ENDP

BootREnd label     byte                     ; konec rezidentnho modulu

; -----------------------------------------------------------------------------
;        start a inicializace programu
; -----------------------------------------------------------------------------

; ------ rozlien, zda je BOOT nebo COM

BootInit:mov       ax,cs                    ; AX <- CS
         or        ax,ax                    ; je to BOOT sektor ?
         jnz       BootInC                  ; je jako COM

; -----------------------------------------------------------------------------
;        instalace jako BOOT
;   Nyn je cel zavad na adrese 0:7C00h !!!
; -----------------------------------------------------------------------------

; ------ pedefinovn zsobnku (ped BOOT sektor)

         mov       si,413h                  ; offset velikosti pamti v KB
         mov       ds,ax                    ; DS <- 0
         mov       ss,ax                    ; SS <- 0
         mov       sp,7c00h                 ; offset zsobnku ped programem

; ------ adresa rezidentu (nepouvat mov ax,ds:[413h] - antiviry !) -> ES:DI

         dec       word ptr ds:[si]         ; snen velikosti pamti o 1 KB
         mov       di,ds:[si]               ; aktuln velikost pamti v KB
         mov       cl,6                     ; CL <- poet rotac pro pepoet
         shl       di,cl                    ; pepoet KB na odstavce
         mov       es,di                    ; ES <- segment rezidentu
         xor       di,di                    ; DI <- offset rezidentu

; ------ volba operace (zde je AL = 0 a DS=CS)

         call      BootInst                 ; volba instalace

; ------ nvrat velikosti pamti pi peruen (je nastaven CY, CS=0)

         adc       word ptr cs:[413h],0     ; pi peruen CY nvrat pamti

; ------ pokraovn v zavdn systmu

         int       19h
         hlt                                ; to jen pro jistotu, ale nen teba

; -----------------------------------------------------------------------------
;        instalace jako COM
; -----------------------------------------------------------------------------

; ------ adresa k pesunu (ES=CS, DS=CS !)

BootInC: mov       di,5ch                   ; adresa k pesunu

; ------ nalezen znaku v pkazovm dku

         mov       si,81h                   ; buffer pkazovho dku
         cld
BootInC2:lodsb                              ; naten znaku z pkazovho dku
         cmp       al," "                   ; je oddlovac mezera ?
         je        BootInC2                 ; oddlovac mezera - dal znak

; ------ volba operace

         call      BootInst                 ; volba instalace
         jnc       BootInC4                 ; instaluje se OK
         int       20h                      ; peruen programu

; ------ uvolnn segmentu prosted (DS=CS !)

BootInC4:mov       es,ds:[2ch]              ; segment prosted
         mov       ah,49h
         int       21h                      ; uvolnn segmentu prosted

; ------ instalace programu do pamti (DI=adresa konce rezidentu !)

         mov       dx,di                    ; konec programu
         int       27h                      ; instalace

; -----------------------------------------------------------------------------
; instalace obsluhy INT 13h (AL=znak, ES:DI=zatek rezidentu) -> CY=peruen
; -----------------------------------------------------------------------------
; VSTUP: AL=znak z pkazovho dku (pro BOOT sektor je AL=0)
;        ES:DI=adresa k uloen rezidentn obsluhy
;        DS=CS
; VSTUP: ES:DI=adresa konce penesenho rezidentu
;         DS=CS (pouze pro NC = operace OK)
;         CY=peruen instalace
; -----------------------------------------------------------------------------

BootInst PROC      NEAR

; ------ zobrazen textu

         push      ax                       ; schova znaku z pkaz. dku

         call      BootIns2                 ; nvratov adresa do zsobnku
BootIns2:pop       si                       ; SI <- adresa BootIns2
         sub       si,offset(BootIns2-BootTxt) ; adresa textu
BootIns4:cld
         lodsb
         or        al,al
         jz        BootIns6
         push      si                       ; (instrukci lze asi zruit)
         mov       ah,0eh
         mov       bx,7
         int       10h
         pop       si                       ; (instrukci lze asi zruit)
         jmp       short BootIns4

BootIns6:pop       ax                       ; znak z pkazovho dku

; ------ ekn na stisk klvesy (SI=adresa zatku INT 13h)

         cmp       al," "                   ; byl zadn njak znak ?
         ja        BootIns7                 ; byl zadn njak znak
         xor       ax,ax
         int       16h                      ; vstup znaku z klvesnice

; ------ segment vektor peruen

BootIns7:xor       bx,bx
         mov       ds,bx                    ; DS <- 0

; ------ test, zda bude instalace volbou "1" nebo "2"

         cmp       al,"2"+1
         cmc
         jc        BootIns9                 ; nesprvn volba
         cmp       al,"1"
         jb        BootIns9                 ; nesprvn volba

; ------ schova pvodn adresy INT 13h (tady je ZY=je instalace 1 !)

         mov       ax,ds:[bx+4*13h]         ; offset adresy INT 13h
         mov       word ptr cs:[si+BootOld-BootIntX],ax ; schova offsetu adresy
         mov       ax,ds:[bx+4*13h+2]       ; segment adresy INT 13h
         mov       word ptr cs:[si+BootOld-BootIntX+2],ax ; schova segmentu

; ------ instalace nov obsluhy INT 13h

         mov       ds:[bx+4*13h],di         ; offset rezidentu
         mov       ds:[bx+4*13h+2],es       ; segment rezidentu

; ------ instalace pro volby "1" - rozen formty

         mov       cx,offset(BootREnd-BootIntX) ; dlka dat k pesunu
         ja        BootIns8                 ; byla volba "2" - zmna mechanik
         add       si,offset(BootIntY-BootIntX)
         mov       cl,offset(BootREnd-BootIntY)

; ------ penesen rezidentn sti (zde je NC !)

BootIns8:cld
         push      cs
         pop       ds                       ; DS <- CS
         rep       movsb                    ; posun programu dol
BootIns9:ret

BootInst ENDP

;         db        0 dup(0)                ; doplnk na 512 B

BootIdnt dw        0aa55h                   ; pznak BOOT sektoru

BootEnd  label     byte                     ; konec BOOT sektoru


IFNDEF   NOCOM

Code     ENDS
                                          ;* pi pekladu jako COM hls
                                          ;* varovn, e je oteven podmnka
                                          ;* - to se mus ignorovat
         END       BootBeg
ENDIF
