
; Nvratov kdy (zatm jet neudlno !!!)
;       0 = nen nainstalovn
;       1 = je v klidu
;       2 = ek na vloen diskety
;       3 = formtuje disketu
;       4 = ek na vyjmut diskety - bez chyby
;       5 = ek na vyjmut diskety - s chybou

PUBLIC   TESTBOD                            ; testovac bod pro DEBUGGER

DENXFLOP EQU       4                        ; den souboru XFLOP.COM
MESXFLOP EQU       4                        ; msc souboru XFLOP.COM

DEMOTRK  EQU       50                       ; dlic stopa pro DEMO a SHAREWARE

; -----------------------------------------------------------------------------
; Pepnae pekladu:
;
;DEMO     EQU       1                        ; demo verze
;SHARE    EQU       1                        ; shareware verze
;DEBUG    EQU       1                        ; ladic reim
; -----------------------------------------------------------------------------

KLIC1    EQU       'XF'                     ; identifiktor 1 (AX)
KLIC2    EQU       'OR'                     ; identifiktor 2 (BX)
KLIC3    EQU       'M?'                     ; identifiktor 3 (CX)
KLIC4    EQU       'OK'                     ; identifiktor 4 (vstup v AX)

bit0     EQU       1
bit1     EQU       2
bit2     EQU       4
bit3     EQU       8
bit4     EQU       10h
bit5     EQU       20h
bit6     EQU       40h
bit7     EQU       80h
HI       EQU       256

; -----------------------------------------------------------------------------
;
; Men rozsahu GAP mezery:
;  ....... mechanika 5 otek/sekundu
;  8 sektor: I1, G6 a G236, O250
;  9 sektor: I1, G6 a G135, O250
; 10 sektor: I1, G6 a G56, O250
; --------------------------------
; 11 sektor: I1, G6 a G118, O300
; 12 sektor: I1, G6 a G55, O300
; 13 sektor: I2, G1 a G3, O300
; --------------------------------
; 18 sektor: I1, G6 a G127, O500
; 19 sektor: I1, G6 a G88, O500
; 20 sektor: I1, G6 a G53, O500
; 21 sektor: I1 a I2, G6 a G22, O500
;
;  ........ mechanika 6 otek/sekundu (O250: 5208,
;  7 sektor:     max. G198, O250 (obsazeno 5206)
;  8 sektor:     max. G88, O250 (obsazeno 5208)
;  9 sektor:     max. G5, O250 (obsazeno 5206)
; -----------------------------------------------------------------------------
; Z maximln hodnoty GAP vypotena pevn st sektoru na hlaviku 62 bajt !!!!
; -----------------------------------------------------------------------------
; Vpoty obsazen sti stopy:
;
;    250000/8/5 = 6250
;  10*(512+62) + 9*56 = 6244
;   9*(512+62) + 8*135 = 6246
;   8*(512+62) + 7*236 = 6244
;
;    300000/8/5 = 7500
;  11*(512+62) + 10*118 = 7494
;  12*(512+62) + 11*55 = 7493
;  13*(512+62) + 12*3 = 7498
;
;    500000/8/5 = 12500
;  18*(512+62) +  17*127 = 12491
;  19*(512+62) + 18*88 = 12490
;  20*(512+62) + 19*53 = 12487
;  21*(512+62) + 20*22 = 12494
;
;   1000000/8/5 = 25000
; -----------------------------------------------------------------------------

TIMEOUT  EQU       2*18                     ; doba pro TIME-OUT (v 1/18 sekund)

MAXERR   EQU       20                       ; maximln poet blok chyb

 IFDEF   DEBUG
KORIG    EQU       0
 ELSE
KORIG    EQU       -(103h-5ch)              ; korekce adres programu
 ENDIF

; ------ typy mechanik

M360     EQU       1                        ; mechanika 360 KB
M120     EQU       2                        ; mechanika 1.2 MB
M720     EQU       3                        ; mechanika 720 KB
M144     EQU       4                        ; mechanika 1.44 MB
M288     EQU       5                        ; mechanika 2.88 MB

DMAW     EQU       4ah                      ; povel pro zpis DMA
DMAR     EQU       46h                      ; povel pro ten DMA
DMAV     EQU       42h                      ; povel pro verifikaci DMA

MAXSEKT  EQU       128                      ; maximln poet sektor
                                            ;  128*512 = 65536 (max. DMA)
                                            ;  128*4 = 512 (max. poloek)
Code     SEGMENT
         ASSUME    cs:Code,ds:Code
         ORG       100h

Start:   jmp       Init

RezBeg   label     byte                     ; zatek rezidentn sti

; -----------------------------------------------------------------------------
;        parametry rezidentni obsluhy
; -----------------------------------------------------------------------------

; ------ uschovan adresy peruen

Old08    dd        0                        ; pvodn adresa INT 08h
Old0e    dd        0                        ; pvodn adresa INT 0Eh
Old40    dd        0                        ; pvodn adresa INT 40h

LastErr  db        0                        ; posledn chyba
                                            ;   0 = OK
                                            ;   1 = TIME-OUT od INT 0Eh
                                            ;   2 = TIME-OUT pjmu stavu od adie
                                            ;   3 = TIME-OUT vysln povelu na adi
                                            ;   4 = pekroen poet bajt stavu (7) od adie
                                            ;   5 = chyba vystaven hlav (nen stopa 0)
                                            ;   6 = mechanika nepipravena
                                            ;   7 = nenalezena stopa 0
                                            ;   8 = sektor nenalezen
                                            ;   9 = disketa chrnna proti zpisu
                                            ;  (10 = peteen penosu DMA)
                                            ;  11 = chyba dat sektoru (CRC)
                                            ;  12 = nesouhlas hlavika sektoru
                                            ;  13 = chyba resetovn adie

                                            ; 255 = jin chyba (chyba operace)

DatBeg   label     byte                     ; zatek dat k penesen

; ------ parametry pro operaci

RParam   db        0                        ; rezidentn parametry 1
                                            ;   bit 0: 1=pout zvukovou indikaci
                                            ;   bit 1: 1=formtovn vce disket
                                            ;   bit 2: 1=neprovdt verifikaci
                                            ;   bit 3: 1=formtovn aktivn
                                            ;   bit 4: 1=probh formtovn diskety
                                            ;   bit 5: 1=poadavek peruen formtovn
                                            ;   bit 6: 1=dvoj krokovn diskety
                                            ;   bit 7: 1=asovn portem 61h

RParam2  db        0                        ; rezidentn parametry 2
                                            ;   bit 0: 1=aktivn intern obsluha
                                            ;   bit 1: 1=vadn BOOT
                                            ;   bit 2: 1=vadn FAT1
                                            ;   bit 3: 1=vadn FAT2
                                            ;   bit 4: 1=vadn ROOT
                                            ;   bit 5: 1=byla chyba v datech
                                            ;   bit 6: 1=zkaz peruen operace
                                            ;   bit 7: 1=pilo peruen INT 0Eh

RParam3  db        0                        ; rezidentn parametry 3
                                            ;   bit 0: 1=uloit LABEL
                                            ;   bit 1: 1=uloit soubor XFLOP.COM
                                            ;   bit 2: 1=nucen vmna diskety
                                            ;   bit 3: 1=LABEL se inkrementuje

LabEnd   dw        offset BootLabl+KORIG    ; adresa posledn slice sla LABEL
LabTime  dw        1                        ; as pro LABEL
LabDate  dw        1                        ; datum pro LABEL

; ------ poloka XFLOP.COM

XFlopNam db        'XFLOP   COM'            ; jmno souboru XFLOP.COM
XFlopTim dw        1*bit3*HI + 0*bit5 + 0   ; as souboru XFLOP.COM
XFlopDat dw        (1995-1980)*bit1*HI + MESXFLOP*bit5 + DENXFLOP ; datum souboru XFLOP.COM
XFlopBlk dw        2                        ; alokan blok s programem XFLOP.COM
         dw        512                      ; velikost programu XFLOP.COM
XFlopAbs dw        -1                       ; absolutn sektor s XFLOP.COM


Disk     db        -1                       ; slo disku (0=A:, 1=B:)
DiskMask db        bit0                     ; maska sla disku (bit0 nebo bit1)


TypDisk  db        1                        ; typ disku
                                            ;   1 = 360 KB (5 1/4")
                                            ;   2 = 1.2 M (5 1/4")
                                            ;   3 = 720 K (3 1/2")
                                            ;   4 = 1.44 M (3 1/2")
                                            ;   5 = 2.88 M (3 1/2")

TestWrit dw        0                        ; poet testovacch zpis
Rate     db        -1                       ; penosov rychlost 0 a 3
                                            ;    0 = 500 Kb/s
                                            ;    1 = 300 Kb/s
                                            ;    2 = 250 Kb/s
                                            ;    3 = 1000 Kb/s

; ------ fyzick parametry diskety

IFDEF    DEMO
DemoStop db        DEMOTRK                  ; DEMO stopa
ENDIF

JmenKap  dw        -1                       ; jmenovit kapacita (v KB)
Stop     db        -1                       ; poet stop
         db        0                        ; doplnk na slovo

Sektoru  db        -1                       ; poet sektor na stopu
         db        0                        ; doplnk na slovo

Stran    db        -1                       ; poet stran
         db        0                        ; doplnk na slovo

SlideX   db        -1                       ; odsazovn mezi stranami
SlideY   db        -1                       ; odsazovn mezi stopami
Interl   db        -1                       ; prokldn sektor
Gap      dw        -1                       ; mezisektorov mezera

; ------ logick parametry diskety

Cluster  db        -1                       ; poet sektor na alokan blok
         db        0                        ; doplnk na slovo

Root     dw        -1                       ; poet sektor na ROOT
MediaB   db        0f0h                     ; bajt popisovae mdia
FillCh   db        0f6h                     ; plnc bajt dat diskety
DatSekt  dw        0                        ; poten datov sektor (absolutn)

; ------  odvozen parametry

CelkSekt dw        0                        ; celkov poet sektor diskety
FATSekt  dw        1                        ; poet sektor na FAT
NumClust dw        0                        ; poet datovch alokanch blok
Nevyuzit db        0                        ; poet nevyuitch sektor

DatEnd   label     byte                     ; konec dat k penesen

; ------ aktuln ukazatele operace

AbsSekt  dw        0                        ; absol. slo sektoru potku stopy
NStrana  db        -1                       ; zpracovan strana
AStrana  db        0                        ; aktivn strana
NStopa   db        -1                       ; zpracovan stopa
AStopa   db        0                        ; aktivn stopa (formtovan)
AOper    db        0                        ; aktivn operace (pro indikaci)
                                            ;    0=je v klidu (nic neformtuje)
                                            ;    1=ek na vloen diskety
                                            ;    2=ek na vyjmut diskety
                                            ;    3=formtovn
                                            ;    4=verifikace
                                            ;    5=zpis
                                            ;    6=ten
                                            ;    7=DEMO ukazatel operace

; ------ uschovan ukazatel zsobnku

RegSP    dw        0                        ; SP
RegSS    dw        0                        ; SS

; ------ buffery

BuffStat db        7 dup(0)                 ; buffer stavu od adie

BuffSekt dw        Buffer+KORIG             ; adresa bufferu sektoru
Zasob    dw        Buffer+2*512-2+KORIG     ; adresa zsobnku (konec)

; ------ mapa chyb
; Struktura:
;        0: (1) poet nsledujcch vadnch blok (0=konec tabulky)
;        1: (2) slo potenho vadnho bloku
ErrMEnd  dw        ErrMap+KORIG             ; ukldac adresa do tabulky
ErrMap   db        MAXERR*3 dup(0)          ; mapa chyb
         db        0                        ; pznak konce tabulky

ErrSekt  db        (MAXSEKT+7)/8 dup(0)     ; mapa vadnch sektor
ErrSekt0 label     byte

IdentBeg label     byte                     ; zatek k testu identifikace
;
; -----------------------------------------------------------------------------
;        obsluha INT 13h
; -----------------------------------------------------------------------------

Int13    PROC      FAR

; ------ test instalace programu

         cmp       ax,KLIC1                 ; identifiktor v AX
         jne       Int131
         cmp       bx,KLIC2                 ; identifiktor v BX
         jne       Int131
         cmp       cx,KLIC3                 ; identifiktor v CX
         jne       Int131
         mov       ax,KLIC4                 ; potvrzen instalace v pamti
         push      cs
         pop       es                       ; ES <- segment programu
         jmp       short Int133

; ------ blokovn obsluhy, je-li aktivn rezidentn obsluha

Int131:  or        dl,dl                    ; je disketa ?
         js        Int138                   ; nen disketa
         test      byte ptr cs:[RParam+KORIG],bit3 ; je formtovn aktivn ?
         jz        Int134                   ; nen aktivn
         cmp       ah,8
         je        Int138                   ; funkce 8 je povolen (parametry)
         cmp       ah,16h                   ; test vmny disku
         mov       ah,80h                   ; pznak nepipravenosti
         jne       Int133                   ; nen vymnn disketa
Int132:  mov       ah,6                     ; chyba - disketa vymnna
Int133:  stc
         sti
         ret       2

; ------ vnucen vmna diskety

Int134:  cmp       dl,cs:[Disk+KORIG]       ; je to aktivn disk ?
         jne       Int138                   ; nen to aktivn disk
         test      byte ptr cs:[RParam3+KORIG],bit2 ; je nucen vmna disku ?
         jz        Int138                   ; nen nucen vmna disku

         cmp       ah,16h
         je        Int132                   ; disketa vymnna
         cmp       ah,2
         jb        Int138
         cmp       ah,5
         jae       Int138
                                          ;* je operace ten, zpis, verifikace
Int135:  and       byte ptr cs:[RParam3+KORIG],not bit2 ; zruen nucen vmny
         jmp       short Int132             ; disketa vymnna

Int138:  jmp       BootIntY                 ; obsluha rozench formt

Int13    ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 08h
; -----------------------------------------------------------------------------

Int08    PROC      FAR

; ------ test, zda je aktivn vlastn formtovn

         test      byte ptr cs:[RParam+KORIG],bit3 ; je formtovn aktivn ?
         jz        Int089                   ; formtovn nen aktivn

; ------ nulovn tae BIOS pro vypnut motoru

         push      ax
         push      ds

         xor       ax,ax
         mov       ds,ax
         mov       byte ptr ds:[440h],38    ; ta pro vypnut motoru BIOS

         pop       ds
         pop       ax

         pushf
         call      dword ptr cs:[Old08+KORIG] ; pvodn obsluha INT 08h
         call      FlipInt                  ; pepnn proces
         iret

Int089:  jmp       dword ptr cs:[Old08+KORIG] ; pvodn obsluha INT 08h

Int08    ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 40h
; -----------------------------------------------------------------------------

Int40    PROC      FAR

         or        dl,dl                    ; je disketa ?
         js        Int142                   ; nen disketa
         test      byte ptr cs:[RParam+KORIG],bit3 ; je formtovn aktivn ?
         jz        Int142                   ; nen aktivn
         mov       ah,80h                   ; pznak nepipravenosti
         stc
         sti
         ret       2

Int142:  jmp       dword ptr cs:[Old40+KORIG] ; pvodn obsluha INT 40h

Int40    ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 0Eh
; -----------------------------------------------------------------------------

Int0E    PROC      FAR

         push      ax
         or        byte ptr cs:[RParam2+KORIG],bit7 ; pznak peruen INT 0Eh
         mov       al,66h
         out       [20h],al                 ; uvolnn adie peruen
         pop       ax
         call      FlipInt                  ; pepnn proces
         iret

Int0E    ENDP

; -----------------------------------------------------------------------------
;        zmna registr a obsluhy (nemnit poad registr v zsobnku !)
; -----------------------------------------------------------------------------

; ------ pepnut na intern obsluhu z obsluhy peruen

FlipInt: pushf
         test      byte ptr cs:[RParam2+KORIG],bit0 ; je intern obsluha ?
         jnz       FlipFlp9                 ; je ji intern obsluha

; ------ test, zda neprobh njak obsluha peruen

         cli
         push      ax
         mov       al,bit3+bit1+bit0        ; povel pro ten registru obsluh
         out       [20h],al                 ; vysln povelu
         jmp       short $+2
         jmp       short $+2                ; mal prodleva
         in        al,[20h]                 ; ten registru obsluh peruen
         or        al,al                    ; probh njak obsluha ?
         pop       ax
         jnz       FlipFlp9                 ; probh njak obsluha - zkaz

         popf

FlipFlop PROC      NEAR

; ------ schova registr do starho zsobnku

         pushf
         cli
         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp
         push      ds
         push      es

; ------ zmna zsobnk

         mov       ax,ss
         xchg      ax,cs:[RegSS+KORIG]
         mov       ss,ax
         xchg      sp,cs:[RegSP+KORIG]
         xor       byte ptr cs:[RParam2+KORIG],bit0 ; zmna pznaku obsluhy

; ------ nvrat registr z novho zsobnku

         pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
FlipFlp9:popf
         ret

FlipFlop ENDP

; -----------------------------------------------------------------------------
;        start operace formtovn (dodrovno DS=ES=CS !)
; -----------------------------------------------------------------------------
;
; ------ instalace obsluhy INT 0Eh

FStart:  call      Inst0E                   ; instalace obsluhy INT 0Eh
         and       byte ptr ds:[RParam2+KORIG],not bit6 ; nen zkaz peruen

; ------ ekn na vloen nov diskety

         call      Reset                    ; resetovn disku
         call      WaitIn                   ; ekn na vloen nov diskety
         jnc       FStart1
         jmp       FStart7                  ; peruen formtovn

; ------ start formtovn jedn diskety - pprava ukazatel

FStart1: or        byte ptr ds:[RParam+KORIG],bit4 ; pznak formtovn diskety
         mov       byte ptr ds:[LastErr+KORIG],0 ; nen dn chyba
         and       byte ptr ds:[RParam2+KORIG],not bit1+bit2+bit3+bit4+bit5 ; nulovn chyb
         mov       byte ptr ds:[AStopa+KORIG],0 ; aktivn stopa
         mov       word ptr ds:[AbsSekt+KORIG],0 ; ukazatel absolutnho sla sektoru
         mov       byte ptr ds:[NStopa+KORIG],-1 ; posledn zformtovan stopa
         mov       byte ptr ds:[NStrana+KORIG],-1 ; posledn zformtovan strana
         or        byte ptr ds:[RParam3+KORIG],bit2 ; nucen vmna diskety

; ------ inkrementace jmenovky a sriovho sla

         test      byte ptr ds:[RParam3+KORIG],bit3 ; inkrementuje se LABEL ?
         jz        FStrt12                  ; neinkrementuje se
         call      LabInc                   ; inkrementace jmenovky a sr. sla
         and       byte ptr ds:[RParam3+KORIG],not bit3 ; LABEL se neinkrementuje

; ------ vynulovn tabulky vadnch blok (DS=ES !)

FStrt12: mov       di,offset ErrMap+KORIG   ; mapa vadnch blok
         mov       ds:[ErrMEnd+KORIG],di    ; ukazatel tabulky
         xor       ax,ax                    ; AX <- 0
         mov       cx,MAXERR*3              ; velikost mapy
         cld
         rep       stosb                    ; vymazn mapy vadnch blok

; ------ rozbh motoru

         call      ZapDisk                  ; zapnut disku
         mov       cx,18
         call      Cekej                    ; prodleva na rozbh motoru
         call      Reset                    ; resetovn disku

; ------ test, zda je peruen formtovn

         call      TstBreak                 ; je peruen ?
         jc        FStart5                  ; je peruen formtovn

; ------ nastaven aktivn stopy

FStart2: mov       byte ptr ds:[AStrana+KORIG],0 ; aktivn strana
         call      Seek                     ; vystaven na aktivn stopu

; ------ test, zda byla disketa vyjmuta

FStart3: call      TestXchg                 ; test vmny diskety
         jc        FStart5                  ; disketa byla vyjmuta

; ------ zformtovn jedn stopy (i se zpisy dat)

         call      FForm                    ; zformtovn stopy

; ------ test, zda je disketa chrnna proti zpisu

         cmp       byte ptr ds:[LastErr+KORIG],9 ; je ochrana proti zpisu ?
         je        FStart5                  ; disketa chrnna proti zpisu

; ------ test, zda je peruen formtovn

         call      TstBreak                 ; je peruen ?
         jc        FStart4                  ; je peruen formtovn

; ------ ukazatel zpracovanch stop

         mov       al,ds:[AStopa+KORIG]     ; aktivn stopa
         mov       ds:[NStopa+KORIG],al     ; zpracovan stopa
         mov       al,ds:[AStrana+KORIG]    ; aktivn strana
         mov       ds:[NStrana+KORIG],al    ; zpracovan strana

; ------ posun absolutnho sla sektoru

         mov       ax,word ptr ds:[Sektoru+KORIG] ; poet sektor na stopu
         add       ds:[AbsSekt+KORIG],ax    ; posun sla sektoru

; ------ zven sla strany

         inc       byte ptr ds:[AStrana+KORIG] ; zven aktivn strany
         mov       al,ds:[AStrana+KORIG]    ; aktivn strana
         cmp       al,ds:[Stran+KORIG]      ; jsou ji vechny strany ?
         jb        FStart3                  ; nejsou vechny - dal strana

; ------ zven sla stopy

         inc       byte ptr ds:[AStopa+KORIG] ; zven aktivn stopy
         mov       al,ds:[AStopa+KORIG]     ; aktivn stopa
         cmp       al,ds:[Stop+KORIG]       ; jsou ji vechny stopy ?
         jb        FStart2                  ; nejsou vechny - dal stopa
         or        byte ptr ds:[RParam3+KORIG],bit3 ; LABEL se inkrementuje

; ------ zpis chyb FAT 1 a FAT 2 (+ zpis sla bloku XFLOP.COM do FAT)

FStart4: or        byte ptr ds:[RParam2+KORIG],bit6 ; zkaz peruen operace
         call      TestXchg                 ; byla disketa vyjmuta ?
         jc        FStart5                  ; byla vyjmuta
         mov       byte ptr ds:[AOper+KORIG],0 ; aktivn operace - nic se nedje
         mov       ax,1                     ; absolutn sektor pro FAT1
         call      WritErr                  ; zpis tabulky chyb FAT 1
         call      TestXchg                 ; byla disketa vyjmuta ?
         jc        FStart5                  ; byla vyjmuta
         mov       ax,ds:[FATSekt+KORIG]    ; poet sektor na FAT
         inc       ax                       ; piten BOOT sektoru
         call      WritErr                  ; zpis tabulky chyb FAT 2
         and       byte ptr ds:[RParam2+KORIG],not bit6 ; konec zkazu peruen

; ------ konec formtovn jedn diskety

FStart5: mov       byte ptr ds:[AStopa+KORIG],0 ; aktivn stopa
         call      Seek                     ; vystaven hlav na zatek
         and       byte ptr ds:[RParam+KORIG],not bit4 ; konec formtovn diskety

; ------ ekn na vyjmut diskety z mechaniky

FStart6: cmp       byte ptr ds:[TypDisk+KORIG],M360 ; mechanika 360K
         je        FStart7                  ; nen podporovna vmna
         call      WaitOut                  ; ekn na vyjmut diskety z mechaniku

; ------ ukonen formtovn pi peruen nebo nen-li vc disket

FStart7: call      TstBreak                 ; je peruen ?
         jc        FStart76                 ; peruen operace
FStart74:test      byte ptr ds:[RParam+KORIG],bit1 ; je vce disket ?
         jnz       FStart8                  ; je vce disket
FStart76:and       byte ptr ds:[RParam+KORIG],not bit3+bit5 ; peruen formtovn

; ------ vypnut motor mechanik

FStart8: mov       byte ptr ds:[AOper+KORIG],0 ; je v klidu
         call      VypDisk                  ; vypnut disk
         call      DInst0E                  ; odinstalovn obsluhy INT 0Eh

; ------ nulovn tae pro vypnut motoru BIOS

         push      ax
         push      ds

         xor       ax,ax
         mov       ds,ax                    ; DS <- 0
         mov       byte ptr ds:[440h],38    ; ta pro vypnut motoru BIOS
         and       byte ptr ds:[43fh],not 0fh ; nulovn zapnut motor
         and       byte ptr ds:[43eh],not 0fh ; potebn rekalibrace
         and       word ptr ds:[490h],not bit4 + HI*bit4 ; mdium neznm

         pop       ds
         pop       ax

         call      FlipFlop                 ; rezidentn obsluha
         jmp       FStart                   ; pokraovn dal disketou

; -----------------------------------------------------------------------------
;        ekn na vloen diskety (CY=peruen)
; -----------------------------------------------------------------------------

WaitIn   PROC      NEAR

; ------ pznak, e se ek na vloen diskety

         mov       byte ptr ds:[AOper+KORIG],1 ; ek na vloen diskety
         mov       byte ptr ds:[AStopa+KORIG],0 ; aktivn stopa

; ------ test, zda je peruen formtovn

WaitIn2: call      TstBreak                 ; test peruen
         jc        WaitIn9                  ; je peruen formtovn

; ------ zapnut disku

         call      ZapDisk                  ; zapnut disku

; ------ mal prodleva (bliknut)

         mov       cx,2
         call      Cekej                    ; ekn

; ------ vystaven hlav (posun na jinou stopu)

         xor       byte ptr ds:[AStopa+KORIG],1 ; zmna stopy 0/1
         call      Seek                     ; vystaven hlav na novou stopu

; ------ test, zda je vloena disketa

         call      TestXchg                 ; test vmny diskety
         jnc       WaitIn9                  ; disketa je vloena (-> NC)

; ------ vypnut mechaniky

         call      VypDisk                  ; vypnut disku

; ------ prodleva (tma mezi bliknutmi)

         mov       cx,26
         call      Cekej                    ; prodleva
         jmp       short WaitIn2            ; znovu zapnut

WaitIn9: ret

WaitIn   ENDP

; -----------------------------------------------------------------------------
;        ekn na vyjmut diskety
; -----------------------------------------------------------------------------

WaitOut  PROC      NEAR

; ------ synchronizace na hodiny (aby prvn tn nebyl zkrcen)

         mov       cx,1
         call      Cekej                    ; synchronizace na hodiny

; ------ test, zda je poteba ekat na vyjmut diskety

         test      byte ptr ds:[RParam2+KORIG],bit1+bit2+bit3+bit4+bit5 ; chyba ?
         jnz       WaitOut2                 ; byla chyba - bude se hlsit
         test      byte ptr ds:[RParam+KORIG],bit0+bit1 ; indikace nebo vce disket ?
         jz        WaitIn9                  ; nen poteba ekat na vyjmut
WaitOut2:mov       byte ptr ds:[AOper+KORIG],2 ; ek na vyjmut diskety

; ------ test, zda je peruen operace

WaitOut3:call      TstBreak                 ; je peruen ?
         jc        WaitIn9                  ; je peruen

; ------ zapnut disku

         call      ZapDisk                  ; zapnut disku

; ------ prodleva pi zapnut (dlouh pi chyb, nen-li indikace)

         mov       ax,10                    ; krtk doba
         test      byte ptr ds:[RParam+KORIG],bit0 ; je zvukov indikace ?
         jnz       WaitOut4                 ; je zvukov indikace
         cmp       byte ptr ds:[LastErr+KORIG],9 ; je ochrana proti zpisu ?
         je        WaitOu32                 ; disketa chrnna proti zpisu
         test      byte ptr ds:[RParam2+KORIG],bit1+bit2+bit3+bit4+bit5 ; chyba ?
         jz        WaitOut4                 ; nebyla chyba
WaitOu32:mov       ax,600                   ; dlouh doba pi chyb
WaitOut4:call      WaitT                    ; prodleva (v 15 us)

; ------ test, zda byla disketa vyjmuta

         call      TestXchg                 ; byla disketa vyjmuta ?
         jc        WaitOut9                 ; byla vyjmuta

; ------ vypnut disku

         call      VypDisk                  ; vypnut disku

; ------ test, zda je zvukov signalizace

         test      byte ptr ds:[RParam+KORIG],bit0
         jz        WaitOut6                 ; nen zvukov indikace

; ------ ppnut pi zvukov signalizaci

         mov       bx,3500/5                ; vysok tn
         test      byte ptr ds:[RParam2+KORIG],bit1+bit2+bit3+bit4+bit5 ; chyba ?
         jnz       WaitOut5                 ; byla chyba - vysok tn
         cmp       byte ptr ds:[LastErr+KORIG],9 ; je ochrana proti zpisu ?
         je        WaitOut5                 ; disketa chrnna proti zpisu
         mov       bx,3500                  ; hlubok tn
WaitOut5:in        al,[61h]
         or        al,bit0+bit1
         out       [61h],al                 ; zapnut zvuku
         mov       al,0b6h
         out       [43h],al
         mov       al,bl
         out       [42h],al
         mov       al,bh
         out       [42h],al

; ------ prodleva pro znn zvuku

         mov       cx,1
         call      Cekej                    ; prodleva pro doznn tnu

; ------ vypnut zvuku

         in        al,[61h]
         and       al,not bit0+bit1
         out       [61h],al

; ------ test, zda je peruen operace

WaitOut6:call      TstBreak                 ; je peruen ?
         jc        WaitOut9                 ; je peruen

; ------ prodleva mezi ppnutmi (a bliknutmi)

         mov       cx,4                     ; rychl blikn a ppn
         cmp       byte ptr ds:[LastErr+KORIG],9 ; je ochrana proti zpisu ?
         je        WaitOut8                 ; disketa chrnna proti zpisu
         test      byte ptr ds:[RParam2+KORIG],bit1+bit2+bit3+bit4+bit5 ; chyba ?
         jnz       WaitOut8                 ; byla chyba
         mov       cx,20                    ; pomal blikn a ppn (nebyla chyba)
WaitOut8:call      Cekej                    ; prodleva
         jmp       WaitOut3                 ; dal ekn

WaitOut9:ret

WaitOut  ENDP

; -----------------------------------------------------------------------------
;        inkrementace jmenovky a sriovho sla
; -----------------------------------------------------------------------------

LabInc   PROC      NEAR

; ------ inkrementace sriovho sla

         add       word ptr ds:[BootSerN+KORIG],1
         adc       word ptr ds:[BootSerN+KORIG+2],0

; ------ inkrementace jmenovky

         test      byte ptr ds:[RParam3+KORIG],bit0 ; ukld se LABEL ?
         jz        LabInc9                  ; LABEL se neukld
         mov       si,ds:[LabEnd+KORIG]     ; adresa posledn slice
LabInc2: cmp       si,offset BootLabl+KORIG
         jbe       LabInc9                  ; nen voln pozice

         inc       byte ptr ds:[si]
         cmp       byte ptr ds:[si],"0"+1
         jb        LabInc6
         cmp       byte ptr ds:[si],"9"+1
         ja        LabInc6
         jb        LabInc9
         mov       byte ptr ds:[si],"0"
         dec       si
         jmp       short LabInc2

LabInc6: mov       byte ptr ds:[si],"1"
LabInc9: ret

LabInc   ENDP

; -----------------------------------------------------------------------------
;        zpis sektoru FAT s chybou (AX=absolutn sektor FAT) (ES=DS !)
; -----------------------------------------------------------------------------

WritErr  PROC      NEAR

; ------ pprava registr

         mov       ds:[AbsSekt+KORIG],ax    ; absolutn sektor FAT
         xor       bx,bx                    ; ukazatel sla sektoru FAT

; ------ schova registr

WritErr1:push      bx                       ; relativn sektor FAT

; ------ pepoet absolutnho sektoru na stopu, stranu a sektor

         mov       ax,ds:[AbsSekt+KORIG]    ; absolutn sektor
         xor       dx,dx                    ; DX <- 0
         div       word ptr ds:[Sektoru+KORIG] ; AX <- stopa, DX <- sektor
         inc       dx
         mov       bh,dl                    ; BH <- slo sektoru na stop
         div       byte ptr ds:[Stran+KORIG] ; AL <- vlec, AH <- strana
         mov       ds:[AStrana+KORIG],ah    ; aktivn strana
         mov       ds:[AStopa+KORIG],al     ; aktivn stopa

; ------ vynulovn bufferu sektoru

         call      NulSekt                  ; vynulovn sektoru
         mov       bp,di                    ; BP <- adresa konce bufferu
         mov       di,si                    ; DI <- zatek bufferu

; ------ ukazatel sla alokanho bloku -> AX

         mov       ah,bl                    ; AH <- slo sektoru FAT
         mov       al,0
         shl       ax,1                     ; offset FAT v bajtech
         shl       ax,1                     ; offset FAT v tetrdch
         xor       dx,dx
         mov       cx,3                     ; poet tetrd na blok
         div       cx                       ; vpoet bloku a tetrdy

; ------ pprava masky a adresy

         xor       si,si                    ; stada modifikace sektoru
         mov       cx,0ff7h                 ; maska pro tetrdu 0
         or        dx,dx                    ; je zarovnan poloka ?
         jz        WritErr2                 ; je zarovnan poloka
         dec       di                       ; posun adresy
         cmp       dl,2                     ; je tetrda 2 ?
         je        WritErr2                 ; je tetrda 2
         mov       cx,0ff70h                ; maska pro tetrdu 1

; ------ alokan blok 0

WritErr2:or        ax,ax                    ; je alokan blok 0 ?
         jnz       WritErr3                 ; nen alokan blok 0
         push      ax
         mov       al,ds:[MediaB+KORIG]     ; popisova mdia
         mov       ah,0fh
         or        ds:[di],ax
         pop       ax
         jmp       short WritErr6

; ------ alokan blok 1

WritErr3:cmp       ax,1
         jne       WritErr4
         or        ds:[di],0fff0h
         jmp       short WritErr6

; ------ alokan blok souboru XFLOP.COM

WritErr4:cmp       ax,ds:[XFlopBlk+KORIG]   ; alokan blok s XFLOP.COM
         jne       WritErr5
         test      byte ptr ds:[RParam3+KORIG],bit1 ; zapisuje se XFLOP.COM ?
         jz        WritErr5                 ; nezapisuje se

         push      cx
         cmp       cl,0f7h
         jne       WritEr42
         mov       cl,0ffh
WritEr42:cmp       cl,70h
         jne       WritEr44
         mov       cl,0f0h
WritEr44:or        ds:[di],cx               ; pznak konce souboru
         or        si,cx                    ; pznak modifikace sektoru
         pop       cx
         jmp       short WritErr6

; ------ nalezen alokanho bloku v tabulce

WritErr5:push      si

         mov       si,offset ErrMap+KORIG-3 ; tabulka chyb
WritEr52:add       si,3
         cmp       byte ptr ds:[si],0       ; je konec tabulky chyb ?
         je        WritEr54                 ; je konec tabulky chyb
         cmp       ax,ds:[si+1]             ; je blok ped intervalem ?
         jb        WritEr52                 ; blok je ped intervalem
         mov       dl,ds:[si]               ; poet blok
         mov       dh,0
         add       dx,ds:[si+1]             ; nsledujc blok za intervalem
         cmp       ax,dx                    ; je uvnit intervalu ?
         jae       WritEr52                 ; nen v intervalu

; ------ blok je vadn

         or        ds:[di],cx               ; nastaven bloku jako vadn
         pop       si
         or        si,cx                    ; pznak modifikace sektoru
         push      si

WritEr54:pop       si

; ------ zven alokanho bloku

WritErr6:inc       di                       ; zven ukldac adresy
         xor       cx,0ff7h XOR 0ff70h      ; zmna masky
         cmp       ch,0fh
         jne       WritEr62
         inc       di
WritEr62:inc       ax                       ; zven sla bloku
         cmp       di,bp                    ; je ji konec bufferu ?
         jb        WritErr2                 ; nen jet konec bufferu

; ------ zpis sektoru

         or        si,si                    ; je poteba nco uloit ?
         jz        WritErr8                 ; nen poteba nic ukldat

         call      Seek                     ; vystaven hlav
         mov       al,bh                    ; AL <- slo sektoru
         call      WritSekt                 ; zpis sektoru na disk

; ------ nvrat registr

WritErr8:pop       bx

; ------ dal sektor FAT

         inc       bx                       ; zven sla sektoru FAT
         inc       word ptr ds:[AbsSekt+KORIG] ; zven absolutnho sektoru
         cmp       bl,byte ptr ds:[FATSekt+KORIG] ; jsou ji vechny sektory FAT ?
         jae       WritErr9                 ; jsou ji vechny sektory FAT
         call      TestEnd                  ; je peruen operace ?
         jc        WritErr9                 ; je peruen operace
         jmp       WritErr1                 ; dal sektor FAT

WritErr9:ret

WritErr  ENDP

; -----------------------------------------------------------------------------
;        vynulovn sektoru (ES=DS !) -> DI=konec, SI=zatek
; -----------------------------------------------------------------------------

NulSekt  PROC      NEAR

         push      ax
         push      cx

         mov       di,ds:[BuffSekt+KORIG]   ; adresa bufferu
         mov       si,di                    ; SI <- zatek bufferu
         cld
         xor       ax,ax                    ; AX <- 0
         mov       cx,512/2
         rep       stosw                    ; vynulovn sektoru

         pop       cx
         pop       ax
         ret

NulSekt  ENDP

; -----------------------------------------------------------------------------
;        instalace obsluhy INT 0Eh (pvodn adresa INT 0Eh uchovna !!!)
; -----------------------------------------------------------------------------

Inst0E   PROC      NEAR

         cli
         push      ax
         push      ds

         xor       ax,ax
         mov       ds,ax
         mov       word ptr ds:[4*0eh],offset Int0E+KORIG ; offset obsluhy
         mov       ds:[4*0eh+2],cs          ; segment obsluhy

         pop       ds
         pop       ax
         and       byte ptr ds:[RParam2+KORIG],not bit7 ; nulovn pznaku peruen
         sti
         ret

Inst0E   ENDP

; -----------------------------------------------------------------------------
;        odinstalovn obsluhy INT 0Eh
; -----------------------------------------------------------------------------

DInst0E  PROC      NEAR

         cli
         push      ax
         push      ds

         xor       ax,ax
         mov       ds,ax
         mov       ax,word ptr cs:[Old0E+KORIG]
         mov       ds:[4*0eh],ax            ; offset pvodn obsluhy
         mov       ax,word ptr cs:[Old0E+KORIG+2]
         mov       ds:[4*0eh+2],ax          ; segment pvodn obsluhy

         pop       ds
         pop       ax
         sti
         ret

DInst0E  ENDP

; -----------------------------------------------------------------------------
;        zformtovn aktivn stopy s verifikac a zpisem dat
; -----------------------------------------------------------------------------
;
FForm    PROC      NEAR

IFDEF    DEMO
         mov       ah,ds:[AStopa+KORIG]     ; aktuln stopa
ENDIF

; ------ nulovn tabulky vadnch sektor

         mov       di,offset ErrSekt+KORIG
         mov       cx,offset(ErrSekt0-ErrSekt)
         mov       al,0
         cld
         rep       stosb                    ; vynulovn tabulky vadnch sektor

IFDEF    DEMO
; ------ DEMO simulace formtovn

         cmp       ah,ds:[DemoStop+KORIG]   ; je to DEMO stopa ?
         jb        FForm02                  ; nen jet DEMO stopa
         mov       byte ptr ds:[AOper+KORIG],7 ; aktivn operace - DEMO simulace
         mov       cx,4                     ; asi takov prodleva
         call      Cekej                    ; ekn po dobu simulace
         jmp       short FForm52            ; oznaen vadnch sektor
FForm02:
ENDIF
; ------ zformtovn aktivn stopy

         call      Format                   ; zformtovn aktivn stopy
         jc        FForm1                   ; chyba

; ------ prvn verifikace cel stopy

         test      byte ptr ds:[RParam+KORIG],bit2 ; provd se verifikace ?
         jnz       FForm2                   ; verifikace se neprovd
         call      Verify0                  ; verifikace cel stopy
         jnc       FForm2                   ; operace je OK

; ------ pi chyb resetovn disku

FForm1:  call      Reset                    ; pi chyb resetovn

; ------ druh pokus o zformtovn stopy

         call      Format                   ; zformtovn aktivn stopy
         jc        FForm5                   ; chyba

; ------ verifikace cel stopy

         call      Verify0                  ; verifikace cel stopy
         jc        FForm5                   ; stopa je vadn

; ------ stopa se zkontroluje testovacm zpisem (pro ujitn)

         mov       bp,ds:[TestWrit+KORIG]   ; poet testovacch zpis
         inc       bp
         inc       bp                       ; 2 testy navc
         jmp       short FForm22            ; testovac zpisy

; ------ bude oven stopy testovacm zpisem

FForm2:  mov       bp,ds:[TestWrit+KORIG]   ; poet testovacch zpis
FForm22: inc       bp                       ; pednastaven

; ------ pprava pro dal testovac zpis

FFOrm3:  dec       bp                       ; ta testovacch zpis
         jz        FForm7                   ; nen dal testovac zpis
         call      TestEnd                  ; je peruen operace ?
         jc        FFOrm9                   ; je peruen operace

; ------ testovac zpis dat na disketu

         call      WritTst                  ; testovac zpis na disketu
         jnc       FForm4                   ; zpis probhl OK
         call      Reset                    ; resetovn pi chyb
         call      WritTst                  ; testovac zpis na disketu
         jc        FForm5                   ; chyba

; ------ verifikace cel stopy

FForm4:  call      Verify0                  ; verifikace cel stopy
         jnc       FForm3                   ; stopa je OK
         call      Reset                    ; pi chyb resetovn
         call      Verify0                  ; jet jeden pokus pro oven
         jnc       FForm3                   ; stopa je OK

; ------ detekce vadnch sektor

FForm5:  call      VerifDet                 ; detekce vadnch sektor
         mov       bp,3                     ; zbvaj 3 zpisy
         call      WritTst                  ; testovac zpis na disketu
         call      VerifDet                 ; detekce vadnch sektor
         dec       bp                       ; dal zpis
         call      WritTst                  ; testovac zpis na disketu
         call      VerifDet                 ; detekce vadnch sektor
         dec       bp                       ; posledn zpis
         call      WritTst                  ; testovac zpis na disketu
         call      VerifDet                 ; detekce vadnch sektor

; ------ test, zda byla nalezena alespo 1 chyba

FForm52: mov       di,offset ErrSekt + KORIG ; tabulka chyb
         mov       cx,offset(ErrSekt0-ErrSekt) ; dlka tabulky
         mov       al,0
         cld
         push      di
         push      cx
         repe      scasb                    ; test, zda je vadn sektor
         pop       cx
         pop       di
         jne       FForm54                  ; byl nalezen vadn sektor

; ------ nic nenalezeno - nastaven vech sektor jako vadn

         dec       ax                       ; ukld se -1
         rep       stosb                    ; vymazn tabulky

; ------ uloen nalezench chyb

FForm54: mov       ax,ds:[AbsSekt+KORIG]    ; absolutn slo sektoru stopy
         mov       cx,word ptr ds:[Sektoru+KORIG] ; poet sektor na stopu
         mov       bx,offset ErrSekt+KORIG  ; ukazatel tabulky chyb

FForm6:  mov       dh,ds:[bx]               ; bajt pznak chyby
         mov       dl,8+1                   ; ta bit
         inc       bx                       ; zven ukazatele v tabulce
FForm62: dec       dl                       ; ta bit
         jz        FForm6                   ; jsou ji vechny bity - dal
         shr       dh,1                     ; test dalho bitu
         jnc       FForm66                  ; nebyla chyba
         call      StorErr                  ; uloen sla vadnho bloku
FForm66: inc       ax
         clc
         loop      FForm62                  ; dal sektor

; ------ zpis BOOT sektoru

FForm7:  call      WritBoot                 ; zpis BOOT

; ------ zpis tabulky FAT 1

         mov       ax,1                     ; slo sektoru pro FAT1
         call      WritFAT                  ; zpis FAT 1

; ------ zpis tabulky FAT 2

         mov       ax,ds:[FATSekt+KORIG]    ; poet sektor na FAT
         inc       ax                       ; piten sektoru BOOT
         call      WritFAT                  ; zpis FAT 2

; ------ zpis prvnho sektoru ROOT

         call      WritRoot                 ; zpis sektoru ROOT

; ------ zpis souboru XFLOP.COM

         call      WritXFlp                 ; zpis souboru XFLOP.COM
FForm9:  ret

FForm    ENDP

; -----------------------------------------------------------------------------
;        detekce vadnch sektor
; -----------------------------------------------------------------------------

VerifDet PROC      NEAR

; ------ test, zda se budou sektory prokldat

         mov       al,1                     ; poten sektor 1
         cmp       byte ptr ds:[Interl+KORIG],1 ; je ji prokldn sektor ?
         je        VerifDt4                 ; nen prokldn sektor

; ------ verifikace sektor bez prokldn

VerifDt2:call      VerifyD                  ; verifikace sektoru
         inc       ax                       ; zven ukazatele sla sektoru
         cmp       al,ds:[Sektoru+KORIG]    ; je ji posledn sektor ?
         jbe       VerifDt2                 ; verifikace dalho sektoru
         jmp       short VerifDt6

; ------ verifikace lichch sektor

VerifDt4:call      VerifyD                  ; verifikace sektoru
         inc       ax
         inc       ax                       ; zven ukazatele sla sektoru
         cmp       al,ds:[Sektoru+KORIG]    ; je ji posledn sektor ?
         jbe       VerifDt4                 ; verifikace dalho sektoru

; ------ verifikace sudch sektor

         mov       al,2                     ; ukazatel sla sektoru
VerifDt5:cmp       al,ds:[Sektoru+KORIG]    ; je jet platn slo sektoru ?
         ja        VerifDt6                 ; nen ji platn slo sektoru
         call      VerifyD                  ; verifikace sektoru
         inc       ax
         inc       ax                       ; zven ukazatele sektor
         jmp       short VerifDt5           ; verifikace dalho sektoru

VerifDt6:ret

VerifDet ENDP

; -----------------------------------------------------------------------------
;    verifikace 1 sektoru slo AL s aktualizac tabulky chyb (ni BX, CX, AH)
; -----------------------------------------------------------------------------

VerifyD  PROC      NEAR

; ------ pprava bitov masky

         mov       bh,0
         mov       bl,al                    ; BL <- slo sektoru 1...
         dec       bx                       ; slo sektoru relativn 0...
         mov       cl,bl                    ; CL <- slo sektoru
         shr       bx,1
         shr       bx,1
         shr       bx,1                     ; BX = offset v tabulce chyb
         and       cl,7                     ; bitov pozice v tabulce
         mov       ch,bit0                  ; bitov maska
         shl       ch,cl                    ; rotace masky na pozici

; ------ test, zda je sektor ji vadn

         test      byte ptr ds:[ErrSekt+KORIG+bx],ch ; je sektor ji vadn ?
         jnz       VerifyD9                 ; sektor je ji vadn

; ------ verifikace testovanho sektoru

         mov       ah,1                     ; verifikace 1 sektoru
         call      Verify                   ; verifikace sektoru
         jnc       VerifyD9                 ; sektor nen vadn

; ------ chyba - test, zda je peruen operace

         call      TestEnd                  ; je peruen operace ?
         jc        VerifyD9                 ; je peruen operace

; ------ oznaen sektoru jako vadn

         or        byte ptr ds:[ErrSekt+KORIG+bx],ch ; oznaen sektoru jako vadn
VerifyD9:ret

VerifyD  ENDP

; -----------------------------------------------------------------------------
;        testovac zpis nhodnm vzorkem (BP=ta zbylch zpis)
; -----------------------------------------------------------------------------

WritTst  PROC      NEAR

; ------ test, zda je ji posledn testovac zpis

         cmp       bp,1                     ; je posledn testovac zpis ?
         je        WritTst1                 ; je posledn testovac zpis

; ------ adresa nhodnch dat

         call      GetTime                  ; poskytnut tae asu -> AX
         sub       al,ds:[AStopa+KORIG]     ; aby se to mnilo se stopou
         mov       cl,4
         ror       ax,cl                    ; penesen zmn do hornch bit
         add       ax,bp
         add       ax,bp
         add       ax,bp                    ; jet se posouv s slem zpisu
         and       ax,701fh                 ; segment adresy
         mov       di,ax                    ; ES <- segment adresy
         xor       si,si                    ; SI <- offset adresy

; ------ zpis nhodnch dat

         mov       ah,ds:[Sektoru+KORIG]    ; poet sektor na stopu
         mov       al,1                     ; slo prvnho sektoru
         call      Write                    ; zpis nhodn stopy
         jmp       short WritTst9

; ------ pprava bufferu (vynulovn) pro posledn zpis

WritTst1:mov       ax,ds:[AbsSekt+KORIG]    ; sektor potku stopy
         cmp       ax,ds:[DatSekt+KORIG]    ; je ji v datov oblasti ?
         mov       al,0                     ; bude se zapisovat 0
         jb        WritTst2                 ; je jet v systmov oblasti
         mov       al,ds:[FillCh+KORIG]     ; datov vzor
WritTst2:mov       ah,al
         mov       cx,512/2
         mov       di,ds:[BuffSekt+KORIG]   ; buffer sektoru
         mov       si,di                    ; SI <- adresa bufferu
         cld
         rep       stosw                    ; vymazn bufferu sektoru
         mov       di,ds                    ; DI <- segment bufferu

; ------ test, zda se budou sektory prokldat

         mov       ax,1*HI + 1              ; 1 sektor od sla 1
         cmp       byte ptr ds:[Interl+KORIG],1 ; je ji prokldn sektor ?
         je        WritTst4                 ; nen prokldn sektor

; ------ zpis sektor bez prokldn

WritTst3:call      Write                    ; zpis sektoru
         jc        WritTst9
         inc       ax                       ; zven ukazatele sla sektoru
         cmp       al,ds:[Sektoru+KORIG]    ; je ji posledn sektor ?
         jbe       WritTst3                 ; zpis dalho sektoru
         jmp       short WritTst9           ; (zde je NC)

; ------ zpis lichch sektor

WritTst4:call      Write                    ; zpis sektoru
         jc        WritTst9
         inc       ax
         inc       ax                       ; zven ukazatele sla sektoru
         cmp       al,ds:[Sektoru+KORIG]    ; je ji posledn sektor ?
         jbe       WritTst4                 ; zpis dalho sektoru

; ------ zpis sudch sektor

         mov       al,2                     ; ukazatel sla sektoru
WritTst5:cmp       al,ds:[Sektoru+KORIG]    ; je jet platn slo sektoru ?
         ja        WritTst9                 ; nen ji platn slo sektoru
         call      Write                    ; zpis sektoru
         inc       ax
         inc       ax                       ; zven ukazatele sektor
         jnc       WritTst5                 ; zpis dalho sektoru (nebyla-li chyba)
WritTst9:ret

WritTst  ENDP

; -----------------------------------------------------------------------------
;        zpis sektoru AL v aktivn stop (z bufferu sektoru)
; -----------------------------------------------------------------------------

WritSekt PROC      NEAR

; ------ schova registr

         push      ax
         push      si
         push      di

; ------ pprava registr

         mov       ah,1                     ; zape se 1 sektor
         mov       di,ds                    ; DI <- segment bufferu sektoru
         mov       si,ds:[BuffSekt+KORIG]   ; SI <- offset bufferu sektoru

; ------ zpis sektoru

         call      Write                    ; zpis sektoru
         jnc       WritSek2                 ; zpis OK
         call      Reset                    ; resetovn disku
         call      Write                    ; druh pokus o zpis
         jc        WritSek9                 ; chyba

; ------ verifikace sektoru

WritSek2:call      Verify                   ; verifikace sektoru
         jnc       WritSek9                 ; operace OK
         call      Reset                    ; resetovn disku
         call      Verify                   ; druh pokus o verifikaci

; ------ nvrat registr

WritSek9:pop       di
         pop       si
         pop       ax
         ret

WritSekt ENDP

; -----------------------------------------------------------------------------
;        zpis BOOT sektoru
; -----------------------------------------------------------------------------

WritBoot PROC      NEAR

; ------ test, zda je stopa s BOOT

         cmp       word ptr ds:[AbsSekt+KORIG],0 ; je zatek diskety ?
         jne       WritBot9                 ; nen zatek diskety

; ------ pprava BOOT sektoru

         mov       di,ds:[BuffSekt+KORIG]   ; adresa bufferu
         mov       si,offset BootBeg + KORIG  ; BOOT sektor
         mov       cx,512/2                 ; dlka BOOT sektoru
         cld
         rep       movsw                    ; penos BOOT sektoru

; ------ zpis sektoru v bufferu

         mov       al,1                     ; slo sektoru
         call      WritSekt                 ; zpis sektoru na disk
WritBot9:ret

WritBoot ENDP

; -----------------------------------------------------------------------------
;        zpis zhlav FAT (AX=absolutn slo sektoru)
; -----------------------------------------------------------------------------

WritFAT  PROC      NEAR

; ------ test, zda je stopa se sektorem FAT

         sub       ax,ds:[AbsSekt+KORIG]    ; ulo se FAT ?
         cmc
         jnc       WritFAT8                 ; nen stopa s FAT
         cmp       ax,word ptr ds:[Sektoru+KORIG] ; je sektor jet na stop ?
         jae       WritFAT8                 ; sektor ji nen na stop
         inc       ax                       ; AL = slo sektoru s FAT

; ------ pprava sektoru

         push      ax
         call      NulSekt                  ; vynulovn sektoru
         mov       di,si                    ; DI <- adresa bufferu
         mov       al,ds:[MediaB+KORIG]     ; popisova mdia
         stosb
         mov       ax,-1
         stosw
         pop       ax

; ------ zpis sektoru

         call      WritSekt                 ; zpis sektoru na disk
WritFAT8:ret

WritFAT  ENDP

; -----------------------------------------------------------------------------
;        zpis sektoru ROOT
; -----------------------------------------------------------------------------

WritRoot PROC      NEAR

; ------ test, zda se zapisuje sektor ROOT

         test      byte ptr ds:[RParam3+KORIG],bit0+bit1 ; zapisuje se ROOT ?
         jz        WritRot9                 ; ROOT se nezapisuje

; ------ test, zda je stopa se sektorem ROOT

         mov       ax,ds:[FATSekt+KORIG]    ; poet sektor na FAT
         shl       ax,1                     ; poet sektor na ob FAT
         inc       ax                       ; poten sektor ROOT
         sub       ax,ds:[AbsSekt+KORIG]    ; je stopa s ROOT ?
         cmc
         jnc       WritRot9                 ; je stopa za sektorem ROOT
         cmp       ax,word ptr ds:[Sektoru+KORIG] ; je sektor jet na stop ?
         jae       WritRot9                 ; sektor ji nen na stop
         inc       ax                       ; AL = slo sektoru

         push      ax

; ------ vynulovn bufferu sektoru

         call      NulSekt                  ; vynulovn sektoru

; ------ sestaven poloky LABEL

         mov       di,si                    ; DI <- ukldac adresa
         test      byte ptr ds:[RParam3+KORIG],bit0 ; zapisuje se LABEL ?
         jz        WritRot4                 ; nezapisuje se LABEL

         mov       si,offset BootLabl+KORIG
         mov       cx,11
         rep       movsb                    ; penesen jmna LABEL
         mov       al,bit3                  ; atribut LABEL
         stosb                              ; atribut poloky
         add       di,10
         mov       si,offset LabTime+KORIG
         movsw                              ; as
         movsw                              ; datum
         add       di,6

; ------ sestaven poloky XFLOP.COM

WritRot4:test      byte ptr ds:[RParam3+KORIG],bit1 ; zapisuje se XFLOP.COM ?
         jz        WritRot6

         mov       si,offset XFlopNam+KORIG
         mov       cx,11
         rep       movsb                    ; jmno souboru
         add       di,11
         mov       cl,4*2
         rep       movsb                    ; parametry

; ------ zpis sektoru ROOT

WritRot6:pop       ax                       ; AL <- slo sektoru
         call      WritSekt                 ; zpis sektoru na disk

WritRot9:ret

WritRoot ENDP

; -----------------------------------------------------------------------------
;        zpis souboru XFLOP.COM
; -----------------------------------------------------------------------------

WritXFlp PROC      NEAR

; ------ test, zda se zapisuje XFLOP.COM

         test      byte ptr ds:[RParam3+KORIG],bit1 ; zapisuje se XFLOP.COM ?
         jz        WritXFl9                 ; XFLOP se nezapisuje

; ------ test, zda je stopa s XFLOP.COM

         mov       ax,ds:[XFlopAbs+KORIG]   ; sektor s XFLOP.COM
         sub       ax,ds:[AbsSekt+KORIG]    ; je stopa s XFLOP ?
         cmc
         jnc       WritXFl9                 ; je stopa za sektorem XFLOP
         cmp       ax,word ptr ds:[Sektoru+KORIG] ; je sektor jet na stop ?
         jae       WritXFl9                 ; sektor ji nen na stop
         inc       ax                       ; AL = slo sektoru

; ------ penesen sektoru do bufferu

         push      ax
         mov       di,ds:[BuffSekt+KORIG]   ; adresa bufferu
         push      di
         mov       si,offset BootBeg + KORIG  ; BOOT sektor
         mov       cx,512/2                 ; dlka BOOT sektoru
         cld
         rep       movsw                    ; penos BOOT sektoru
         pop       si                       ; adresa bufferu
         pop       ax                       ; AL = slo sektoru

; ------ zpis sektoru na disk

         call      WritSekt                 ; zpis sektoru na disk

WritXFl9:ret

WritXFlp ENDP

; -----------------------------------------------------------------------------
;        uloen chyby pro absolutn sektor AX
; -----------------------------------------------------------------------------

StorErr  PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      dx

; ------ test, zda je vadn BOOT sektor

         sub       ax,1                     ; je to BOOT sektor ?
         jae       StorErr2                 ; nen BOOT sektor
         or        byte ptr ds:[RParam2+KORIG],bit1 ; vadn BOOT sektor
         jmp       short StorErr9

; ------ test, zda je vadn FAT1

StorErr2:sub       ax,ds:[FATSekt+KORIG]    ; odeten sektor na FAT 1
         jae       StorErr3                 ; nen FAT1
         or        byte ptr ds:[RParam2+KORIG],bit2 ; vadn FAT1
         jmp       short StorErr9

; ------ test, zda je vadn FAT2

StorErr3:sub       ax,ds:[FATSekt+KORIG]    ; odeten sektor na FAT 2
         jae       StorErr4                 ; nen FAT2
         or        byte ptr ds:[RParam2+KORIG],bit3 ; vadn FAT 2
         jmp       short StorErr9

; ------ test, zda je vadn ROOT

StorErr4:sub       ax,ds:[Root+KORIG]       ; odeten sektor na ROOT
         jae       StorErr5                 ; nen ROOT
         or        byte ptr ds:[RParam2+KORIG],bit4 ; vadn ROOT
         jmp       short StorErr9

; ------ pepoet sektoru na slo alokanho bloku -> AX

StorErr5:
IFDEF    DEMO
         push      ax
         mov       al,ds:[AStopa+KORIG]
         cmp       al,ds:[DemoStop+KORIG]   ; je to DEMO stopa ?
         pop       ax
         jae       StorEr52                 ; je DEMO stopa
ENDIF
         or        byte ptr ds:[RParam2+KORIG],bit5 ; byla chyba v datech
StorEr52:xor       dx,dx
         div       word ptr ds:[Cluster+KORIG] ; vpoet sla bloku

         cmp       ax,ds:[NumClust+KORIG]   ; je to platn alokan blok ?
         jae       StorErr9                 ; nen to platn alokan blok

         inc       ax
         inc       ax                       ; posun + 2 = slo bloku

; ------ test, zda je nov poloka

         mov       bx,ds:[ErrMEnd+KORIG]    ; ukazatel vadnch blok
         cmp       byte ptr ds:[bx],0       ; je nco uloeno ?
         je        StorErr7                 ; nen nic uloeno

; ------ test, zda je pokraovn etzce

         mov       dl,ds:[bx]               ; poet blok v tabulce
         mov       dh,0
         add       dx,ds:[bx+1]             ; slo nsledujcho bloku
         cmp       ax,dx                    ; je nsledujc blok ?
         jb        StorErr9                 ; blok je ji zahrnut
         ja        StorErr6                 ; vytvoen nov poloky

; ------ test, zda me bt dal blok etzce

         cmp       byte ptr ds:[bx],255     ; me bt dal blok ?
         jb        StorErr8                 ; me bt dal blok v etzci

; ------ vytvoen nov poloky

StorErr6:add       bx,3                     ; zven ukazatele poloek
         cmp       bx,offset ErrMap+KORIG+MAXERR*3 ; je tabulka ji pln ?
         jae       StorErr9                 ; tabulka je ji pln
         mov       ds:[ErrMEnd+KORIG],bx    ; nov ukazatel poloek

; ------ uloen nov poloky

StorErr7:mov       ds:[bx+1],ax             ; uloen potenho bloku
StorErr8:inc       byte ptr ds:[bx]         ; zven potu blok

; ------ nvrat registr

StorErr9:pop       dx
         pop       bx
         pop       ax
         ret

StorErr  ENDP

; -----------------------------------------------------------------------------
;        zformtovn aktivn stopy (s opakovnm pi chyb DMA)
; -----------------------------------------------------------------------------

Format   PROC      NEAR

         push      bp
         mov       bp,20                    ; poet pokus o verifikaci

Format01:call      TestEnd                  ; test ukonen operace
         jc        Format04                 ; peruen operace
         mov       byte ptr ds:[BuffStat+KORIG+1],0 ; pednastaven ST0
         call      Format0                  ; formtovn
         jnc       Format04                 ; operace OK
         test      byte ptr ds:[BuffStat+KORIG+1],bit4 ; je peteen DMA ?
         jz        Format03                 ; nen peteen DMA
         dec       bp
         jnz       Format01                 ; dal pokus
Format03:stc                                ; pznak chyby
Format04:pop       bp
         ret

Format   ENDP

; -----------------------------------------------------------------------------
;        zformtovn aktivn stopy (CY=chyba) (DS=ES=CS)
; -----------------------------------------------------------------------------

Format0  PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp
         mov       byte ptr ds:[AOper+KORIG],3 ; pznak formtovn

IFDEF    DEMO
         mov       bx,(DEMOTRK-23)*HI       ; dlc stopa pro DEMO
ENDIF

IFDEF    DEBUG
         call      ZapDisk                  ; zapnut disku
ENDIF

; ------ vynulovn tabulky sektor (zachovat BX pro DEMO !)

         call      NulSekt                  ; vynulovn tabulky sektor
         mov       di,si                    ; DI <- zatek bufferu

; ------ stanoven sla potenho sektoru -> AX (zachovat BX pro DEMO !)

         mov       al,ds:[SlideY+KORIG]     ; odsazen sektor stop
         cmp       byte ptr ds:[Stran+KORIG],1 ; je 1 strana ?
         je        Format1                  ; je 1 strana
         add       al,ds:[SlideX+KORIG]     ; piten odsazen pro strany
Format1: mul       byte ptr ds:[AStopa+KORIG] ; posun odsazenm pedelch stop

         cmp       byte ptr ds:[AStrana+KORIG],0 ; je strana 0 ?
         je        Format2                  ; je strana 0
         add       al,ds:[SlideX+KORIG]     ; odsazen podle strany
         adc       ah,0

Format2: mov       cx,word ptr ds:[Sektoru+KORIG] ; poet sektor na stopu
         dec       cx
         add       ax,cx                    ; korekce potku posun

IFDEF    DEMO
         add       bh,23                    ; korekce na slo dlc stopy DEMO
ENDIF

         inc       cx
         xor       dx,dx
         div       cx                       ; vpoet odsazen
         xchg      ax,cx                    ; AX <- poet sektor na stopu
         sub       ax,dx                    ; AL = slo potenho sektoru

; ------ pprava ke generovn tabulky (zachovat BX pro DEMO !)

         mov       dl,ds:[AStopa+KORIG]     ; DL <- aktuln stopa

IFDEF    DEMO
         add       bh,bl                    ; jen pro zmaten (BL = 0)
         cmp       dl,bh                    ; je DEMO stopa ? (NC=je)
         cmc                                ; zmna CY=je DEMO stopa
         adc       dl,bl                    ; pro vy stopu se slo pokaz
ENDIF

         mov       dh,ds:[AStrana+KORIG]    ; DH <- aktuln strana
         mov       ah,2                     ; velikost sektoru 512 B
         mov       cx,word ptr ds:[Sektoru+KORIG] ; poet sektor na stopu
         mov       bp,cx                    ; BP <- poet sektor na stopu
         shl       bp,1
         shl       bp,1                     ; * 4 = velikost tabulky
         mov       si,bp                    ; SI <- velikost tabulky
         add       bp,di                    ; BP = adresa konce tabulky
         mov       bl,ds:[Interl+KORIG]     ; prokldn sektor

IFDEF    SHARE
         cmp       byte ptr ds:[AStopa+KORIG],DEMOTRK
         jb        Format32                 ; nen jet polovina diskety
;
         mov       bl,8
         cmp       bl,ds:[Sektoru+KORIG]
         jb        Format31
         mov       bl,ds:[Sektoru+KORIG]
Format31:cmp       bl,ds:[Interl+KORIG]
         jae       Format32
         mov       bl,ds:[Interl+KORIG]
Format32:

ENDIF

         mov       bh,0
         dec       bx                       ; prokldn - 1
         shl       bx,1
         shl       bx,1                     ; posun adres sektor

; ------ zajitn platnosti adresy

Format4: cmp       di,bp                    ; je adresa OK ?
         jb        Format5                  ; adresa je OK
         sub       di,si                    ; posun adresy o 1 stopu
         jmp       short Format4

; ------ zajitn volnosti poloky

Format5: cmp       byte ptr ds:[di+3],0     ; je voln poloka (dlka sektoru) ?
         je        Format6                  ; je voln poloka
         add       di,4                     ; zven ukldac adresy
         jmp       short Format4            ; nov test poloky

; ------ uloen poloky

Format6: xchg      ax,dx                    ; AL <- vlec, AH <- hlava
         stosw                              ; slo vlce a hlavy
         xchg      ax,dx                    ; AL <- sektor, AH <- velikost
         stosw                              ; slo a velikost sektoru

; ------ zven sla sektoru

         inc       ax                       ; zven sla sektoru
         cmp       al,ds:[Sektoru+KORIG]    ; je slo sektoru jet OK ?
         jbe       Format7                  ; slo sektoru je jet OK
         mov       al,1                     ; peteen sla sektoru

; ------ dal poloka

Format7: add       di,bx                    ; posun poloky pi prokldn
         loop      Format4                  ; dal poloka

IFDEF    DEMO
; ------ omezen DEMO stopy (ni registr DL !)

         add       dl,17                    ; pokaen sla
         cmp       dl,DEMOTRK+17            ; je DEMO stopa ?
         jae       Format9                  ; omezen pro DEMO stopu
ENDIF
; ------ nastaven kanlu DMA pro zpis

         mov       cx,word ptr ds:[Sektoru+KORIG]    ; poet sektor na stopu
         shl       cx,1
         shl       cx,1                     ; 4 bajty na sektor
         mov       al,DMAW                  ; povel pro zpis DMA
         mov       si,ds:[BuffSekt+KORIG]   ; adresa bufferu
         mov       di,ds                    ; segment adresy bufferu
         call      SetDMA                   ; nastaven kanlu DMA

; ------ vysln povelu pro formtovn

         mov       al,4dh                   ; povel pro formtovn
         call      Output                   ; vysln bajtu
         jc        Format9

; ------ nastaven mechaniky a hlaviky

         mov       al,ds:[AStrana+KORIG]    ; aktivn strana
         shl       al,1
         shl       al,1                     ; rotace na pozici
         or        al,ds:[Disk+KORIG]       ; mechanika
         call      Output                   ; nastaven mechaniky a hlaviky
         jc        Format9

; ------ nastaven dlky sektoru

         mov       al,2                     ; 512 bajt
         call      Output                   ; nastaven dlky sektoru
         jc        Format9

; ------ nastaven potu sektor

         mov       al,ds:[Sektoru+KORIG]    ; poet sektor
         call      Output                   ; nastaven potu sektor
         jc        Format9

; ------ nastaven mezisektorov mezery

         mov       al,byte ptr ds:[Gap+KORIG] ; mezisektorov mezera
         call      Output                   ; nastaven mezisektorov mezery
         jc        Format9

; ------ nastaven datovho vzorku

         mov       ax,ds:[AbsSekt+KORIG]    ; sektor potku stopy
         cmp       ax,ds:[DatSekt+KORIG]    ; je ji v datov oblasti ?
         mov       al,0                     ; bude se zapisovat 0
         jb        Formt76                  ; je jet v systmov oblasti
         mov       al,ds:[FillCh+KORIG]     ; datov vzor
Formt76: cmp       word ptr ds:[TestWrit+KORIG],0 ; bude testovac zpis ?
         je        Format8                  ; nebude testovac zpis
         not       al                       ; inverze pro test spolehlivosti
Format8: call      Output                   ; nastaven datovho vzoru
         jc        Format9

; ------ ekn na proveden operace

         call      OperWait                 ; ekn na ukonen operace

; ------ nvrat registr

Format9: pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

Format0  ENDP

; -----------------------------------------------------------------------------
;        verifikace cel aktivn stopy (ni AX)
; -----------------------------------------------------------------------------

Verify0: mov       ah,ds:[Sektoru+KORIG]    ; poet sektor na stopu
         mov       al,1                     ; poten sektor

; -----------------------------------------------------------------------------
;        verifikace AH sektor od sla AL (s opakovnm pi chyb DMA)
; -----------------------------------------------------------------------------

Verify   PROC      NEAR

         push      bp
         mov       bp,20                    ; poet pokus o verifikaci

IFDEF    DEMO
         cmp       byte ptr ds:[AStopa+KORIG],DEMOTRK ; je DEMO stopa ?
         jae       Verify3                  ; je DEMO stopa - chyba
ENDIF

Verify1: call      TestEnd                  ; test ukonen operace
         jc        Verify4                  ; peruen operace
         mov       byte ptr ds:[BuffStat+KORIG+1],0 ; pednastaven ST0
         call      Verify8                  ; verifikace
         jnc       Verify4                  ; operace OK
         test      byte ptr ds:[BuffStat+KORIG+1],bit4 ; je peteen DMA ?
         jz        Verify3                  ; nen peteen DMA
         dec       bp
         jnz       Verify1
Verify3: stc                                ; pznak chyby operace
Verify4: pop       bp
         ret

Verify   ENDP

; -----------------------------------------------------------------------------
;        verifikace AH sektor od sla AL
; -----------------------------------------------------------------------------

Verify8  PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      dx
         push      si
         push      di
         mov       dx,ax                    ; DL <- slo sektoru, DH <- poet
         mov       byte ptr ds:[AOper+KORIG],4 ; pznak verifikace

IFDEF    DEBUG
         call      ZapDisk                  ; zapnut disku
ENDIF

; ------ nastaven kanlu DMA pro verifikaci

         mov       al,0                     ; AL <- 0
         shl       ax,1                     ; poet bajt
         xchg      ax,cx                    ; CX <- poet bajt pro zpis
         mov       al,DMAV                  ; povel pro verifikaci DMA
         xor       si,si                    ; SI <- 0 offset adresy
         xor       di,di                    ; DI <- 0 segment adresy
         call      SetDMA                   ; nastaven kanlu DMA

; ------ vysln povelu pro ten

         mov       al,66h                   ; povel pro ten
         jmp       short Write1

Verify8  ENDP

; -----------------------------------------------------------------------------
;        zpis AH sektor od sla AL, adresa DI:SI (s opakovnm pi chyb DMA)
; -----------------------------------------------------------------------------

Write    PROC      NEAR

         push      bp
         mov       bp,20                    ; poet pokus o zpis

IFDEF    DEMO
         cmp       byte ptr ds:[AStopa+KORIG],DEMOTRK ; je DEMO stopa ?
         jae       WriteX3                  ; je DEMO stopa - chyba
ENDIF

WriteX1: call      TestEnd                  ; test ukonen operace
         jc        WriteX5                  ; peruen operace
         mov       byte ptr ds:[BuffStat+KORIG+1],0 ; pednastaven ST0
         call      Write0                   ; zpis
         jnc       WriteX5                  ; operace OK
         test      byte ptr ds:[BuffStat+KORIG+1],bit4 ; je peteen DMA ?
         jz        WriteX3                  ; nen peteen DMA
         dec       bp
         jnz       WriteX1                  ; dal pokus pi peteen DMA
WriteX3: stc
WriteX5: pop       bp
         ret

Write    ENDP

; -----------------------------------------------------------------------------
;        zpis AH sektor od sla AL, adresa DI:SI
; -----------------------------------------------------------------------------

Write0   PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      dx
         push      si
         push      di
         mov       dx,ax                    ; DL <- slo sektoru, DH <- poet
         mov       byte ptr ds:[AOper+KORIG],5 ; pznak zpisu

IFDEF    DEBUG
         call      ZapDisk                  ; zapnut disku
ENDIF

; ------ nastaven kanlu DMA pro zpis

         mov       al,0                     ; AL <- 0
         shl       ax,1                     ; poet bajt
         xchg      ax,cx                    ; CX <- poet bajt pro zpis
         mov       al,DMAW                  ; povel pro zpis DMA
         call      SetDMA                   ; nastaven kanlu DMA

; ------ vysln povelu pro zpis

         mov       al,45h                   ; povel pro zpis
Write1:  call      Output                   ; vysln bajtu
         jc        Write9

; ------ nastaven mechaniky a hlaviky

         mov       al,ds:[AStrana+KORIG]    ; aktivn strana
         shl       al,1
         shl       al,1                     ; rotace na pozici
         or        al,ds:[Disk+KORIG]       ; mechanika
         call      Output                   ; nastaven mechaniky a hlaviky
         jc        Write9

; ------ nastaven sla stopy

         mov       al,ds:[AStopa+KORIG]     ; aktivn stopa
         call      Output                   ; nastaven sla stopy
         jc        Write9

; ------ nastaven sla strany

         mov       al,ds:[AStrana+KORIG]    ; aktivn strana
         call      Output                   ; nastaven sla strany
         jc        Write9

; ------ nastaven sla sektoru

         mov       al,dl                    ; slo sektoru
         call      Output                   ; nastaven sla sektoru
         jc        Write9

; ------ nastaven dlky sektoru 512 B

         mov       al,2
         call      Output                   ; nastaven dlky sektoru
         jc        Write9

; ------ nastaven sla maximlnho sektoru

         mov       al,ds:[Sektoru+KORIG]    ; poet sektor na stopu
         call      Output                   ; nastaven maximlnho sektoru
         jc        Write9

; ------ nastaven mezisektorov mezery (pozor - BIOS ji pouv 27 a 42 !)

         mov       al,2                     ; mezisektorov mezera (nen poteba)
         call      Output                   ; nastaven mezisektorov mezery
         jc        Write9

; ------ poet tench bajt

         mov       al,255
         call      Output                   ; nastaven potu tench bajt
         jc        Write9

; ------ ekn na proveden operace

         call      OperWait                 ; ekn na ukonen operace

; ------ nvrat registr

Write9:  pop       di
         pop       si
         pop       dx
         pop       cx
         pop       ax
         ret

Write0   ENDP

; -----------------------------------------------------------------------------
;        reset adie disket (CY=chyba)
; -----------------------------------------------------------------------------

Reset    PROC      NEAR

; ------ schova registr

         push      ax
         push      dx

IFDEF    DEMO
; ------ omezen pro DEMO stopu

         mov       al,ds:[AStopa+KORIG]     ; aktivn stopa
         add       al,93
ENDIF
; ------ test, zda je peruen operace

         call      TestEnd                  ; test ukonen operace
         jc        Reset9                   ; peruen operace

IFDEF    DEMO
; ------ omezen pro DEMO stopu

         cmp       al,DEMOTRK+93            ; je DEMO stopa ?
         jae       Reset9                   ; je DEMO stopa
ENDIF
; ------ vysln signlu RESET na adi disket

         call      ResDisk                  ; vysln signlu pro reset
         call      ZapDisk                  ; uvolnn adie

; ------ kontrola vsledku operace

         call      ChkStat                  ; kontrola stavu
         jc        Reset9
         cmp       byte ptr ds:[BuffStat+KORIG],0c0h ; kontrola navrcenho stavu
         je        Reset1                   ; navrcen stav je OK
         mov       byte ptr ds:[LastErr+KORIG],13 ; chyba resetovn adie
         stc
         jmp       short Reset9             ; chyba

; ------ vysln povelu pro specifikaci parametr SPECIFY

Reset1:  mov       al,3
         call      Output                   ; vysln povelu SPECIFY
         jc        Reset9

         mov       al,0dfh                  ; krokovn pro mechaniky 5 1/4"
         cmp       byte ptr ds:[TypDisk+KORIG],M120 ; je mechanika 5 1/4" ?
         jbe       Reset2                   ; mechanika 5 1/4"
         mov       al,0afh                  ; krokovn pro mechaniku 3 1/2"
Reset2:  call      Output                   ; nastaven rychlosti krokovn
         jc        Reset9

         mov       al,2
         call      Output                   ; as pro piklopen hlaviky, DMA
         jc        Reset9

; ------ nastaven penosov rychlosti

         mov       dx,3f7h
         mov       al,ds:[Rate+KORIG]       ; penosov rychlost
         out       dx,al                    ; nastaven penosov rychlosti

; ------ rekalibrace disku

         mov       al,7                     ; povel pro rekalibraci disku
         call      Output                   ; vysln povelu pro rekalibraci
         jc        Reset9
         mov       al,ds:[Disk+KORIG]       ; poadovan disk
         call      Output                   ; vysln sla disku
         jc        Reset9

; ------ kontrola operace rekalibrace

         call      ChkStat                  ; kontrola stavu operace
         jc        Reset9                   ; chyba

; ------ vystaven zptky na stopu

         call      Seek                     ; vystaven hlav

; ------ nvrat registr

Reset9:  pop       dx
         pop       ax
         ret

Reset    ENDP

; -----------------------------------------------------------------------------
;        nastaven kanlu DMA: AL=povel pro DMA, CX=poet bajt, DI:SI=adresa
; -----------------------------------------------------------------------------

SetDMA   PROC      NEAR

; ------ schova registr

         push      ax
         push      cx                       ; (mus bt posledn !)

; ------ nastaven povelu pro DMA

         cli
         out       [0ch],al                 ; nastaven pznaku nslednosti DMA
         jmp       short $+2                ; prodleva
         out       [0bh],al                 ; nastaven povelu pro DMA

; ------ vpoet adresy pro penos DMA -> CH:AX (20 bit)

         mov       ax,di                    ; AX <- segment adresy
         mov       ch,ah                    ; CH <- vy bajt adresy
         mov       cl,4                     ; poet rotac
         shl       ax,cl                    ; pevod segmentu na offset
         shr       ch,cl                    ; vy 4 bity adresy v CH
         add       ax,si                    ; adresa bufferu sektoru
         adc       ch,0                     ; penos do adresy HIGH

; ------ nastaven adresy pro penos DMA (kanl 2)

         out       [4],al                   ; nastaven niho bajtu adresy
         mov       al,ah                    ; AL <- vy bajt adresy
         jmp       short $+2                ; prodleva
         out       [4],al                   ; nastaven vyho bajtu adresy
         mov       al,ch                    ; AL <- nejvy 4 bity
         out       [81h],al                 ; nastaven strnkovho registru

; ------ nastaven potu bajt k penosu

         pop       ax                       ; poet bajt k penosu
         push      ax
         dec       ax                       ; poet bajt - 1
         out       [5],al                   ; poet bajt LOW
         mov       al,ah                    ; AL <- poet bajt HIGH
         jmp       short $+2                ; prodleva
         out       [5],al                   ; poet bajt HIGH

; ------ povolen penosu kanlem DMA 2

         mov       al,2                     ; kanl 2
         out       [0ah],al                 ; povolen penosu kanlem 2
         sti

; ------ nvrat registr

         pop       cx
         pop       ax
         ret

SetDMA   ENDP

; -----------------------------------------------------------------------------
;        vystaven mechaniky na aktivn stopu (CY=chyba)
; -----------------------------------------------------------------------------

Seek     PROC      NEAR

; ------ schova registr

         push      ax

; ------ povel pro vystaven na stopu SEEK

         mov       al,0fh                   ; povel pro vystaven
         call      Output                   ; vysln povelu pro vystaven
         jc        Seek9

; ------ nastaven sla disku

         mov       al,ds:[Disk+KORIG]       ; poadovan disk
         call      Output                   ; vysln sla disku
         jc        Seek9                    ; chyba

; ------ nastaven sla stopy

         mov       al,ds:[AStopa+KORIG]     ; aktivn stopa
         test      byte ptr ds:[RParam+KORIG],bit6 ; je dvoj krokovn ?
         jz        Seek2                    ; nen dvoj krokovn
         shl       al,1                     ; dvojit krokovn
Seek2:   call      Output                   ; nastaven sla stopy
         jc        Seek9                    ; chyba

; ------ kontrola vsledku operace

         call      ChkStat                  ; test vsledku operace
         jc        Seek9                    ; chyba

; ------ prodleva pro ustlen hlav

         mov       ax,1000
         call      WaitT                    ; ekn 15 ms na ustlen hlav
         clc

; ------ nvrat registr

Seek9:   pop       ax
         ret

Seek     ENDP

; -----------------------------------------------------------------------------
;        vypnut mechaniky
; -----------------------------------------------------------------------------

VypDisk  PROC      NEAR

; ------ schova registr

         push      ax
         push      dx

; ------ nastaven registru

         mov       dx,3f2h                  ; adresa adie
         mov       al,ds:[Disk+KORIG]       ; zvolen disk
         or        al,bit2+bit3             ; uvolnn adie, povolen DMA
         out       dx,al

; ------ nvrat registr

         pop       dx
         pop       ax
         ret

VypDisk  ENDP

; -----------------------------------------------------------------------------
;        resetovn adie
; -----------------------------------------------------------------------------

ResDisk  PROC      NEAR

         push      ax
         mov       al,bit3                  ; resetovn adie
         jmp       short ZapDisk1

ResDisk  ENDP

; -----------------------------------------------------------------------------
;        zapnut mechaniky
; -----------------------------------------------------------------------------

ZapDisk  PROC      NEAR

; ------ schova registr

         push      ax
         mov       al,bit2+bit3             ; uvolnn adie, povolen DMA
ZapDisk1:push      dx

; ------ nastaven registru

         mov       dx,3f2h                  ; adresa adie
         mov       ah,ds:[DiskMask+KORIG]   ; maska disk
         shl       ah,1
         shl       ah,1
         shl       ah,1
         shl       ah,1
         or        al,ds:[Disk+KORIG]       ; zvolen disk
         or        al,ah                    ; maska zapnut motor
         out       dx,al

; ------ nvrat registr

         pop       dx
         pop       ax
         ret

ZapDisk  ENDP

; -----------------------------------------------------------------------------
;        test, zda je ukonen operace (peruen nebo vyjmut diskety) CY=konec
; -----------------------------------------------------------------------------

TestEnd  PROC      NEAR

         call      TstBreak                 ; test peruen operace
         jc        TestEnd2                 ; je peruen operace
         call      TestXchg                 ; test vyjmut diskety
TestEnd2:ret

TestEnd  ENDP

; -----------------------------------------------------------------------------
;        test, zda je peruen operace formtovn (CY=je peruen)
; -----------------------------------------------------------------------------

TstBreak PROC      NEAR

         test      byte ptr ds:[RParam2+KORIG],bit6 ; je zkaz peruen ?
         jnz       TstBrea2                 ; je zkaz peruen operace
         test      byte ptr ds:[RParam+KORIG],bit5 ; poadavek peruen ?
         jz        TstBrea2                 ; nen poadovno peruen
         stc                                ; pznak peruen
TstBrea2:ret

TstBreak ENDP

; -----------------------------------------------------------------------------
;        test, zda je vloena disketa (CY=nen)
; -----------------------------------------------------------------------------

TestXchg PROC      NEAR

         push      ax
         push      dx

         cmp       byte ptr ds:[TypDisk+KORIG],M360
         je        TestXch8                 ; pro mechaniku 360 KB vloena

         mov       dx,3f7h
         in        al,dx
         test      al,bit7                  ; je disketa vloena ?
         jz        TestXch8                 ; je vloena
         stc                                ; nen vloena

TestXch8:pop       dx
         pop       ax
         ret

TestXchg ENDP

; -----------------------------------------------------------------------------
;        ekn na proveden operace ten/zpis/formtovn
; -----------------------------------------------------------------------------

OperWait PROC      NEAR

; ------ ekn na pchod peruen od adie

         call      WaitInt                  ; ekn na peruen od adie
         jc        OperWai9                 ; chyba

; ------ pjem vsledku operace od adie

         call      Result                   ; pjem vsledku operace od adie
         jc        OperWai9

; ------ vyhodnocen vsledku operace

         test      byte ptr ds:[BuffStat+KORIG],bit6+bit7 ; stavov bajt ST0
         jz        OperWai9                 ; nen chyba

         test      byte ptr ds:[BuffStat+KORIG+1],bit4
         jnz       OperWai8                 ; peteen penosu DMA (nehls se)

         mov       byte ptr ds:[LastErr+KORIG],6 ; mechanika nepipravena
         test      byte ptr ds:[BuffStat+KORIG],bit3
         jne       OperWai8                 ; mechanika nepipravena

         mov       byte ptr ds:[LastErr+KORIG],7 ; nenalezena stopa 0
         test      byte ptr ds:[BuffStat+KORIG],bit4
         jnz       OperWai8                 ; nenalezena stopa 0

         mov       byte ptr ds:[LastErr+KORIG],8 ; sektor nenalezen
         test      byte ptr ds:[BuffStat+KORIG+1],bit0+bit2
         jnz       OperWai8                 ; sektor nenalezen

         mov       byte ptr ds:[LastErr+KORIG],9 ; disketa chrnna proti zpisu
         test      byte ptr ds:[BuffStat+KORIG+1],bit1
         jnz       OperWai8                 ; ochrana proti zpisu

         mov       byte ptr ds:[LastErr+KORIG],11 ; chyba CRC dat sektoru
         test      byte ptr ds:[BuffStat+KORIG+1],bit5
         jnz       OperWai8                 ; chyba CRC dat sektoru

         mov       byte ptr ds:[LastErr+KORIG],12 ; nesouhlas hlavika sektoru
         test      byte ptr ds:[BuffStat+KORIG+2],bit1+bit4
         jnz       OperWai8                 ; nesouhlas hlavika sektoru

         mov       byte ptr ds:[LastErr+KORIG],255 ; jin chyba

OperWai8:stc                                ; pznak chyby
OperWai9:ret

OperWait ENDP

; -----------------------------------------------------------------------------
;        kontrola vsledku operace vystaven, rekalibrace, resetu (CY=chyba)
; -----------------------------------------------------------------------------

ChkStat  PROC      NEAR

; ------ schova registr

         push      ax

; ------ ekn na peruen od adie (po proveden operace)

         call      WaitInt                  ; ekn na peruen od adie
         jc        ChkStat9                 ; chyba

; ------ vysln povelu SENSE INTERRUPT STATUS

         mov       al,8                     ; povel SENSE INTERRUPT STATUS
         call      Output                   ; vysln povelu SENSE INTERRUPT ...
         jc        ChkStat9                 ; chyba operace

; ------ pjem vsledku operace od adie

         call      Result                   ; pjem vsledku operace od adie
         jc        ChkStat9                 ; chyba operace

; ------ kontrola navrcenho stavovho bajtu ST0

         mov       al,ds:[BuffStat+KORIG]   ; stavov bajt ST0
         and       al,bit5+bit6             ; kontrolovan bity
         cmp       al,bit5+bit6             ; chyba vystaven ?
         clc                                ; operace OK
         jne       ChkStat9                 ; nen chyba vystaven
         mov       byte ptr ds:[LastErr+KORIG],5 ; chyba vystaven hlav
         stc                                ; chyba operace vystaven

; ------ nvrat registr

ChkStat9:pop       ax
         ret

ChkStat  ENDP

; -----------------------------------------------------------------------------
;        vysln bajtu AL na adi (CY=chyba TIME-OUT)
; -----------------------------------------------------------------------------

Output   PROC      NEAR

; ------ schova registr

         push      ax
         push      dx

; ------ ekn na pipravenost adie pijmat data

         mov       ah,bit7                  ; oekvan hodnota (pro zpis)
         call      WaitPort                 ; ekn na pipravenost pro zpis
         jc        Output9                  ; chyba TIME-OUT

; ------ vysln bajtu AL na adi

         mov       dx,3f5h
         out       dx,al                    ; vysln bajtu na adi
                                          ;* zde je NC = operace OK
; ------ nvrat registr

Output9: pop       dx
         pop       ax
         ret

Output   ENDP

; -----------------------------------------------------------------------------
;        naten stavu od adie (CY=chyba)
; -----------------------------------------------------------------------------

Result   PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      dx

; ------ vynulovn bufferu

         mov       bx,offset BuffStat+KORIG ; buffer stavu od adie
         xor       ax,ax                    ; AX <- 0
         mov       ds:[bx],ax
         mov       ds:[bx+2],ax
         mov       ds:[bx+4],ax

; ------ ekn na pipravenost adie

Result1: mov       ah,bit6+bit7             ; poadovan hodnota (pro ten)
         call      WaitPort                 ; ekn na pipravenost adie
         jc        Result9                  ; byla chyba adie TIME-OUT

; ------ pjem stavovho bajtu od adie

         mov       dx,3f5h
         in        al,dx                    ; ten stavovho bajtu adie
         mov       ds:[bx],al               ; uloen bajtu
         inc       bx                       ; zven ukldac adresy

; ------ mal prodleva (30 us)

         mov       ax,3                     ; (je to trochu vc)
         call      WaitT                    ; ekac doba pro odezvu adie

; ------ test, zda je jet dal stavov bajt

         dec       dx                       ; stavov registr adie 3f4h
         in        al,dx                    ; ten stavu adie
         test      al,bit4                  ; je jet dal stavov bajt ?
         jz        Result9                  ; nen ji dal bajt
         cmp       bx,offset BuffStat+KORIG+7 ; pekroen poet stavovch bajt ?
         jb        Result1                  ; pjem dalho stavovho bajtu
         mov       byte ptr ds:[LastErr+KORIG],4 ; pekroen poet bajt stavu
                                          ;* pekroen se ignoruje
; ------ nvrat registr

Result9: pop       dx
         pop       bx
         pop       ax
         ret

Result   ENDP

; -----------------------------------------------------------------------------
;        ekn na pipravenost adie - stav AH (CY=chyba TIME-OUT)
; -----------------------------------------------------------------------------

WaitPort PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx

; ------ schova aktulnho asu -> BX

         xchg      ax,bx
         call      GetTime                  ; poskytnut tae asu -> AX
         xchg      ax,bx                    ; BX <- aktuln stav tae asu
         mov       ch,30                    ; njak doba bez pepnn proces

; ------ test, zda je adi pipraven

WaitPrt2:mov       dx,3f4h                  ; port adie
         in        al,dx                    ; ten stavovho registru adie
         and       al,bit6+bit7             ; bity pipravenosti
         cmp       al,ah                    ; je adi pipraven ?
         je        WaitPrt9                 ; adi je pipraven OK

; ------ zpotku zrychlen ekn

         jcxz      WaitPrt3                 ; nen ji zrychlen ekn
         loop      WaitPrt2                 ; rychl ekn

; ------ pepnn proces

WaitPrt3:sti
         call      FlipFlop                 ; pepnn proces

; ------ test, zda je ji TIME-OUT

WaitPrt4:xchg      ax,dx
         call      GetTime                  ; poskytnut tae asu -> AX
         xchg      ax,dx
         sub       dx,bx                    ; ubhl doba
         cmp       dx,TIMEOUT               ; je ji doba pro TIME-OUT ?
         jb        WaitPrt2                 ; ekn na dosaen poadovan doby

         mov       byte ptr ds:[LastErr+KORIG],2 ; TIME-OUT pjmu stavu od adie
         test      ah,bit6                  ; oekv se pjem ?
         jnz       WaitPrt5                 ; oekv se pjem
         mov       byte ptr ds:[LastErr+KORIG],3 ; TIME-OUT vysln povelu na adi

; ------ oprava pi pechodu pes plnoc (zmn se 00B0 -> 0000)

WaitPrt5:cmp       dx,-0d0h                 ; byl pechod pes plnoc ?
         jb        WaitPrt9                 ; nen pechod pes plnoc
         sub       bx,0b0h                  ; oprava
         jmp       short WaitPrt4           ; nov test

; ------ nvrat registr

WaitPrt9:pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

WaitPort ENDP

; -----------------------------------------------------------------------------
;        ekn na peruen INT 0Eh (CY=chyba TIME-OUT)
; -----------------------------------------------------------------------------

WaitInt  PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx

; ------ povolen peruen od adie peruen

         mov       ch,60                    ; njakou dobu bude zrychlen ekn
         in        al,[21h]                 ; registr masky peruen
         jmp       short $+2
         jmp       short $+2
         and       al,not bit6              ; povolen peruen
         out       [21h],al                 ; povolen peruen

; ------ schova aktulnho asu -> BX

         call      GetTime                  ; poskytnut tae asu -> AX
         xchg      ax,bx                    ; BX <- vchoz stav tae asu

; ------ test, zda ji pilo peruen

WaitInt4:test      byte ptr ds:[RParam2+KORIG],bit7 ; pilo peruen ?
         jnz       WaitInt8                 ; peruen pilo OK

; ------ zpotku zrychlen ekn

         jcxz      WaitInt5                 ; nen ji zrychlen ekn
         loop      WaitInt4

; ------ pepnn proces

WaitInt5:sti
         call      FlipFlop                 ; pepnn proces

; ------ test, zda je ji TIME-OUT

WaitInt6:call      GetTime                  ; poskytnut tae asu -> AX
         sub       ax,bx                    ; ubhl doba
         cmp       ax,TIMEOUT               ; je ji doba pro TIME-OUT ?
         jb        WaitInt4                 ; ekn na dosaen poadovan doby
         mov       byte ptr ds:[LastErr+KORIG],1 ; chyba TIME-OUT od INT 0Eh

; ------ oprava pi pechodu pes plnoc (zmn se 00B0 -> 0000)

         cmp       ax,-0d0h                 ; byl pechod pes plnoc ?
         jb        WaitInt9                 ; nen pechod pes plnoc
         sub       bx,0b0h                  ; oprava
         jmp       short WaitInt6           ; nov test

; ------ peruen INT 0Eh pilo OK

WaitInt8:and       byte ptr ds:[RParam2+KORIG],not bit7 ; nulovn pznaku peruen
                                          ;* zde je NC
; ------ nvrat registr

WaitInt9:pop       cx
         pop       bx
         pop       ax
         ret

WaitInt  ENDP

; -----------------------------------------------------------------------------
;        ekn po dobu CX nepodmnn
; -----------------------------------------------------------------------------

Cekej    PROC      NEAR

; ------ schova registr

         push      ax
         push      bx

; ------ schova aktulnho tae asu

         call      GetTime                  ; poskytnut tae asu -> AX
         xchg      ax,bx                    ; BX <- schova vchozho asu

; ------ obsluha pepnae proces

Cekej1:  sti
         call      FlipFlop                 ; pepnn proces

; ------ test, zda ji bylo dosaeno poadovanho asu

Cekej2:  call      GetTime                  ; poskytnut tae asu -> AX
         sub       ax,bx                    ; ubhl doba
         cmp       ax,cx                    ; je ji poadovan doba ?
         jb        Cekej1                   ; ekn na dosaen poadovan doby

; ------ oprava pi pechodu pes plnoc (zmn se 00B0 -> 0000)

         cmp       ax,-0d0h                 ; byl pechod pes plnoc ?
         jb        Cekej9                   ; nen pechod pes plnoc
         sub       bx,0b0h                  ; oprava
         jmp       short Cekej2             ; nov test

; ------ nvrat registr

Cekej9:  pop       bx
         pop       ax
         ret

Cekej    ENDP

; -----------------------------------------------------------------------------
;        poskytnut aktulnho stavu tae asu -> AX
; -----------------------------------------------------------------------------

GetTime  PROC      NEAR

         push      ds
         xor       ax,ax                    ; AX <- 0
         mov       ds,ax                    ; DS <- 0
         mov       ax,ds:[46ch]             ; aktuln as
         pop       ds
         ret

GetTime  ENDP

; -----------------------------------------------------------------------------
;        ekn po dobu AX nsobek 15 us
; -----------------------------------------------------------------------------

WaitT    PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      dx

; ------ rozlien, zda je port [61h]

         xchg      ax,dx                    ; DX <- poadovan doba v 30 us
         test      byte ptr ds:[RParam+KORIG],bit7 ; je port 61h ?
         jnz       WaitT3                   ; je port 61h

; ------ prodleva pro pota XT

WaitT2:  mov       cx,10                    ; 17 takt = 3.5 us, + rezerva
         loop      $                        ; prodleva
         dec       dx
         jnz       WaitT2
         jmp       short WaitT9

; ------ pprava aktulnho stavu

WaitT3:  in        al,[61h]                 ; ten portu
         and       al,bit4                  ; dleit pouze bit4
WaitT4:  mov       ah,al                    ; schova stavu

; ------ ekn zmnu signlu hodin

         xor       cx,cx
WaitT5:  in        al,[61h]                 ; ten hodin
         and       al,bit4                  ; aktuln stav bitu
         cmp       al,ah                    ; je zmna ?
         loope     WaitT5                   ; ekn na zmnu signlu
         dec       dx
         jnz       WaitT4                   ; dal cyklus

; ------ nvrat registr

WaitT9:  pop       dx
         pop       cx
         pop       ax
         ret

WaitT    ENDP

IdentEnd label     byte                     ; konec k testu identifikace

; -----------------------------------------------------------------------------
;        BOOT sektor (dlka 512 bajt)
; -----------------------------------------------------------------------------
;
NOCOM    EQU       1                        ; pznak pro peklad jako INCLUDE
INCLUDE  XFLOP.ASM                          ; BOOT sektor

         dw        0                        ; peteen pro FAT
Buffer   db        2*512 dup(0)             ; buffer pro zsobnk a sektor
         dw        0                        ; peteen pro FAT

RezEnd   label     byte                     ; konec rezidentn sti

; 
;
;                            Start a instalace programu
;
; 
;
; ------ zobrazen vodnho textu

Init:    mov       dx,offset UvTxt
         call      DispTxt                  ; zobrazen vodnho textu

; ------ test, zda je program ji rezidentn

         mov       ds:[RezSegm],es          ; tento program je jako rezidentn
         push      ds
         mov       ax,KLIC1                 ; identifiktor v AX
         mov       bx,KLIC2                 ; identifiktor v BX
         mov       cx,KLIC3                 ; identifiktor v CX
         int       13h                      ; test instalace programu
         pop       ds
         cmp       ax,KLIC4                 ; je potvrzen operace ?
         jne       Init1                    ; nen rezidentn
         mov       ax,es
         cmp       ax,ds:[RezSegm]
         je        Init1                    ; njak program zablokoval ES

; ------ oven verze programu v pamti

         mov       si,offset IdentBeg       ; zatek k testu identifikace
         mov       di,offset IdentBeg+KORIG
         mov       cx,offset(IdentEnd-IdentBeg) ; dlka identifikace
         cld
         repe      cmpsb                    ; porovnn programu
         je        Init04                   ; je to OK

         mov       dx,offset VerzeTxt       ; chyba - je jin verze
         call      DispTxt
         jmp       short Init1

Init04:  or        byte ptr ds:[Param],bit0 ; je rezidentn
         mov       ds:[RezSegm],es          ; segment rezidentnho modulu

; ------ schova pkazovho dku do bufferu

Init1:   push      ds
         pop       es                       ; ES <
         mov       si,81h                   ; zatek pkazovho dku
         mov       di,offset Buffer         ; pracovn buffer
         mov       cl,ds:[si-1]             ; dlka pkazovho dku
         mov       ch,0
         cld
         rep       movsb                    ; schova pkazovho dku
         mov       al,0
         stosb                              ; oznaen konce textu

; ------ posun programu dol

         mov       si,offset RezBeg
         mov       di,offset RezBeg+KORIG
         mov       cx,offset(RezEnd-RezBeg)
         rep       movsb                    ; pesun programu dol

; ------ pprava adresy bufferu sektoru (mus se nechat monost peteen 2 B)

         mov       ax,cs                    ; AX <- segment programu
         mov       cl,4
         shl       ax,cl                    ; pevod segmentu na offset
         add       ax,offset Buffer+KORIG   ; inicializan adresa bufferu
         add       ax,200h                  ; je peteen pes 64 KB ?
         jnc       Init2                    ; nen peteen pes 64 KB
         mov       word ptr ds:[BuffSekt+KORIG],offset Buffer+512+KORIG
         mov       word ptr ds:[Zasob+KORIG],offset Buffer+512-2+KORIG

; ------ pprava pepnae proces

Init2:   mov       si,ds:[Zasob+KORIG]      ; konec zsobnku
         sub       si,11*2                  ; RET F AX BX CX DX SI DI BP DS ES
         mov       word ptr ds:[si+10*2],offset FStart+KORIG ; startovac adresa
         mov       ds:[si+1*2],ds           ; registr DS
         mov       ds:[si+0*2],ds           ; registr ES
         mov       ds:[RegSP+KORIG],si      ; to je ukazatel zsobnku
         mov       ds:[RegSS+KORIG],ds      ; to je segment zsobnku

; ------ pprava asovae AT

         call      TestT                    ; test asovae AT

; ------ rozbor pkazovho dku

         call      Rozbor                   ; rozbor pkazovho dku
         jnc       Init3                    ; zadn je OK

; ------ chybov hlen

ChybaH:  mov       dx,offset HelpTxt
Chyba:   call      DispTxt                  ; chyba - nen pota AT
         int       20h

; ------ odinstalovn programu z pamti

Init3:   test      byte ptr ds:[Param],bit1 ; je odinstalovn ?
         jz        Init4                    ; nen odinstalovn

         mov       es,ds:[RezSegm]
         test      byte ptr es:[RParam+KORIG],bit3 ; probh formtovn ?
         mov       dx,offset JedeTxt        ; text - nutno peruit
         jnz       Chyba                    ; chyba - nutno peruit

         jmp       DInstal                  ; odinstalovn programu z pamti

; ------ detekce parametr disku

Init4:   cmp       byte ptr ds:[Disk+KORIG],-1 ; zadn disk ?
         je        Init5                    ; disk nezadn

         mov       es,ds:[RezSegm]
         test      byte ptr es:[RParam+KORIG],bit3 ; probh formtovn ?
         mov       dx,offset JedeTxt        ; text - nutno peruit
         jnz       Chyba                    ; chyba - nutno peruit

         call      DetDisk                  ; detekce typu disku
         jc        Chyba                    ; chyba - neplatn disk
         call      DetParm                  ; detekce parametr diskety

         call      DispParm                 ; zobrazen parametr diskety

         test      byte ptr ds:[Param],bit3 ; ek se na potvrzen ?
         jnz       Init44                   ; neek se na potvrzen

         mov       dx,offset VarTxt
         mov       al,ds:[Disk+KORIG]
         add       al,"A"
         mov       ds:[VarTxt1],al
         call      DispTxt

         mov       ax,0c08h
         int       21h
         cmp       al,13
         je        Init44
         int       20h

Init44:  or        byte ptr ds:[RParam+KORIG],bit3 ; formtovn aktivn

         call      SetSer                   ; pprava sriovho sla

         mov       si,offset DatBeg+KORIG
         mov       di,si
         mov       cx,offset(DatEnd-DatBeg)
         mov       es,ds:[RezSegm]
         cld
         rep       movsb                    ; penos dat

         mov       si,offset BootBeg+KORIG
         mov       di,si
         mov       cx,offset(BootTxt-BootBeg)
         rep       movsb                    ; penos dat BOOT sektoru


Init5:   test      byte ptr ds:[Param],bit2 ; poadovno peruen ?
         jz        Init6
         mov       es,ds:[RezSegm]
         or        byte ptr es:[RParam+KORIG],bit5 ; poadavek peruen
Init6:
;
; ------ instalace do pamti

         test      byte ptr ds:[Param],bit0 ; je ji nainstalovn ?
         jnz       InitX                    ; je ji nainstalovn

         mov       dx,offset INT23
         mov       ax,2523h
         int       21h

         call      Instal

         test      byte ptr ds:[Param],bit4 ; zobrazen ?
         jz        InitX1                   ; nen zobrazen
         call      Zobraz                   ; zobrazen operace
InitX1:  mov       dx,offset RezEnd+KORIG   ; konec rezidentn sti
         int       27h                      ; instalace do pamti


InitX:
         test      byte ptr ds:[Param],bit4 ; zobrazen ?
         jz        InitX2                   ; nen zobrazen
         call      Zobraz                   ; zobrazen operace
InitX2:
         int       20h


INT23:   iret

; -----------------------------------------------------------------------------
;        instalace programu do pamti
; -----------------------------------------------------------------------------

; ------ hlen o instalaci do pamti

Instal:  mov       dx,offset InstTxt
         call      DispTxt                  ; hlen o instalaci

; ------ schova INT 08h

         mov       ax,3508h
         int       21h
         mov       word ptr ds:[Old08+KORIG],bx
         mov       word ptr ds:[Old08+KORIG+2],es

; ------ schova INT 0Eh

         mov       ax,350Eh
         int       21h
         mov       word ptr ds:[Old0e+KORIG],bx
         mov       word ptr ds:[Old0e+KORIG+2],es

; ------ schova INT 13h

         mov       ax,3513h
         int       21h
         mov       word ptr ds:[BootOld+KORIG],bx
         mov       word ptr ds:[BootOld+KORIG+2],es

; ------ schova INT 40h

         mov       ax,3540h
         int       21h
         mov       word ptr ds:[Old40+KORIG],bx
         mov       word ptr ds:[Old40+KORIG+2],es

; ------ instalace INT 08h

         mov       dx,offset INT08+KORIG
         mov       ax,2508h
         int       21h                      ; instalace INT 08h

; ------ instalace INT 13h

         mov       dx,offset INT13+KORIG
         mov       ax,2513h
         int       21h                      ; instalace INT 13h

; ------ instalace INT 40h

         mov       dx,offset INT40+KORIG
         mov       ax,2540h
         int       21h                      ; instalace INT 40h

; ------ uvolnn segmentu prosted

         mov       es,ds:[2ch]              ; segment prosted
         mov       ah,49h
         int       21h                      ; uvolnn segmentu prosted

         ret

; -----------------------------------------------------------------------------
;        odinstalovn programu z pamti
; -----------------------------------------------------------------------------

; ------ test, zda je program nainstalovn do pamti

DInstal: mov       dx,offset DInsTxt1       ; text - nen nainstalovn
         test      byte ptr ds:[Param],bit0 ; je program nainstalovn ?
         jnz       DInstal2
         jmp       DInstal9                 ; program nen nainstalovn

; ------ kontrola INT 08h

DInstal2:mov       dx,offset DInsTxt2       ; text - nutn odinstalovat pozdj
         mov       ax,3508h
         int       21h
         mov       ax,es
         cmp       ax,ds:[RezSegm]
         jne       DInstal9

; ------ kontrola INT 0Eh

         mov       ax,350eh
         int       21h
         mov       ax,es
         mov       es,ds:[RezSegm]
         cmp       ax,word ptr es:[Old0E+2+KORIG] ; je pvodn obsluha ?
         je        DInstal3                 ; je pvodn obsluha
         cmp       ax,ds:[RezSegm]
         jne       DInstal9

; ------ kontrola INT 13h

DInstal3:mov       ax,3513h
         int       21h
         mov       ax,es
         cmp       ax,ds:[RezSegm]
         jne       DInstal9

; ------ kontrola INT 40h

         mov       ax,3540h
         int       21h
         mov       ax,es
         cmp       ax,ds:[RezSegm]
         jne       DInstal9

; ------ nvrat adresy INT 08h

         push      ds
         mov       ds,ds:[RezSegm]          ; rezidentn segment
         lds       dx,ds:[Old08+KORIG]
         mov       ax,2508h
         int       21h                      ; nvrat adresy INT 08h
         pop       ds

; ------ nvrat adresy INT 0Eh

         push      ds
         mov       ds,ds:[RezSegm]          ; rezidentn segment
         lds       dx,ds:[Old0e+KORIG]
         mov       ax,250eh
         int       21h                      ; nvrat adresy INT 0Eh
         pop       ds

; ------ nvrat adresy INT 13h

         push      ds
         mov       ds,ds:[RezSegm]          ; rezidentn segment
         lds       dx,ds:[BootOld+KORIG]
         mov       ax,2513h
         int       21h                      ; nvrat adresy INT 13h
         pop       ds

; ------ nvrat adresy INT 40h

         push      ds
         mov       ds,ds:[RezSegm]          ; rezidentn segment
         lds       dx,ds:[Old40+KORIG]
         mov       ax,2540h
         int       21h                      ; nvrat adresy INT 40h
         pop       ds

; ------ uvolnn segmentu programu

         mov       es,ds:[RezSegm]          ; rezidentn segment
         mov       ah,49h
         int       21h                      ; uvolnn bloku pamti

; ------ hlen o odinstalovn

         mov       dx,offset DInsTxt        ; text - byl odinstalovn
DInstal9:call      DispTxt                  ; zobrazen hlen
         int       20h

; -----------------------------------------------------------------------------
;        test asovae
; -----------------------------------------------------------------------------

TestT    PROC      NEAR

; ------ ekn na stav 0 signlu hodin

         mov       ch,230                   ; max. doba testu
TestT1:  in        al,[61h]                 ; systmov stavov slovo
         test      al,bit4                  ; jsou hodiny na rovni 0 ?
         loopnz    TestT1                   ; ekn na stav 0 signlu hodin
         jcxz      TestT8                   ; nen asova AT

; ------ ekn na stav 1 signlu hodin

TestT2:  in        al,[61h]                 ; systmov stavov slovo
         test      al,bit4                  ; jsou hodiny na rovni 1 ?
         loopz     TestT2                   ; ekn na stav 1 signlu hodin
         jcxz      TestT8                   ; nen asova AT
         or        byte ptr ds:[RParam+KORIG],bit7 ; pznak asovae AT

TestT8:  ret

TestT    ENDP

; -----------------------------------------------------------------------------
;        pprava sriovho sla
; -----------------------------------------------------------------------------

SetSer   PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx

; ------ stanoven systmovho asu

         mov       ah,2ch
         int       21h                      ; poskytnut systmovho asu

         mov       ah,0
         mov       al,dl                    ; setina sekundy 7 bit
         shr       al,1                     ; setina sekundy 6 bit

         mov       dl,0
         shr       dx,1
         shr       dx,1
         or        ax,dx                    ; sekunda 6 bit (pesahuj 4 bity)

         mov       dh,0
         mov       dl,cl                    ; minuta
         mov       cl,4                     ; poet rotac
         shl       dx,cl
         or        ah,dl                    ; minuty 4 bity
         mov       dl,dh                    ; minuty 2 bity

         mov       dh,ch                    ; hodina
         shl       dh,1
         shl       dh,1
         or        dl,dh                    ; hodina 5 bit (zbv 1 bit)
         mov       dh,0

         mov       word ptr ds:[BootSerN+KORIG+2],ax
         mov       word ptr ds:[BootSerN+KORIG],dx ; v DX je 7 bit

; ------ stanoven systmovho data

         mov       ah,2ah
         int       21h                      ; poskytnut systmovho data

         mov       ah,dh                    ; msc
         mov       cl,4
         shl       ah,cl                    ; msc 4 bity
         mov       dh,0
         mov       cl,7
         shl       dx,cl                    ; den 5 bit
         or        ax,dx                    ; msc + den
         or        word ptr ds:[BootSerN+KORIG],ax ; + msc a den

; ------ nvrat registr

         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

SetSer   ENDP

; *****************************************************************************
;
;                        Rozbor pkazovho dku
;
; *****************************************************************************
;
; -----------------------------------------------------------------------------
;        rozbor pkazovho dku
; -----------------------------------------------------------------------------

Rozbor   PROC      NEAR

; ------ naten znaku parametru

         mov       si,offset Buffer+KORIG   ; buffer pkazovho dku
Rozbor1: call      RozbSpc                  ; vyputn mezer
         call      RozbChr                  ; naten znaku parametru
         jnc       Rozbor4                  ; je dal znak OK
Rozbor2: cmc
Rozbor3: ret

; ------ skok na obsluhu znaku AL

Rozbor4: mov       bx,offset RozbTab-3
Rozbor5: add       bx,3
         cmp       byte ptr cs:[bx],0       ; konec tabulky ?
         je        Rozbor2                  ; chyba - parametr nenalezen
         cmp       byte ptr cs:[bx],al      ; je to hledan znak parametru ?
         jne       Rozbor5                  ; nalezen parametru
         call      word ptr cs:[bx+1]       ; skok na obsluhu parametru
         jmp       short Rozbor1            ; dal parametr

Rozbor   ENDP

; ------ tabulka skok na obsluhy parametr

RozbTab  label     byte
         db        'A'
         dw        RozbTA
                                            
         db        'B'
         dw        RozbTB
                                            
         db        'C'
         dw        RozbTC

         db        'D'
         dw        RozbTD

         db        'E'
         dw        RozbTE

         db        'F'
         dw        RozbTF

         db        'G'
         dw        RozbTG

         db        'H'
         dw        RozbTH

         db        'I'
         dw        RozbTI

         db        'J'
         dw        RozbTJ

         db        'K'
         dw        RozbTK

         db        'L'
         dw        RozbTL

         db        'M'
         dw        RozbTM

         db        'N'
         dw        RozbTN

         db        'O'
         dw        RozbTO

         db        'P'
         dw        RozbTP

         db        'Q'
         dw        RozbTQ

         db        'R'
         dw        RozbTR

         db        'S'
         dw        RozbTS

         db        'T'
         dw        RozbTT

         db        'U'
         dw        RozbTU

         db        'V'
         dw        RozbTV

         db        'W'
         dw        RozbTW

         db        'X'
         dw        RozbTX

         db        'Y'
         dw        RozbTY

;         db        'Z'
;         dw        RozbTZ

         db        '1'
         dw        RozbT1

         db        '4'
         dw        RozbT4

         db        '8'
         dw        RozbT8

         db        '!'
         dw        RozbT_X

         db        0

; ------ "A" - disk A:

RozbTA:  mov       byte ptr ds:[Disk+KORIG],0 ; je disk A:
         ret

; ------ "B" - disk B:

RozbTB:  mov       byte ptr ds:[Disk+KORIG],1 ; je disk B:
         ret

; ------ "C" - velikost bloku

RozbTC:  call      RozbNumB                 ; naten parametru (bajt)
         or        al,al                    ; je nco zadno ?
         jz        RozbTC9                  ; nen nic zadno
         mov       ah,1                     ; 1 sektor na blok
RozbTC4: cmp       al,ah                    ; je ji dostaten velikost bloku ?
         jbe       RozbTC6                  ; nalezen poet sektor na blok
         shl       ah,1                     ; poet sektor * 2
         jnz       RozbTC4                  ; dal test
         mov       ah,80h                   ; omezen velikosti bloku
RozbTC6: mov       ds:[Cluster+KORIG],ah    ; poet sektor na alokan blok
RozbTC9: ret

; ------ "D" - zobrazen operace

RozbTD:  or        byte ptr ds:[Param],bit4 ; poadavek zobrazen operace
         ret

; ------ "E" - pout zvukovou indikaci konce

RozbTE:  or        byte ptr ds:[RParam+KORIG],bit0 ; pout zvukovou indikaci
         ret

; ------ "F" - jmenovit kapacita

RozbTF:  call      RozbNum                  ; naten sla
         cmp       ax,10                    ; asi tolik hranice pro KB
         jae       RozbTF2                  ; je to v KB
         add       dx,40                    ; zaokrouhlen nahoru
         adc       ax,0
         mov       cx,dx                    ; schova desetin
         mov       dx,1000                  ; nsobitel pro pepoet
         mul       dx                       ; pepoet MB na KB
         xchg      ax,cx                    ; CX <- tisce KB
         mov       dx,1000
         mul       dx                       ; pepoet desetin na KB
         xchg      ax,dx                    ; AX <- jednotky KB
         add       ax,cx                    ; kapacita v KB
RozbTF2: or        ax,ax                    ; je zadn OK ?
         jz        RozbTF6                  ; kapacita nen zadan
         inc       ax                       ; trochu zaokrouhlen nahoru
         mov       ds:[JmenKap+KORIG],ax    ; jmenovit kapacita v KB
         call      RozbSpc                  ; vyputn mezer
         jc        RozbTF6
         cmp       al,"M"
         je        RozbTF4
         cmp       al,"K"
         jne       RozbTF6
RozbTF4: call      RozbChr                  ; zruen znaku "K" nebo "M"
         call      RozbChr                  ; dal znak
         jc        RozbTF6                  ; nen dal znak
         cmp       al,"B"
         je        RozbTF6                  ; zruen znaku "B"
         dec       si                       ; nvrat znaku
RozbTF6: ret

; ------ "G" - mezisektorov mezera

RozbTG:  call      RozbNumB
         mov       ds:[Gap+KORIG],ax
         or        byte ptr ds:[Param],bit7 ; pznak zadn mezery GAP
         ret

; ------ "H" - poet hlav

RozbTH:  call      RozbNumB
         or        al,al
         jz        RozbTH4
         cmp       al,2
         jbe       RozbTH2
         mov       al,2
RozbTH2: mov       ds:[Stran+KORIG],al
RozbTH4: ret

; ------ "I" - prokldn sektor interleave

RozbTI:  call      RozbNumB
         cmp       al,MAXSEKT
         jb        RozbTI2
         mov       al,MAXSEKT
RozbTI2: mov       ds:[Interl+KORIG],al
         ret

; ------ "J" - dvoj krokovn

RozbTJ:  call      RozbNumB
         or        ax,ax
         jz        RozbTJ4
         or        byte ptr ds:[Param],bit6 ; zadno krokovn
         and       byte ptr ds:[RParam+KORIG],not bit6 ; nen dvoj krokovn
         dec       ax
         jz        RozbTJ4                  ; nen dvoj krokovn
         or        byte ptr ds:[RParam+KORIG],bit6 ; je dvoj krokovn
RozbTJ4: ret

; ------ "K" - neekat na potvrzen klvesnic

RozbTK:  or        byte ptr ds:[Param],bit3 ; neekat na potvrzen
         ret

; ------ "L" - plnc bajt dat diskety

RozbTL:  call      RozbNumB
         mov       ds:[FillCh+KORIG],al     ; plnc bajt dat
         ret

; ------ "M" - popisova mdia

RozbTM:  call      RozbNumB
         mov       ds:[MediaB+KORIG],al     ; bajt popisovae mdia
         or        byte ptr ds:[Param],bit5 ; pznak zadn popisovae mdia
         ret

; ------ "N" - poet sektor

RozbTN:  call      RozbNumB
         or        al,al                    ; nco zadno ?
         jz        RozbTN4                  ; nic nezadno
         cmp       al,MAXSEKT
         jb        RozbTN2
         mov       al,MAXSEKT               ; maximln poet sektor
RozbTN2: mov       ds:[Sektoru+KORIG],al    ; poet sektor na stopu
RozbTN4: ret

; ------ "O" - penosov rychlost

RozbTO:  call      RozbNum
         or        ax,ax
         jz        RozbTO4
         mov       bl,2
         cmp       ax,275
         jbe       RozbTO2
         dec       bx
         cmp       ax,400
         jbe       RozbTO2
         dec       bx
         cmp       ax,750
         jbe       RozbTO2
         mov       bl,3
RozbTO2: mov       ds:[Rate+KORIG],bl
RozbTO4: ret

; ------ "P" - formtovat vce disket za sebou

RozbTP:  or        byte ptr ds:[RParam+KORIG],bit1 ; formtovn vce disket
         ret

; ------ "Q" - peruen operace

RozbTQ:  or        byte ptr ds:[Param],bit2 ; poadavek peruen
         ret

; ------ "R" - velikost ROOT

RozbTR:  call      RozbNum
         add       ax,15                    ; zaokrouhlen na sektor
         rcr       ax,1
         shr       ax,1
         shr       ax,1
         shr       ax,1                     ; poet sektor
         jz        RozbTR2                  ; nen nic zadno
         mov       ds:[Root+KORIG],ax       ; poet sektor na ROOT
RozbTR2: ret

; ------ "S" - uloit soubor XFLOP.COM

RozbTS:  or        byte ptr ds:[RParam3+KORIG],bit1 ; poadavek uloit XFLOP.COM
         ret

; ------ "T" - poet stop

RozbTT:  call      RozbNumB
         or        al,al                    ; nco zadno ?
         jz        RozbTT2                  ; nic nezadno
         cmp       al,120
         jbe       RozbTT1
         mov       al,120
RozbTT1: mov       ds:[Stop+KORIG],al       ; poet stop
RozbTT2: ret

; ------ "U" - neprovdt veirifikaci

RozbTU:  or        byte ptr ds:[RParam+KORIG],bit2 ; neprovdt verifikaci
         ret

; ------ "V" - jmenovka disku

RozbTV:  call      RozbSpc                  ; vyputn mezer
         jc        RozbTV6
         cmp       al,'"'
         jne       RozbTV6
         call      RozbChr                  ; vyputn znaku uvozovek
         mov       di,offset BootLabl+KORIG ; buffer nvt disku
         push      ds
         pop       es
         mov       cx,11
         mov       al," "
         push      di
         rep       stosb                    ; vymazn bufferu nvt
         pop       di
         or        byte ptr ds:[RParam3+KORIG],bit0 ; poadavek uloit LABEL
         and       byte ptr ds:[RParam3+KORIG],not bit3 ; LABEL se neinkrementuje
         mov       word ptr ds:[LabEnd+KORIG],di ; adresa posledn slice LABEL

RozbTV2: call      RozbChr                  ; naten dalho znaku
         jc        RozbTV6                  ; nen dal znak
         cmp       al,'"'                   ; jsou koncov uvozovky ?
         je        RozbTV6                  ; jsou koncov uvozovky
         cmp       di,offset BootLab0+KORIG ; je konec bufferu nvt ?
         jae       RozbTV2                  ; je konec bufferu nvt
         cmp       al,"0"
         jb        RozbTV4                  ; nen slice
         cmp       al,"9"
         ja        RozbTV4                  ; nen slice
         mov       word ptr ds:[LabEnd+KORIG],di ; adresa posledn slice LABEL
RozbTV4: stosb                              ; uloen znaku do bufferu
         jmp       short RozbTV2            ; dal znak

RozbTV6: ret

; ------ "W" - poet testovacch zpis

RozbTW:  call      RozbNum
         mov       ds:[TestWrit+KORIG],ax   ; poet testovacch zpis
         ret

; ------ "X" - odsazovn mezi stranami

RozbTX:  call      RozbNumB
         cmp       al,MAXSEKT
         jb        RozbTX2
         mov       al,MAXSEKT
RozbTX2: mov       ds:[SlideX+KORIG],al
         ret

; ------ "Y" - odsazovn mezi stopami

RozbTY:  call      RozbNumB
         cmp       al,MAXSEKT
         jb        RozbTY2
         mov       al,MAXSEKT
RozbTY2: mov       ds:[SlideY+KORIG],al
         ret

;; ------ "Z"
;
;RozbTZ:
;         ret


; ------ "1" - jednostrann formtovn

RozbT1:  mov       byte ptr ds:[Stran+KORIG],1   ; 1 strana
         ret


; ------ "4" - 40 stop

RozbT4:  mov       byte ptr ds:[Stop+KORIG],40   ; 40 stop
         ret

; ------ "8" - 8 sektor

RozbT8:  mov       byte ptr ds:[Sektoru+KORIG],8 ; 8 sektor
         ret


; ------ "!" - odinstalovn z pamti

RozbT_X: or        byte ptr ds:[Param],bit1 ; poadovno odinstalovn
         ret

; -----------------------------------------------------------------------------
;        naten sla z pkazovho dku -> AX (omezen na bajt)
; -----------------------------------------------------------------------------

RozbNumB PROC      NEAR

         push      dx
         call      RozbNum
         or        ah,ah
         jz        RozbNmB1
         mov       ax,255
RozbNmB1:pop       dx
         ret

RozbNumB ENDP

; -----------------------------------------------------------------------------
;        naten sla z pkazovho dku -> AX=cel st, DX=desetinn st
; -----------------------------------------------------------------------------

RozbNum  PROC      NEAR

; ------ vyputn mezer ped slem

         call      RozbSpc                  ; vyputn mezer
         jc        RozbNum0
         cmp       al,"$"
         jne       RozbNum0
         call      RozbChr                  ; vyputn znaku "$"
         jmp       RozbHex                  ; naten sla HEX

; ------ schova registr

RozbNum0:push      bx
         push      cx
         push      di
         push      bp

; ------ pprava registr

         xor       bx,bx                    ; BX <- stada sla (cel st)
         xor       cx,cx                    ; CX <- stada sla (desetiny)

         mov       bp,10                    ; nsobitel a dlitel
         mov       di,6554                  ; (65536/10) desetina

; ------ celoseln st

RozbNum1:call      RozbNm                   ; naten slice
         jc        RozbNum2                 ; nen dal slice
         xchg      ax,bx                    ; BX <- nov slice
         mul       bp                       ; stada * 10
         add       bx,ax                    ; piten slice ke stadai
         adc       dx,dx                    ; je peteen ?
         jz        RozbNum1
         mov       bx,-1                    ; omezen sla
         jmp       short RozbNum1           ; dal slice

; ------ peskoen oddlovae desetin

RozbNum2:cmp       al,","                   ; je rka ?
         je        RozbNum3                 ; je rka, budou desetiny
         cmp       al,"."                   ; je teka ?
         jne       RozbNum9                 ; nen ani teka - konec sla
RozbNum3:call      RozbChr                  ; peskoen znaku teky nebo rky

; ------ naten desetinn sti

RozbNum4:call      RozbNm                   ; naten dal slice
         jc        RozbNum9                 ; konec sla
         mul       di                       ; vynsoben desetiny
         add       cx,ax                    ; piten ke stadai desetin
         xchg      ax,di                    ; AX <- ukazatel desetiny
         xor       dx,dx                    ; DX <- 0
         div       bp                       ; posun desetin o d dol
         xchg      ax,di                    ; DI <- nov ukazatel desetiny
         jmp       short RozbNum4           ; dal slice

; ------ nvrat registr

RozbNum9:xchg      ax,bx                    ; AX <- slo
         mov       dx,cx                    ; DX <- desetiny
         pop       bp
         pop       di
         pop       cx
         pop       bx
         ret

RozbNum  ENDP

; ------ naten sla HEX

RozbHex: push      bx
         xor       bx,bx                    ; stada
RozbHex1:call      RozbChr
         jc        RozbHex5
         cmp       al,"0"
         jb        RozbHex4
         cmp       al,"9"
         jbe       RozbHex2
         cmp       al,"A"
         jb        RozbHex4
         cmp       al,"F"
         ja        RozbHex4
         sub       al,7
RozbHex2:sub       al,"0"
         shl       bx,1
         shl       bx,1
         shl       bx,1
         shl       bx,1
         or        bl,al
         jmp       short RozbHex1

RozbHex4:dec       si
RozbHex5:xchg      ax,bx
         pop       bx
         ret

; -----------------------------------------------------------------------------
;        naten jedn slice -> AX (nen-li slice, je v AL znak)
; -----------------------------------------------------------------------------

RozbNm   PROC      NEAR

         mov       ah,0
         call      RozbChr
         jc        RozbNm9
         cmp       al,"0"
         jb        RozbNm8
         cmp       al,"9"
         ja        RozbNm8
         sub       al,"0"
         ret

RozbNm8: dec       si
         stc
RozbNm9: ret

RozbNm   ENDP

; -----------------------------------------------------------------------------
;        vyputn mezer z pkazovho dku
; -----------------------------------------------------------------------------

RozbSpc  PROC      NEAR

         call      RozbChr
         jc        RozbSpc2
         je        RozbSpc
         cmp       al,"/"
         je        RozbSpc
         cmp       al,":"
         je        RozbSpc
         cmp       al,"="
         je        RozbSpc

         dec       si
         clc
RozbSpc2:ret

RozbSpc  ENDP

; -----------------------------------------------------------------------------
;        naten znaku z pkazovho dku
; -----------------------------------------------------------------------------

RozbChr  PROC      NEAR

         cld
         lodsb
         cmp       al,9
         jne       RozbChr2
         mov       al," "

RozbChr2:cmp       al,"a"
         jb        RozbChr3
         cmp       al,"z"
         ja        RozbChr3
         sub       al,32

RozbChr3:cmp       al," "
         jae       RozbChr4
         dec       si

RozbChr4:ret

RozbChr  ENDP

; *****************************************************************************
;
;                        Zobrazen nastaven parametr
;
; *****************************************************************************
;
; -----------------------------------------------------------------------------
;        zobrazen parametr diskety
; -----------------------------------------------------------------------------

DispParm PROC      NEAR

; ------ zobrazen vodn sti hlen

         mov       dx,offset ParTxt
         call      DispTxt

; ------ zobrazen kapacity v KB

         xor       dx,dx
         mov       ax,ds:[JmenKap+KORIG]
         cmp       ax,1000                  ; hranice pro MB
         jae       DispPrm2                 ; zobraz se MB
         call      DispNum                  ; zobrazen kapacity v KB
         mov       al,"K"
         jmp       short DispPrm3

; ------ zobrazen kapacity v MB

DispPrm2:mov       bx,1000
         div       bx                       ; pepoet na MB
         push      ax
         xor       ax,ax
         div       bx                       ; pepoet
         xchg      ax,dx
         pop       ax
         call      DispNum                  ; zobrazen kapacity v MB
         mov       al,"M"
DispPrm3:call      DispChr

; ------ zobrazen potu stop

         mov       dx,offset ParTxtT
         call      DispTxt
         mov       al,ds:[Stop+KORIG]
         call      DispNumB

; ------ zobrazen potu sektor

         mov       dx,offset ParTxtN
         call      DispTxt
         mov       al,ds:[Sektoru+KORIG]
         call      DispNumB

; ------ poet hlav

         mov       dx,offset ParTxtH
         call      DispTxt
         mov       al,ds:[Stran+KORIG]
         call      DispNumB

; ------ krokovn

         mov       dx,offset ParTxtJ
         call      DispTxt
         mov       al,"1"
         test      byte ptr ds:[RParam+KORIG],bit6 ; je dvoj krokovn ?
         jz        DispPr31                 ; nen dvoj krokovn
         inc       ax                       ; jinak parametr "2"
DispPr31:call      DispChr

; ------ odsazovn mezi stranami

         mov       dx,offset ParTxtX
         call      DispTxt
         mov       al,ds:[SlideX+KORIG]
         call      DispNumB

; ------ odsazovn mezi stopami

         mov       dx,offset ParTxtY
         call      DispTxt
         mov       al,ds:[SlideY+KORIG]
         call      DispNumB

; ------ prokldn

         mov       dx,offset ParTxtI
         call      DispTxt
         mov       al,ds:[Interl+KORIG]
         call      DispNumB

; ------ mezisektorov mezera

         mov       dx,offset ParTxtG
         call      DispTxt
         mov       ax,ds:[Gap+KORIG]
         call      DispNum0

; ------ penosov rychlost

         mov       dx,offset ParTxtO
         call      DispTxt
         cmp       byte ptr ds:[Rate+KORIG],1
         mov       ax,500
         jb        DispPr32
         mov       ax,300
         je        DispPr32
         cmp       byte ptr ds:[Rate+KORIG],2
         mov       ax,250
         je        DispPr32
         mov       ax,1000
DispPr32:call      DispNum0

; ------ poet sektor na alokan blok

         mov       dx,offset ParTxtC
         call      DispTxt
         mov       al,ds:[Cluster+KORIG]
         call      DispNumB

; ------ poet poloek na ROOT

         mov       dx,offset ParTxtR
         call      DispTxt
         mov       ax,ds:[Root+KORIG]
         mov       cl,4
         shl       ax,cl
         call      DispNum0

; ------ bajt popisovae mdia

         mov       dx,offset ParTxtM
         call      DispTxt
         mov       al,ds:[MediaB+KORIG]
         call      DispHex

; ------ plnc znak dat

         mov       dx,offset ParTxtL
         call      DispTxt
         mov       al,ds:[FillCh+KORIG]
         call      DispHex

; ------ poet testovacch zpis

         mov       dx,offset ParTxtW
         call      DispTxt
         mov       ax,ds:[TestWrit+KORIG]
         call      DispNum0

; ------ neprovdt verifikaci

         test      byte ptr ds:[RParam+KORIG],bit2
         jz        DispPrm4
         mov       dx,offset ParTxtU
         call      DispTxt

; ------ jmenovka disku

DispPrm4:test      byte ptr ds:[RParam3+KORIG],bit0
         jz        DispPr44                 ; neukld se LABEL
         mov       si,offset BootLabl+KORIG
         mov       di,offset ParTxtV1
         mov       cx,11
         cld
         push      ds
         pop       es
         rep       movsb
DispPr41:cmp       byte ptr ds:[di-1]," "
         jne       DispPr42
         dec       di
         cmp       di,offset ParTxtV1
         ja        DispPr41
DispPr42:mov       ax,'"'
         stosw
         mov       dx,offset ParTxtV
         call      DispTxt

; ------ ukld se XFLOP.COM

DispPr44:test      byte ptr ds:[RParam3+KORIG],bit1 ; ukld se XFLOP.COM ?
         jz        DispPr46                 ; neukld se XFLOP.COM
         mov       dx,offset ParTxtS
         call      DispTxt

; ------ zvukov indikace konce

DispPr46:test      byte ptr ds:[RParam+KORIG],bit0
         jz        DispPrm5                 ; nen zvukov indikace
         mov       dx,offset ParTxtE
         call      DispTxt

; ------ formtovn vce disket

DispPrm5:test      byte ptr ds:[RParam+KORIG],bit1
         jz        DispPrm6
         mov       dx,offset ParTxtP
         call      DispTxt

; ------ poet sektor FAT

DispPrm6:mov       dx,offset ParTxtFA
         call      DispTxt
         mov       ax,ds:[FATSekt+KORIG]
         call      DispNum0

; ------ nevyuit sektory

         mov       dx,offset ParTxtZB
         call      DispTxt
         mov       al,ds:[Nevyuzit+KORIG]
         call      DispNumB

; ------ voln kapacita

         mov       dx,offset ParTxtVO
         call      DispTxt
         mov       ax,word ptr ds:[Cluster+KORIG]    ; poet sektor na alokan blok
         mul       word ptr ds:[NumClust+KORIG] ; poet datovch sektor celkem
         mov       dx,512
         mul       dx                       ; voln kapacita v bajtech
         call      DispNumD

; ------ poet alokanch blok

         mov       dx,offset ParTxtBL
         call      DispTxt
         mov       ax,ds:[NumClust+KORIG]
         call      DispNum0

; ------ zbytek textu

         mov       dx,offset ParTxt0
         call      DispTxt
         ret

DispParm ENDP

; -----------------------------------------------------------------------------
;        zobrazen textu DS:DX
; -----------------------------------------------------------------------------

DispTxt  PROC      NEAR

         push      ax
         push      si

         mov       si,dx
DispTxt1:cld
         lodsb
         cmp       al,0
         je        DispTxt2
         call      DispChr
         jmp       short DispTxt1

DispTxt2:pop       si
         pop       ax
         ret

DispTxt  ENDP

; -----------------------------------------------------------------------------
;        zobrazen sla DOS v AX (DX=desetiny)
; -----------------------------------------------------------------------------

DispNumB:mov       ah,0

DispNum0:xor       dx,dx

DispNum  PROC      NEAR

         push      dx
         push      di
         push      es

         push      ds
         pop       es
         mov       di,offset BuffNum
         push      di
         call      DekNum
         pop       dx
         call      DispTxt

         pop       es
         pop       di
         pop       dx
         ret

DispNum  ENDP

; -----------------------------------------------------------------------------
;        zobrazen sla DX:AX
; -----------------------------------------------------------------------------

DispNumD PROC      NEAR

         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di

         mov       si,10
         xor       cx,cx
DispNmD2:xchg      ax,bx                    ; BX <- LOW
         cmp       cl,3
         jne       DispNmD3
         mov       al,"."
         push      ax
         inc       cx
DispNmD3:cmp       cl,7
         jne       DispNmD4
         mov       al,"."
         push      ax
         inc       cx
DispNmD4:xchg      ax,dx                    ; AX <- HIGH
         xor       dx,dx                    ; DX <- 0
         div       si                       ; vydlen HIGH / 10
         xchg      ax,bx                    ; AX <- LOW, BX <- nov HIGH
         div       si                       ; vydlen LOW
         add       dl,"0"                   ; slice
         push      dx
         inc       cx                       ; ta znak
         mov       dx,bx                    ; nvrat HIGH
         or        bx,ax                    ; je ji 0 ?
         jnz       DispNmD2                 ; dal slice

DispNmD6:pop       ax
         call      DispChr
         loop      DispNmD6

         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

DispNumD ENDP

; -----------------------------------------------------------------------------
;    dekdovn sla v AX (DX=desetiny) do bufferu ES:DI -> DI konec (ozna 0)
; -----------------------------------------------------------------------------

DekNum   PROC      NEAR

         push      ax
         push      bx
         push      cx
         push      dx
         push      si

         mov       si,dx                    ; SI <- schova detesin

         cld
         xor       cx,cx
         mov       bx,10
DekNum1: xor       dx,dx
         div       bx
         push      dx
         inc       cx
         or        ax,ax
         jnz       DekNum1

DekNum2: pop       ax
         add       al,"0"
         stosb
         loop      DekNum2

         inc       si                       ; zaokrouhlen nahoru

         mov       al,"."                   ; oddlovac teka
         stosb

         mov       cl,3                     ; max. slic
DekNum3: xchg      ax,si                    ; AX <- desetiny
         mul       bx                       ; vpoet dal slice
         xchg      ax,si                    ; SI <- schova novho stavu
         xchg      ax,dx
         add       al,"0"
         stosb
         loop      DekNum3                  ; dekdovn dalho sla

DekNum4: cmp       byte ptr es:[di-1],"0"
         jne       DekNum5
         dec       di
         jmp       short DekNum4

DekNum5: cmp       byte ptr es:[di-1],"."
         jne       DekNum6
         dec       di

DekNum6: mov       byte ptr es:[di],0

         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

DekNum   ENDP

; -----------------------------------------------------------------------------
;        zobrazen bajtu HEX
; -----------------------------------------------------------------------------

DispHex  PROC      NEAR

         push      ax
         mov       al,"$"
         call      DispChr
         pop       ax

         push      ax
         shr       al,1
         shr       al,1
         shr       al,1
         shr       al,1
         call      DispHx
         pop       ax

DispHx:  push      ax
         and       al,0fh
         cmp       al,10
         jb        DispHx2
         add       al,7
DispHx2: add       al,"0"
         call      DispChr
         pop       ax
         ret

DispHex  ENDP

; -----------------------------------------------------------------------------
;        zobrazen znaku DOS
; -----------------------------------------------------------------------------

DispChr  PROC      NEAR

         push      ax
         push      dx
         xchg      ax,dx
         mov       ah,2
         int       21h
         pop       dx
         pop       ax
         ret

DispChr  ENDP

; *****************************************************************************
;
;                           Detekce parametr disket
;
; *****************************************************************************
;
; -----------------------------------------------------------------------------
;        detekce parametr diskety (disk je zadn)
; -----------------------------------------------------------------------------

DetParm  PROC      NEAR

         mov       bl,ds:[TypDisk+KORIG]    ; typ mechaniky
         mov       dx,ds:[JmenKap+KORIG]    ; jmenovit kapacita mechaniky

; ------ STOP: implicitn poet stop

         mov       al,ds:[Stop+KORIG]       ; poet stop
         cmp       al,-1                    ; zadn poet stop ?
         jne       DetParm1                 ; poet stop zadn
         mov       al,40                    ; poet stop pro 360 KB
         cmp       bl,M360                  ; mechanika 360 KB ?
         je        DetParm1                 ; mechanika 360 KB
         cmp       dx,600                   ; hranice pro 80 stop
         jb        DetParm1                 ; je mal kapacita
         mov       al,80                    ; jinak implicitn 80 stop
DetParm1:cmp       al,120
         jbe       DetPrm12
         mov       al,120
DetPrm12:mov       ds:[Stop+KORIG],al       ; poet stop diskety


IFDEF    DEMO
         push      ax
         shr       al,1                     ; polovin poet stop
         cmp       al,DEMOTRK               ; omezen stopy
         jb        DetPrm13                 ; stopa je OK
         mov       al,DEMOTRK               ; omezen stopy
DetPrm13:mov       ds:[DemoStop+KORIG],al   ; DEMO stopa
         pop       ax
ENDIF

; ------ krokovn hlav

         test      byte ptr ds:[Param],bit6 ; zadno krokovn ?
         jnz       DetPrm14                 ; zadno krokovn
         and       byte ptr ds:[RParam+KORIG],not bit6 ; nen dvoj krokovn
         cmp       bl,M360
         je        DetPrm14                 ; je jednoduch krokovn
         cmp       al,50                    ; je mlo stop ?
         jae       DetPrm14                 ; je dost stop
         or        byte ptr ds:[RParam+KORIG],bit6 ; je dvoj krokovn

; ------ STRAN: implicitn poet stran

DetPrm14:mov       al,ds:[Stran+KORIG]      ; poet stran
         cmp       al,-1                    ; zadn poet stran ?
         jne       DetParm2                 ; poet stran zadn
         mov       al,1                     ; 1 strana
         cmp       dx,280                   ; hranice pro 1 stranu
         jb        DetParm2                 ; bude 1 strana
         mov       al,2                     ; jinak 2 strany
DetParm2:mov       ds:[Stran+KORIG],al      ; poet stran diskety
         mov       byte ptr ds:[BootSide+KORIG],al ; poet stran diskety

; ------ SEKTORU: implicitn poet sektor

         mov       al,ds:[Sektoru+KORIG]    ; poet sektor na stopu
         cmp       al,-1                    ; zadn poet sektor ?
         jne       DetParm5                 ; poet sektor zadn
         cmp       dx,-1                    ; zadna jmenovit kapacita ?
         jne       DetParm4                 ; jmenovit kapacita zadna

; ------ implicitn poet sektor podle typu mechaniky (nezadna kapacita)

         cmp       byte ptr ds:[Stop+KORIG],50 ; poet stop
         jb        DetParm3                 ; pro mlo stop - disketa DD
         mov       al,15                    ; disketa HD 5 1/4"
         cmp       bl,M120                  ; mechanika HD 1.2MB
         je        DetParm5
         mov       al,18                    ; disketa HD 3 1/2"
         cmp       bl,M144                  ; mechanika HD 1.44 MB
         je        DetParm5
         mov       al,36                    ; disketa QD 3 1/2"
         cmp       bl,M288                  ; mechanika QD 2.88 MB
         je        DetParm5
DetParm3:mov       al,9                     ; jinak disketa DD
         jmp       short DetParm5

; ------ implicitn poet sektor z kapacity diskety

DetParm4:push      dx                       ; jmenovit kapacita
         mov       al,ds:[Stran+KORIG]      ; poet stran
         mul       byte ptr ds:[Stop+KORIG] ; poet stop na celm povrchu diskety
         xchg      ax,cx                    ; CX <- poet stop celkem na povrchu
         pop       ax                       ; AX <- jmenovit kapacita
         mov       dx,1024/512              ; konstanta pro pepoet na sektory
         mul       dx                       ; pepoet kapacity v KB na sektory
         div       cx                       ; vpoet potu sektor na stopu
         cmp       al,MAXSEKT
         jb        DetPrm42
         mov       al,MAXSEKT
DetPrm42:or        al,al                    ; je daj OK ?
         jnz       DetParm5                 ; daj je OK
         inc       ax                       ; minimln 1 sektor
DetParm5:mov       ds:[Sektoru+KORIG],al    ; poet sektor na stopu
         mov       byte ptr ds:[BootSekt+KORIG],al ; poet sektor na stopu

; ------ JMENKAP: vpoet nov jmenovit kapacity (upesnn)

         mul       byte ptr ds:[Stran+KORIG] ; poet sektor na vechny strany
         mov       dx,word ptr ds:[Stop+KORIG] ; poet stop celkem
         mul       dx                       ; poet sektor celkem
         mov       ds:[CelkSekt+KORIG],ax   ; celkov poet sektor disku
         mov       ds:[BootSumS+KORIG],ax   ; celkov poet sektor disku
         shr       ax,1                     ; jmenovit kapacita v KB
         mov       ds:[JmenKap+KORIG],ax    ; nov jmenovit kapacita

; ------ RATE: penosov rychlost

         mov       ah,ds:[Sektoru+KORIG]    ; poet sektor na stopu
         mov       al,ds:[Rate+KORIG]       ; penosov rychlost
         cmp       al,-1
         jne       DetPrm51                 ; rychlost zadna
         cmp       ah,13
         ja        DetPrm50                 ; je HD nebo QD
         mov       al,1                     ; 300 Kb/s
         cmp       bl,M120
         je        DetPrm5A                 ; mechanika 1.2 MB
         cmp       ah,11
DetPrm5B:jae       DetPrm51                 ; 11 a 13 sektor - je 300 Kb/s
         mov       al,2                     ; jinak 250 Kb/s
         jmp       short DetPrm51

DetPrm5A:cmp       ah,8                     ; 8 a vce sektor = 300 Kb/s
         jmp       short DetPrm5B           ; nebo 7 a mn = 250 Kb/s

DetPrm50:mov       al,0                     ; 500 Kb/s
         cmp       ah,22
         jbe       DetPrm51                 ; je HD
         mov       al,3                     ; jinak 1 Mb/s pro QD
DetPrm51:mov       ds:[Rate+KORIG],al

; ------ GAP: mezisektorov mezera

         mov       ax,ds:[Gap+KORIG]
         cmp       ax,-1
         jne       DetParm6

         push      bx
         mov       bl,ds:[Rate+KORIG]       ; penosov rychlost
         mov       bh,0
         shl       bx,1                     ; penosov rychlost * 2
         shl       bx,1
         mov       ax,word ptr ds:[RateTab+bx] ; penosov rychlost
         mov       dx,word ptr ds:[RateTab+bx+2]
         pop       bx
         mov       cx,5                     ; 5 otek za sekundu
         cmp       bl,M120
         jne       DetPrm52
         mov       cl,6                     ; pro mechaniku 1.2 MB je 6 otek
DetPrm52:div       cx                       ; vpoet potu bajt na stopu
         xor       dx,dx
         div       word ptr ds:[Sektoru+KORIG] ; poet bajt na sektor
         sub       ax,512+62                ; zbytek na mezeru
         jae       DetPrm53                 ; je to OK
         xor       ax,ax                    ; minimln mezera
DetPrm53:sub       ax,40                    ; tady bude zlom
         jb        DetPrm54                 ; je men mezera
         shr       ax,1                     ; korekce 80+40 -> 40+40
DetPrm54:add       ax,40                    ; navrcen zlomu
         jnz       DetPrm55                 ; je mezera minimln 1
         inc       ax                       ; korekce mezery na minimln 1
DetPrm55:or        ah,ah                    ; je vce ne 255 bajt ?
         jz        DetParm6                 ; nen vce
         mov       al,255                   ; omezen na 255 bajt
DetParm6:mov       ah,0
         mov       ds:[Gap+KORIG],ax

; ------ INTERL: prokldn sektor

         mov       al,ds:[Interl+KORIG]     ; prokldn sektor
         cmp       al,-1
         jne       DetParm7                 ; zadno

         mov       ah,42                    ; omezen GAP pro DD
         cmp       byte ptr ds:[Rate+KORIG],1 ; 300 kb/s ?
         je        DetPrm62                 ; je DD
         cmp       byte ptr ds:[Rate+KORIG],2 ; 250 kb/s ?
         je        DetPrm62                 ; je DD
         mov       ah,27                    ; omezen GAP pro HD a QD

DetPrm62:mov       al,1                     ; nen prokldn
         cmp       byte ptr ds:[GAP+KORIG],ah ; je nutn prokldn ?
         jae       DetParm7                 ; nen nutn prokldn
         mov       al,2                     ; prokldn pes sektor
DetParm7:cmp       al,ds:[Sektoru+KORIG]
         jb        DetPrm70
         mov       al,ds:[Sektoru+KORIG]
DetPrm70:mov       ds:[Interl+KORIG],al

; ------ zmenen mezery GAP, je-li prokldn (je zbyten, aby byla)

         test      byte ptr ds:[Param],bit7 ; zadna mezera GAP ?
         jnz       DetPrm64                 ; zadna mezera GAP
         cmp       al,1                     ; je prokldn ?
         je        DetPrm64                 ; nen prokldn
         shr       byte ptr ds:[Gap+KORIG],1 ; snen mezery GAP pi prokldn
         jnz       DetPrm64
         inc       byte ptr ds:[Gap+KORIG]  ; minimln 1 mezera

; ------ SLIDEX: odsazovn mezi stranami

DetPrm64:mov       al,ds:[SlideX+KORIG]
         cmp       al,-1
         jne       DetPrm71

         mov       al,ds:[SlideY+KORIG]     ; odsazen Y
         dec       al                       ; X = Y-1
         jns       DetPrm71                 ; Y mlo rozumnou hodnotu

         mov       al,3                     ; odsazen 3 pro QD diskety
         cmp       byte ptr ds:[Rate+KORIG],3
         je        DetPrm71                 ; disketa QD
         dec       ax                       ; odsazen 2 pro HD diskety
         cmp       byte ptr ds:[Rate+KORIG],0
         je        DetPrm71                 ; disketa HD
         dec       ax                       ; jinak odsazen 1 pro diskety DD
DetPrm71:cmp       al,ds:[Sektoru+KORIG]
         jb        DetPr712
         mov       al,ds:[Sektoru+KORIG]
DetPr712:mov       ds:[SlideX+KORIG],al

; ------ SLIDEY: odsazovn mezi stopami

         mov       al,ds:[SlideY+KORIG]
         cmp       al,-1
         jne       DetPrm72

         mov       al,ds:[SlideX+KORIG]     ; odsazen X
         inc       ax                       ; odsazen Y = X+1

         cmp       byte ptr ds:[Stop+KORIG],50 ; je mlo stop ?
         jae       DetPrm72                 ; je dost stop
         inc       ax                       ; odsazen Y = X+2 (dl vt krok)

DetPrm72:cmp       al,ds:[Sektoru+KORIG]
         jb        DetPr722
         mov       al,ds:[Sektoru+KORIG]
DetPr722:mov       ds:[SlideY+KORIG],al

; ------ MEDIAB: popisova mdia

         mov       al,ds:[MediaB+KORIG]     ; popisova mdia
         test      byte ptr ds:[Param],bit5 ; zadn popisova mdia ?
         jnz       DetPrm75                 ; popisova mdida zadn
         cmp       byte ptr ds:[Stop+KORIG],50 ; mal poet stop ?
         jb        DetPrm73                 ; je mal poet stop

         mov       al,0f9h                  ; mal poet sektor
         cmp       byte ptr ds:[Sektoru+KORIG],16
         jbe       DetPrm75                 ; je mal poet sektor
         mov       al,0f0h                  ; velk poet sektor
         jmp       short DetPrm75

DetPrm73:mov       al,0feh                  ; mal poet stop i sektor
         cmp       byte ptr ds:[Sektoru+KORIG],8
         jbe       DetPrm74                 ; je mal poet sektor
         mov       al,0fch                  ; mlo stop, ale dost sektor
DetPrm74:cmp       byte ptr ds:[Stran+KORIG],1 ; je 1 strana ?
         je        DetPrm75                 ; je 1 strana
         or        al,bit0                  ; korekce pro 2 strany
DetPrm75:mov       ds:[MediaB+KORIG],al
         mov       ds:[BootMedD+KORIG],al

; ------ ROOT: poet sektor na ROOT

         mov       ax,ds:[Root+KORIG]       ; poet sektor na ROOT
         cmp       ax,-1
         jne       DetPrm77                 ; poet poloek ROOT byl zadn
         mov       ax,7                     ; diskety DD
         cmp       byte ptr ds:[Sektoru+KORIG],14
         jb        DetPrm76
         mov       al,14                    ; diskety HD
         cmp       byte ptr ds:[Sektoru+KORIG],23
         jb        DetPrm76
         mov       al,15                    ; jinak diskety QD
DetPrm76:cmp       byte ptr ds:[Stran+KORIG],1 ; je 1 strana ?
         ja        DetPrm77                 ; je vc stran
         shr       ax,1                     ; polovin poet ROOT
         cmp       al,4                     ; bylo 7 sektor ?
         ja        DetPrm77                 ; bylo vce
         inc       ax                       ; korekce
DetPrm77:mov       ds:[Root+KORIG],ax
         shl       ax,1
         shl       ax,1
         shl       ax,1
         shl       ax,1
         mov       ds:[BootRoot+KORIG],ax   ; poet poloek ROOT

; ------ CLUSTER: poet sektor na alokan blok

         mov       al,ds:[Cluster+KORIG]
         cmp       al,-1                    ; poet sektor zadn ?
         jne       DetPrm78                 ; zadn
         mov       al,1                     ; 1 sektor na blok
         cmp       byte ptr ds:[Stran+KORIG],1 ; je vce stran ?
         je        DetPrm78                 ; je jen 1 strana
         cmp       byte ptr ds:[Sektoru+KORIG],14 ; je disketa HD ?
         jae       DetPrm78                 ; je disketa HD
         inc       ax                       ; 2 sektory na blok
DetPrm78:mov       ds:[Cluster+KORIG],al    ; poet sektor na alokan blok
         mov       ds:[BootClst+KORIG],al   ; poet sektor na alokan blok

; ------ FATSEKT: uren potu sektor pro tabulky FAT

; ------ poet alokanch blok

DetParm8:mov       word ptr ds:[FatSekt+KORIG],1 ; vchoz hodnota-1 sektor na FAT
DetPrm81:mov       ax,ds:[CelkSekt+KORIG]   ; celkov poet sektor
         dec       ax                       ; odeten BOOT sektoru
         mov       bx,ds:[FatSekt+KORIG]    ; poet sektor na FAT (prozatmn)
         sub       ax,bx                    ; odeten sektor na FAT 1
         sub       ax,bx                    ; odeten sektor na FAT 2
         sub       ax,ds:[Root+KORIG]       ; odeten sektor na ROOT
         xor       dx,dx                    ; DX <- 0
         mov       bl,ds:[Cluster+KORIG]    ; poet sektor na alokan blok
         div       bx                       ; vpoet potu alokanch blok
         mov       ds:[NumClust+KORIG],ax   ; celkov poet alokanch blok
         mov       ds:[Nevyuzit+KORIG],dl   ; poet pebvajcch sektor

; ------ vpoet kapacity tabulek FAT

         mov       ah,byte ptr ds:[FatSekt+KORIG] ; poet sektor na FAT
         mov       al,0
         shl       ax,1                     ; poet bajt na FAT
         shl       ax,1                     ; poet tetrd
         xor       dx,dx                    ; DX <- 0
         mov       bl,3                     ; poet tetrd na poloku FAT
         div       bx                       ; vpoet potu poloek FAT
         dec       ax
         dec       ax                       ; odeten rezervovanch hodnot

; ------ kontrola, zda je poet poloek FAT postaujc

         cmp       ax,ds:[NumClust+KORIG]   ; sta poet poloek FAT ?
         jae       DetPrm82                 ; poet poloek FAT je postaujc
         inc       word ptr ds:[FatSekt+KORIG] ; zven potu poloek FAT
         jmp       short DetPrm81           ; nov test

; ------ kontrola, zda je pekroen poet alokanch blok

DetPrm82:cmp       word ptr ds:[NumClust+KORIG],0ff6h-2 ; pekroen max. poet blok ?
         jb        DetPrm83                 ; poet blok je OK
         shl       byte ptr ds:[Cluster+KORIG],1 ; zven potu sektor na blok
         jmp       short DetParm8           ; nov vpoet FAT

DetPrm83:mov       ax,ds:[FatSekt+KORIG]    ; poet sektor na FAT
         mov       ds:[BootFATS+KORIG],ax   ; poet sektor na FAT

; ------ DATSEKT: poten datov sektor (absolutn) (AX=poet sektor na FAT!)

         shl       ax,1                     ; poet sektor na ob FAT
         inc       ax                       ; piten BOOT
         add       ax,ds:[Root+KORIG]       ; piten sektor na ROOT
         mov       ds:[DatSekt+KORIG],ax    ; poten datov sektor
         mov       ds:[XFlopAbs+KORIG],ax   ; absolutn sektor s XFLOP.COM



         ret

DetParm  ENDP

; ------ tabulka penosovch rychlost
TESTBOD:
RateTab  dd        500000/8                 ; 500 kb/s
         dd        300000/8                 ; 300 kb/s
         dd        250000/8                 ; 250 kb/s
         dd        1000000/8                ; 1000 kb/s

; -----------------------------------------------------------------------------
;        detekce typu zadanho disku (CY=chyba, DX=text chyby)
; -----------------------------------------------------------------------------

DetDisk  PROC      NEAR

; ------ maska disku

         mov       cl,ds:[Disk+KORIG]       ; slo disku
         mov       al,bit0
         shl       al,cl                    ; rotace na pozici
         mov       ds:[DiskMask+KORIG],al   ; maska disku

; ------ naten typu disku z CMOS

         mov       ah,ds:[Disk+KORIG]       ; zadan disk
         call      GetTDisk                 ; ten typu disku z CMOS
         jnc       DetDisk8                 ; disk detekovn OK
         call      TestCMOS                 ; je pam CMOS ?
         mov       al,1                     ; mechanika 360 KB (asi je XT)
         jc        DetDisk8                 ; nen pam CMOS, asi je XT

; ------ chyba - disk nen v potai

         mov       al,ds:[Disk+KORIG]
         add       al,"A"
         mov       ds:[NDiskTx1],al
         mov       dx,offset NDiskTxt
         stc                                ; pznak chyby
         ret

; ------ uloen typu mechaniky

DetDisk8:mov       ds:[TypDisk+KORIG],al    ; typ mechaniky
         clc                                ; pznak operace OK
         ret

DetDisk  ENDP

; -----------------------------------------------------------------------------
;        naten typu mechaniky AH z CMOS -> AL (CY=neplatn disk)
; -----------------------------------------------------------------------------

GetTDisk PROC      NEAR

         push      cx

         call      TestCMOS                 ; test pamti CMOS
         jc        GetTDsk3                 ; neplatn CMOS

         mov       al,ah                    ; AL <- slo mechaniky 0=A:, 1=B:
         inc       ax                       ; 1=A:, 2=B:
         shl       al,1
         shl       al,1                     ; 4=A:, 8=B:
         xchg      ax,cx                    ; CL <- 4=A:, 8=B:

         mov       ah,10h                   ; slo registru CMOS
         call      ReadCMOS                 ; naten registru z CMOS -> AL
         rol       al,cl                    ; rotace sla na pozici
         and       al,0fh                   ; slo mechaniky

         cmp       al,1                     ; minimln slo 1
         jb        GetTDsk2                 ; neplatn disk
         cmp       al,6                     ; maximln slo 5
         cmc

GetTDsk2:mov       ah,ch                    ; nvrat registru AH
GetTDsk3:pop       cx
         ret

GetTDisk ENDP

; -----------------------------------------------------------------------------
;        test kontrolnho soutu pamti CMOS -> CY=neplatn pam
; -----------------------------------------------------------------------------

TestCMOS PROC      NEAR

; ------ schova registr

         push      ax
         push      dx

; ------ kontroln souet CMOS

         xor       dx,dx                    ; stada kontrolnho soutu
         mov       ah,10h                   ; ukazatel sla registru
TestCMS2:call      ReadCMOS                 ; ten bajtu
         add       dl,al                    ; piten
         adc       dh,0
         inc       ah                       ; zven ukazatele
         cmp       ah,2eh
         jne       TestCMS2                 ; dal bajt

; ------ kontrola kontrolnho soutu

         call      ReadCMOS                 ; ten bajtu 2Eh
         cmp       al,dh                    ; souhlas souet HIGH ?
         jne       TestCMS8                 ; nesouhlas
         inc       ah
         call      ReadCMOS                 ; ten bajtu 2Fh
         cmp       al,dl                    ; souhlas souet LOW ?
         je        TestCMS9                 ; souhlas OK
TestCMS8:stc                                ; pznak chyby

; ------ nvrat registr

TestCMS9:pop       dx
         pop       ax
         ret

TestCMOS ENDP

; -----------------------------------------------------------------------------
;        ten bajtu z pamti CMOS (adresa AH) -> AL
; -----------------------------------------------------------------------------

ReadCMOS PROC      NEAR

         xchg      al,ah
         out       [70h],al                 ; nastaven adresy
         xchg      al,ah
         jmp       short $+2
         jmp       short $+2
         jmp       short $+2
         in        al,[71h]                 ; naten hodnoty CMOS
         ret

ReadCMOS ENDP

; *****************************************************************************
;
;                         Obsluha zobrazen operace
;
; *****************************************************************************
;
; -----------------------------------------------------------------------------
;        zobrazen operace (mus bt nainstalovn)
; -----------------------------------------------------------------------------

Zobraz   PROC      NEAR

; ------ inicializace videomdu

         call      InitVMod                 ; inicializace videomdu
         call      KurzOff                  ; vypnut kurzoru

; ------ vymazn obrazovky

         call      Clear                    ; vymazn obrazovky

         mov       es,ds:[RezSegm]
         cmp       byte ptr es:[Disk+KORIG],-1
         je        Zobraz9

; ------ inicializace parametr zobrazen

         call      InitZobr                 ; inicializace zobrazen

; ------ zobrazen podkladu mapy

         call      ZobrPod                  ; zobrazen podkladu mapy

; ------ zobrazen aktulnho nastaven parametr

         call      ZobrPar                  ; zobrazen nastaven parametr

; ------ zobrazen mapy

Zobraz2: call      ZobrMap                  ; zobrazen mapy
;         call      ZobrErr                  ; zobrazen posledn chyby
         call      ZobrVol                  ; zobrazen voln kapacity

; ------ sharewarov demo

IFDEF    SHARE
         call      ZobrShar                 ; zobrazen SHAREWARE
ENDIF

; ------ zobrazen demo

IFDEF    DEMO
         call      ZobrDemo                 ; zobrazen DEMO
ENDIF

; ------ zobrazen chyb systmov oblasti

         call      ZobrSyst

; ------ zobrazen jmna disku

         call      ZobrLab

; ------ zobrazen sriovho sla

         call      ZobrSer                  ; zobrazen sriovho sla

; ------ test, zda je stisk klvesy

         mov       ah,1
         int       16h
         jnz       Zobraz9
         jmp       Zobraz2

; ------ vyprzdnn bufferu klvesnice

Zobraz9: mov       ah,0
         int       16h
         call      InitVMod
         ret

Zobraz   ENDP

; -----------------------------------------------------------------------------
;        sharewarov demo
; -----------------------------------------------------------------------------
IFDEF    SHARE

ZobrShar PROC      NEAR

; ------ hodnota asovae

         xor       bx,bx
         mov       es,bx
         mov       bl,es:[46ch]             ; systmov asova
         shr       bl,1
         shr       bl,1
         and       bx,7
         mov       al,ds:[ZobrSTab+bx]

; ------ pprava k zobrazen

         mov       es,ds:[AdrVRAM]          ; adresa videopamti
         mov       di,(6*80 + 7)*2 + 1
         mov       cx,67
         cld
ZobrShr4:stosb
         inc       di
         loop      ZobrShr4
         ret

ZobrShar ENDP

ZobrSTab label     byte
         db        74h
         db        71h
         db        78h
         db        71h
         db        75h
         db        71h
         db        78h
         db        71h
ENDIF

; -----------------------------------------------------------------------------
;        demo
; -----------------------------------------------------------------------------
IFDEF    DEMO

ZobrDemo PROC      NEAR

; ------ hodnota asovae

         xor       bx,bx
         mov       es,bx
         mov       bl,es:[46ch]             ; systmov asova
         shr       bl,1
         shr       bl,1
         and       bx,7
         mov       al,ds:[ZobrDTab+bx]

; ------ pprava k zobrazen

         mov       es,ds:[AdrVRAM]          ; adresa videopamti
         mov       di,(6*80 + 7)*2 + 1
         mov       cx,67
         cld
ZobrDem4:stosb
         inc       di
         loop      ZobrDem4
         ret

ZobrDemo ENDP

ZobrDTab label     byte
         db        74h
         db        71h
         db        78h
         db        71h
         db        75h
         db        71h
         db        78h
         db        71h
ENDIF

; -----------------------------------------------------------------------------
;        zobrazen mapy
; -----------------------------------------------------------------------------

ZobrMap  PROC      NEAR

; ------ pprava ukazatel

         mov       es,ds:[RezSegm]
         mov       dx,ds:[DTopPoz]          ; poten pozice
         add       dx,101h                  ; pozice prvnho bodu
         mov       ch,ds:[DRadku]           ; dk
         mov       cl,ds:[DPozic]           ; ka
         mov       bh,0                     ; ukazatel sla stopy

ZobrMap1:mov       bl,0                     ; ukazatel sla strany

; ------ schova ukazatel pro jeden dek

ZobrMap2:push      dx
         push      cx
         push      bx

; ------ zobrazen obsahu polka (BL=strana, BH=stopa)

ZobrMap3:call      GetMap                   ; stanoven obsahu
         call      OutChr                   ; zobrazen polka
         inc       bh                       ; zven sla stopy
         cmp       bh,es:[Stop+KORIG]
         jae       ZobrMap8
         dec       cl
         jnz       ZobrMap3

; ------ nvrat ukazatel pro jeden dek

ZobrMap8:pop       bx
         pop       cx
         pop       dx

; ------ posun na dal stranu

         inc       dh
         inc       bx                       ; zven sla strany
         cmp       bl,es:[Stran+KORIG]      ; jsou ji vechny strany ?
         jb        ZobrMap2                 ; dal strana

; ------ posun ukazatel na dal dek

         sub       dh,es:[Stran+KORIG]
         add       bh,ds:[DPozic]           ; posun sla stopy
         add       dh,ds:[DPosun]           ; posun dku
         dec       ch
         jnz       ZobrMap1                 ; dal dek
         ret

ZobrMap  ENDP

; -----------------------------------------------------------------------------
;        poskytnut znaku operace (stopa BH, strana BL) -> AX
; -----------------------------------------------------------------------------

GetMap   PROC      NEAR

; ------ schova registr

         push      bx

IFDEF    DEMO
         push      cx
         mov       cx,bx                    ; CH <- stopa
ENDIF

         push      dx
         push      es

; ------ test, zda je aktuln operace

         mov       es,ds:[RezSegm]
         cmp       bh,es:[AStopa+KORIG]
         jne       GetMap2
         cmp       bl,es:[AStrana+KORIG]
         jne       GetMap2

; ------ uren aktuln operace

IFDEF    DEMO
         mov       ax,"D" + 1eh*HI          ; DEMO simulace
         cmp       byte ptr es:[AOper+KORIG],7
         je        GetMap9
ENDIF

         mov       ax,"R" + 1eh*HI          ; ten
         cmp       byte ptr es:[AOper+KORIG],5
         ja        GetMap9
         mov       al,"W"
         je        GetMap9
         mov       al,"V"
         cmp       byte ptr es:[AOper+KORIG],3
         ja        GetMap9
         mov       al,"F"
         je        GetMap9

; ------ stopa jet nebyla obslouena

GetMap2: cmp       bh,es:[NStopa+KORIG]
         jne       GetMap22
         cmp       bl,es:[NStrana+KORIG]
GetMap22:mov       ax,"" + 7*HI
         jg        GetMap9                  ; nen jet formtovan stopa

; ------ pepoet na absolutn sektor

         mov       al,bh                    ; stopa
         mul       byte ptr es:[Stran+KORIG] ; pepoet stopy na strany
         add       al,bl                    ; piten strany
         adc       ah,0
         mov       bx,word ptr es:[Sektoru+KORIG] ; poet sektor
         mul       bx                       ; pepoet na absolutn sektor

; ------ test, zda je nkter sektor vadn

GetMap3: call      GetErrS                  ; test, zda je sektor vadn
         jc        GetMap8                  ; nalezen vadn sektor
         inc       ax                       ; zven ukazatele sektor
         dec       bx                       ; ta sektor
         jnz       GetMap3                  ; dal sektor

GetMp32: mov       ax,"" + 0ah*HI          ; stopa je OK
         jmp       short GetMap9

GetMap8: mov       ax,"x" + 4eh*HI          ; chyba

IFDEF    DEMO

         test      byte ptr es:[RParam2+KORIG],bit5 ; byla chyba v datech ?
         jnz       GetMp82                  ; byla chyba
         cmp       ch,es:[DemoStop+KORIG]   ; je stopa ped DEMO ?
         jb        GetMp32                  ; nem bt chyba (pelom) - oprava
GetMp82: sub       ch,es:[DemoStop+KORIG]   ; je DEMO stopa ?
         jb        GetMap9                  ; nen DEMO stopa
         mov       bl,ch                    ; stopa
         and       bx,3                     ; offset v tabulce znak
         shr       ch,1
         shr       ch,1
         xor       ch,cl                    ;
         mov       al,ds:[DemoChr+bx]       ; znak z textu
         test      ch,bit0
         jz        GetMp84
         mov       al,"-"
GetMp84:

ENDIF

; ------ nvrat registr

GetMap9: pop       es
         pop       dx

IFDEF    DEMO
         pop       cx
ENDIF

         pop       bx
         ret

GetMap   ENDP


IFDEF    DEMO
DemoChr  db        'DEMO'
ENDIF

; -----------------------------------------------------------------------------
;        poskytnut chyby sektoru AX (CY=chyba)
; -----------------------------------------------------------------------------

GetErrS  PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      dx
         push      es
         mov       es,ds:[RezSegm]

; ------ test, zda to je BOOT sektor

         sub       ax,1
         jae       GetErrS1                 ; nen BOOT
         test      byte ptr es:[RParam2+KORIG],bit1 ; je vadn BOOT ?
         jmp       short GetErrS4

; ------ test, zda je vadn FAT1

GetErrS1:sub       ax,es:[FATSekt+KORIG]
         jae       GetErrS2
         test      byte ptr es:[RParam2+KORIG],bit2
         jmp       short GetErrS4

; ------ test, zda je vadn FAT 2

GetErrS2:sub       ax,es:[FATSekt+KORIG]
         jae       GetErrS3
         test      byte ptr es:[RParam2+KORIG],bit3
         jmp       short GetErrS4

; ------ test, zda je vadn ROOT

GetErrS3:sub       ax,es:[Root+KORIG]
         jae       GetErrS5
         test      byte ptr es:[RParam2+KORIG],bit4
GetErrS4:jnz       GetErrS8                 ; je vadn
         jmp       short GetErrS9           ; je OK

; ------ pepoet na alokan blok

GetErrS5:xor       dx,dx                    ; DX <- 0
         div       word ptr es:[Cluster+KORIG] ; pepoet na alokan blok
         inc       ax
         inc       ax                       ; korekce

; ------ nalezen bloku v tabulce chyb

         mov       bx,offset ErrMap+KORIG - 3
GetErrS6:add       bx,3
         cmp       byte ptr es:[bx],0       ; konec tabulky ?
         je        GetErrS9                 ; konec tabulky
         cmp       ax,es:[bx+1]
         jb        GetErrS6                 ; je ped blokem
         mov       dl,es:[bx]               ; poet blok v intervalu
         mov       dh,0
         add       dx,es:[bx+1]             ; nsledujc blok
         cmp       ax,dx
         jae       GetErrS6                 ; nen v tabulce
                                          ;* jinak nalezen OK v chybch
; ------ nvrat registr

GetErrS8:stc
GetErrS9:pop       es
         pop       dx
         pop       bx
         pop       ax
         ret

GetErrS  ENDP

; -----------------------------------------------------------------------------
;        zobrazen aktulnho nastaven parametr
; -----------------------------------------------------------------------------

ZobrPar  PROC      NEAR

         mov       es,ds:[RezSegm]          ; rezidentn segment

; ------ aktivn disk

         mov       ah,74h                   ; barva textu
         mov       al,es:[Disk+KORIG]       ; aktuln disk
         add       al,"A"
         mov       dx,3
         call      OutChr

; ------ pprava k dekdovn kapacity

         mov       ax,es:[JmenKap+KORIG]    ; jmenovit kapacita v KB
         push      ds
         pop       es                       ; ES <- datov segment
         mov       di,offset BuffNum        ; buffer k dekdovn sla
         mov       si,di                    ; buffer textu

; ------ dekdovn kapacity v KB

         xor       dx,dx                    ; nejsou desetiny
         cmp       ax,1000                  ; hranice pro MB
         jae       ZobrPar1                 ; zobraz se MB
         call      DekNum                   ; dekdovn kapacity v KB
         mov       al,"K"
         jmp       short ZobrPar2

; ------ dekdovn kapacity v MB

ZobrPar1:mov       cx,1000
         div       cx                       ; pepoet na MB
         push      ax
         xor       ax,ax
         div       cx                       ; pepoet
         xchg      ax,dx
         pop       ax
         call      DekNum                   ; dekdovn kapacity v MB
         mov       al,"M"
ZobrPar2:mov       ah,0
         stosw

; ------ zobrazen jmenovit kapacity

         sub       di,si                    ; dlka textu
         xchg      ax,di                    ; AL <- dlka textu
         mov       dx,1*HI + 20
         sub       dl,al                    ; poten pozice k zobrazen
         mov       ah,74h
         call      OutTxt                   ; zobrazen jmenovit kapacity

; ------ poet stop

         mov       es,ds:[RezSegm]          ; rezidentn segment
         mov       ax,word ptr es:[Stop+KORIG] ; poet stop
         mov       bh,74h                   ; barva
         mov       dx,2*HI + 18
         call      OutNumW                  ; zobrazen potu stop

; ------ poet sektor

         mov       ax,word ptr es:[Sektoru+KORIG] ; poet sektor
         mov       dh,3
         call      OutNumW                  ; zobrazen potu sektor

; ------ poet stran

         mov       ax,word ptr es:[Stran+KORIG] ; poet stran
         mov       dh,4
         call      OutNumW                  ; zobrazen potu stran

; ------ krokovn

         mov       ax,1                     ; krokovn po 1 stop
         test      byte ptr es:[RParam+KORIG],bit6 ; je dvoj krokovn ?
         jz        ZobrPar3                 ; nen dvoj krokovn
         inc       ax                       ; krokovn po 2 stopch
ZobrPar3:mov       dh,5
         call      OutNumW                  ; zobrazen krokovn

; ------ posun stran X

         mov       ah,0
         mov       al,es:[SlideX+KORIG]
         mov       dx,1*HI + 37
         call      OutNumW                  ; zobrazen posunu X

; ------ posun stop Y

         mov       al,es:[SlideY+KORIG]
         mov       dh,2
         call      OutNumW                  ; zobrazen posunu Y

; ------ prokldn

         mov       al,es:[Interl+KORIG]
         mov       dh,3
         call      OutNumW                  ; zobrazen prokldn

; ------ mezisektorov mezera

         mov       al,byte ptr es:[GAP+KORIG]
         mov       dh,4
         call      OutNumW

; ------ rychlost

         mov       ax,500
         cmp       byte ptr es:[Rate+KORIG],1
         jb        ZobrPar4
         mov       ax,300
         je        ZobrPar4
         mov       ax,250
         cmp       byte ptr es:[Rate+KORIG],2
         je        ZobrPar4
         mov       ax,1000
ZobrPar4:mov       dh,5
         call      OutNumW

; ------ alokan blok

         mov       ax,word ptr es:[Cluster+KORIG]
         mov       dx,1*HI + 56
         call      OutNumW

; ------ poet poloek ROOT

         mov       ax,es:[Root+KORIG]
         mov       cl,4
         shl       ax,cl
         mov       dh,2
         call      OutNumW

; ------ poet testovacch zpis

         mov       ax,es:[TestWrit+KORIG]
         mov       dh,5
         call      OutNumW

; ------ popisova mdia

         mov       dx,3*HI + 57-3
         mov       ah,74h
         mov       al,"$"
         call      OutChr
         mov       al,es:[MediaB+KORIG]
         call      OutHex

; ------ plnc znak formtovn

         mov       dx,4*HI + 57-3
         mov       al,"$"
         call      OutChr
         mov       al,es:[FillCh+KORIG]
         call      OutHex

; ------ verifikace

         mov       dx,1*HI + 77
         mov       al,"-"
         test      byte ptr es:[RParam+KORIG],bit2 ; provd se verifikace ?
         jz        ZobrPar5                 ; provd se
         mov       al,"o"                   ; verifikace vypnuta
ZobrPar5:call      OutChr

; ------ uloit XFLOP

         mov       dx,3*HI + 77
         mov       al,"-"
         test      byte ptr es:[RParam3+KORIG],bit1 ; ukld se XFLOP ?
         jz        ZobrPar7                 ; neukld se
         mov       al,"o"                   ; XFLOP se ukld
ZobrPar7:call      OutChr

; ------ zvukov indikace

         mov       dx,4*HI + 77
         mov       al,"-"
         test      byte ptr es:[RParam+KORIG],bit0 ; zvukov indikace ?
         jz        ZobrPar8                 ; nen zvukov indikace
         mov       al,"o"
ZobrPar8:call      OutChr

; ------ vce disket

         mov       dx,5*HI + 77
         mov       al,"-"
         test      byte ptr es:[RParam+KORIG],bit1 ; vce disket ?
         jz        ZobrPar9                 ; nen vce disket
         mov       al,"o"
ZobrPar9:call      OutChr
         ret

ZobrPar  ENDP

; -----------------------------------------------------------------------------
;        zobrazen jmna disku
; -----------------------------------------------------------------------------

ZobrLab  PROC      NEAR

         mov       ah,74h
         mov       es,ds:[RezSegm]
         mov       dx,2*HI + 77
         test      byte ptr es:[RParam3+KORIG],bit0 ; ukld se LABEL ?
         jnz       ZobrLab1                 ; LABEL se ukld

         mov       al,"-"
         call      OutChr
         ret


ZobrLab1:mov       cx,11                    ; maximln dlka jmna
         mov       si,offset BootLabl+KORIG + 11
ZobrLab2:cmp       byte ptr es:[si-1]," "
         jne       ZobrLab3
         dec       si
         loop      ZobrLab2

ZobrLab3:sub       dl,cl
         inc       dx
         jcxz      ZobrLab6

         mov       si,offset BootLabl+KORIG
ZobrLab4:mov       al,es:[si]
         call      OutChr
         inc       si
         loop      ZobrLab4

ZobrLab6:ret

ZobrLab  ENDP

; -----------------------------------------------------------------------------
;        zobrazen voln kapacity
; -----------------------------------------------------------------------------

ZobrVol  PROC      NEAR

; ------ pprava celkov kapacity

         mov       es,ds:[RezSegm]          ; rezidentn segment
         mov       ax,es:[NumClust+KORIG]   ; poet alokanch blok
         mul       word ptr es:[Cluster+KORIG] ; vpoet potu sektor celkem
         mov       dx,512
         mul       dx                       ; vpoet celkov kapacity
         mov       word ptr ds:[ZobrVolK],ax ; celkov kapacita
         mov       word ptr ds:[ZobrVolK+2],dx

IFDEF    DEMO
; ------ pprava sla alokanho bloku DEMO dat -> BP

         mov       al,es:[DemoStop+KORIG]   ; DEMO stopa
         mul       byte ptr es:[Stran+KORIG] ; pepoet na poet stran
         mul       word ptr es:[Sektoru+KORIG] ; absolutn slo sektoru DEMO
         dec       ax                       ; bez BOOT sektoru
         sub       ax,es:[FATSekt+KORIG]    ; odeten sektor FAT 1
         sub       ax,es:[FATSekt+KORIG]    ; odeten sektor FAT 2
         sub       ax,es:[Root+KORIG]       ; odeten sektor ROOT
         xor       dx,dx
         div       word ptr es:[Cluster+KORIG] ; pepoet na slo bloku relativn
         inc       ax
         inc       ax                       ; korekce na slo bloku
         xchg      ax,bp                    ; BP <- slo bloku DEMO
ENDIF

; ------ pprava voln kapacity

         mov       word ptr ds:[ZobrVolF],0
         mov       word ptr ds:[ZobrVolF+2],0
         mov       al,es:[NStopa+KORIG]     ; zpracovan stopa
         or        al,al
         js        ZobrVol2                 ; stopa neplatn
         mul       byte ptr es:[Stran+KORIG] ; poet zpracovanch stran
         add       al,es:[NStrana+KORIG]
         adc       ah,0
         inc       ax                       ; piten aktuln strany
         mul       word ptr es:[Sektoru+KORIG] ; pepoet na sektory
         sub       ax,1
         jbe       ZobrVol2
         sub       ax,es:[FATSekt+KORIG]    ; odeten FAT1
         jbe       ZobrVol2
         sub       ax,es:[FATSekt+KORIG]    ; odeten FAT 2
         jbe       ZobrVol2
         sub       ax,es:[Root+KORIG]       ; odeten sektor na ROOT
         jbe       ZobrVol2

         mov       cx,word ptr es:[Cluster+KORIG] ; sektor na alokan blok
         dec       cx
         add       ax,cx                    ; zaokrouhlen nahoru
         inc       cx
         xor       dx,dx
         div       cx                       ; vpoet potu alok. blok
         cmp       ax,es:[NumClust+KORIG]   ; pekroen poet blok ?
         jbe       ZobrVol1
         mov       ax,es:[NumClust+KORIG]   ; omezen potu blok
ZobrVol1:mul       cx                       ; zarovnn na alokan bloky
         mov       dx,512
         mul       dx                       ; pepoet na bajty
         mov       word ptr ds:[ZobrVolF],ax ; voln kapacita
         mov       word ptr ds:[ZobrVolF+2],dx

; ------ pprava vadnch dat

ZobrVol2:mov       word ptr ds:[ZobrVolV],0 ; nulovn vadnch dat
         mov       word ptr ds:[ZobrVolV+2],0

IFDEF    DEMO
         mov       word ptr ds:[ZobrVolD],0 ; nulovn DEMO dat
         mov       word ptr ds:[ZobrVolD+2],0
ENDIF

         mov       si,offset ErrMap+KORIG   ; tabulka chyb
ZobrVol3:cmp       byte ptr es:[si],0
         je        ZobrVol4

         mov       al,es:[Cluster+KORIG]    ; poet sektor na blok
         mul       byte ptr es:[si]         ; velikost seku v sektorech
         mov       dx,512                   ; poet bajt na sektor
         mul       dx                       ; pepoet na bajty

IFDEF    DEMO
         cmp       bp,es:[si+1]             ; je blok DEMO ?
         ja        ZobrVl37                 ; je vadn blok

         add       word ptr ds:[ZobrVolD],ax ; ta DEMO dat
         adc       word ptr ds:[ZobrVolD+2],dx
         jmp       short ZobrVl39
ENDIF

ZobrVl37:add       word ptr ds:[ZobrVolV],ax ; ta vadnch dat
         adc       word ptr ds:[ZobrVolV+2],dx
ZobrVl39:add       si,3
         jmp       short ZobrVol3

; ------ vodn st textu

ZobrVol4:push      ds
         pop       es
         mov       di,offset BuffText
         mov       si,offset TextKap1
         call      DekTxt

; ------ celkov kapacita

         mov       bh,74h
         mov       ax,word ptr ds:[ZobrVolK]
         mov       dx,word ptr ds:[ZobrVolK+2]
         call      DekNumD                  ; dekdovn celkov kapacity

; ------ druh st textu

         call      DekTxt

; ------ voln kapacita

         mov       ax,word ptr ds:[ZobrVolF]
         mov       dx,word ptr ds:[ZobrVolF+2]

IFDEF    DEMO
         sub       ax,word ptr ds:[ZobrVolD]
         sbb       dx,word ptr ds:[ZobrVolD+2]
         jc        ZobrVl48
ENDIF
         sub       ax,word ptr ds:[ZobrVolV]
         sbb       dx,word ptr ds:[ZobrVolV+2]
         jnc       ZobrVol5
ZobrVl48:xor       ax,ax
         xor       dx,dx
ZobrVol5:call      DekNumD

; ------ test, zda jsou vadn data

         mov       ax,word ptr ds:[ZobrVolV]
         or        ax,word ptr ds:[ZobrVolV+2]
         jz        ZobrVol8                 ; nejsou vadn data

; ------ tet st textu

         call      DekTxt

; ------ vadn data

         mov       ax,word ptr ds:[ZobrVolV]
         mov       dx,word ptr ds:[ZobrVolV+2]
         call      DekNumD


ZobrVol8:

IFDEF    DEMO

; ------ test, zda jsou DEMO data

         mov       ax,word ptr ds:[ZobrVolD]
         or        ax,word ptr ds:[ZobrVolD+2]
         jz        ZobrVl81                 ; nejsou DEMO data

; ------ tet st textu

         mov       si,offset TextKap9
         call      DekTxt

; ------ DEMO data

         mov       ax,word ptr ds:[ZobrVolD]
         mov       dx,word ptr ds:[ZobrVolD+2]
         call      DekNumD

ENDIF

; ------ posledn st textu

ZobrVl81:mov       si,offset TextKap4
         call      DekTxt

; ------ vpoet okraj

         mov       si,offset BuffText
         sub       di,si                    ; dlka textu * 2
         shr       di,1                     ; dlka textu ve znacch
         mov       cx,di                    ; CX <- dlka textu
         mov       bx,70                    ; dlka dku
         sub       bx,di                    ; zbytek na okraje
         shr       bx,1                     ; poten pozice
         inc       bx
         inc       bx

; ------ zobrazen levho okraje

         mov       dx,23*HI + 1
         mov       ax,70h*HI + " "
ZobrVl82:call      OutChr
         dec       bx
         jnz       ZobrVl82

; ------ zobrazen textu

ZobrVol9:cld
         lodsw
         call      OutChr
         loop      ZobrVol9

; ------ zobrazen pravho okraje

         mov       ax,70h*HI + " "
ZobrVl94:call      OutChr
         cmp       dl,72
         jb        ZobrVl94
         ret

ZobrVol  ENDP

ZobrVolK dd        0                        ; celkov kapacita
ZobrVolF dd        0                        ; voln kapacita
ZobrVolV dd        0                        ; vadn data

IFDEF    DEMO
ZobrVolD dd        0                        ; demo data
ENDIF

; -----------------------------------------------------------------------------
;        zobrazen chyb v systmov oblasti
; -----------------------------------------------------------------------------
;
ZobrSyst PROC      NEAR

; ------ vpoet absolutnho sektoru zpracovan oblasti

         mov       es,ds:[RezSegm]
         xor       bp,bp
         mov       al,es:[NStopa+KORIG]     ; zpracovan stopa
         or        al,al
         js        ZobrSys2                 ; stopa neplatn
         mul       byte ptr es:[Stran+KORIG] ; poet zpracovanch stran
         add       al,es:[NStrana+KORIG]
         adc       ah,0
         inc       ax                       ; piten aktuln strany
         mul       word ptr es:[Sektoru+KORIG] ; pepoet na sektory
         xchg      ax,bp                    ; BP <- zpracovan sektory
         or        ax,ax
         jns       ZobrSys2
         mov       bp,7fffh

; ------ text "BOOT"

ZobrSys2:mov       si,offset ErrTxt
         mov       dx,13*HI + 63
         mov       ah,70h
         call      OutTxt

; ------ stav pepnae BOOT

         mov       ah,74h
         mov       al,"-"
         sub       bp,1                     ; sektor na BOOT
         js        ZobrSys3
         mov       al,"o"
         test      byte ptr es:[RParam2+KORIG],bit1 ; vadn BOOT ?
         jz        ZobrSys3                 ; nen vadn BOOT
         mov       al,"X"
ZobrSys3:call      OutChr                   ; zobrazen indiktoru

; ------ text "FAT1"

         mov       dx,15*HI + 63
         mov       ah,70h
         call      OutTxt

; ------ stav pepnae FAT 1

         mov       ah,74h
         mov       al,"-"
         sub       bp,es:[FATSekt+KORIG]
         js        ZobrSys4
         mov       al,"o"
         test      byte ptr es:[RParam2+KORIG],bit2 ; vadn FAT 1 ?
         jz        ZobrSys4
         mov       al,"X"
ZobrSys4:call      OutChr

; ------ text "FAT2"

         mov       dx,17*HI + 63
         mov       ah,70h
         call      OutTxt

; ------ stav pepnae FAT 2

         mov       ah,74h
         mov       al,"-"
         sub       bp,es:[FATSekt+KORIG]
         js        ZobrSys5
         mov       al,"o"
         test      byte ptr es:[RParam2+KORIG],bit3 ; vadn FAT 2 ?
         jz        ZobrSys5
         mov       al,"X"
ZobrSys5:call      OutChr

; ------ text "ROOT"

         mov       dx,19*HI + 63
         mov       ah,70h
         call      OutTxt

; ------ stav pepnae ROOT

         mov       ah,74h
         mov       al,"-"
         sub       bp,es:[Root+KORIG]
         js        ZobrSys6
         mov       al,"o"
         test      byte ptr es:[RParam2+KORIG],bit4 ; vadn ROOT ?
         jz        ZobrSys6
         mov       al,"X"
ZobrSys6:call      OutChr
         ret

ZobrSyst ENDP

; -----------------------------------------------------------------------------
;        zobrazen sriovho sla
; -----------------------------------------------------------------------------

ZobrSer  PROC      NEAR

; ------ nadpis sriovho sla

         mov       ah,70h
         mov       si,offset SerNTxt
         mov       dx,9*HI + 63
         call      OutTxt

; ------ zobrazen sriovho sla

         mov       dx,10*HI + 65
         mov       es,ds:[RezSegm]
         mov       ah,74h
         mov       al,byte ptr es:[BootSerN+KORIG+3]
         call      OutHex
         mov       al,byte ptr es:[BootSerN+KORIG+2]
         call      OutHex
         mov       al,"-"
         call      OutChr
         mov       al,byte ptr es:[BootSerN+KORIG+1]
         call      OutHex
         mov       al,byte ptr es:[BootSerN+KORIG]
         call      OutHex
         ret

ZobrSer  ENDP

; -----------------------------------------------------------------------------
;        penesen textu ASCIIZ do bufferu s barvou AH
; -----------------------------------------------------------------------------

DekTxt   PROC      NEAR

         cld
         mov       ah,70h
DekTxt1: lodsb
         cmp       al,0
         je        DekTxt2
         stosw
         jmp       short DekTxt1
DekTxt2: ret

DekTxt   ENDP

; -----------------------------------------------------------------------------
;        dekdovn sla DX:AX do bufferu ES:DI, barva BH
; -----------------------------------------------------------------------------

DekNumD  PROC      NEAR

         push      ax
         push      bx
         push      cx
         push      dx
         push      bp
         push      si

         mov       si,10
         xor       cx,cx
DekNumD2:xchg      ax,bp                    ; BP <- LOW
         cmp       cl,3
         jne       DekNumD3
         mov       al,"."
         push      ax
         inc       cx
DekNumD3:cmp       cl,7
         jne       DekNumD4
         mov       al,"."
         push      ax
         inc       cx
DekNumD4:xchg      ax,dx                    ; AX <- HIGH
         xor       dx,dx                    ; DX <- 0
         div       si                       ; vydlen HIGH / 10
         xchg      ax,bp                    ; AX <- LOW, BP <- nov HIGH
         div       si                       ; vydlen LOW
         add       dl,"0"                   ; slice
         push      dx
         inc       cx                       ; ta znak
         mov       dx,bp                    ; nvrat HIGH
         or        bp,ax                    ; je ji 0 ?
         jnz       DekNumD2                 ; dal slice

DekNumD6:pop       ax
         cld
         mov       ah,bh
         stosw
         loop      DekNumD6

         pop       si
         pop       bp
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

DekNumD  ENDP

;; -----------------------------------------------------------------------------
;;        zobrazen posledn chyby
;; -----------------------------------------------------------------------------
;
;ZobrErr  PROC      NEAR
;
;         mov       dx,23*HI + 2
;         mov       si,offset LastETxt
;         mov       ah,70h
;         call      OutTxt
;
;         mov       ah,74h
;         mov       es,ds:[RezSegm]
;         mov       al,es:[LastErr+KORIG]
;         mov       si,offset LastETab
;ZobrErr2:inc       si
;         cmp       al,ds:[si-1]
;         je        ZobrErr5
;         cmp       byte ptr ds:[si-1],0
;         je        ZobrErr5
;ZobrErr3:inc       si
;         cmp       byte ptr ds:[si-1],0
;         jne       ZobrErr3
;         jmp       short ZobrErr2
;
;ZobrErr5:call      OutTxt
;
;
;ZobrErr6:cmp       dl,78
;         jae       ZobrErr7
;         mov       al," "
;         call      OutChr
;         jmp       short ZobrErr6
;
;ZobrErr7:
;         ret
;
;ZobrErr  ENDP
;
; -----------------------------------------------------------------------------
;        zobrazen podkladu mapy
; -----------------------------------------------------------------------------

ZobrPod  PROC      NEAR

; ------ pprava registr

         mov       es,ds:[RezSegm]
         mov       dx,ds:[DTopPoz]          ; poten pozice mapy
         mov       ch,ds:[DRadku]           ; poet dk mapy
         mov       cl,ds:[DPozic]           ; poet pozic mapy

; ------ zobrazen jednoho dku

         mov       bh,0                     ; ukazatel sla stopy
ZobrPod0:push      dx
         mov       al,es:[Stop+KORIG]
         sub       al,bh
         cmp       al,cl
         jae       ZobrPd02
         mov       cl,al                    ; omezen potu stop

; ------ zobrazen horn linky jednoho dku

ZobrPd02:push      dx
         push      cx
         mov       ch,0
         mov       ah,70h
         mov       al,""
         call      OutChr
ZobrPod1:mov       al,""
         call      OutChr
         loop      ZobrPod1
         mov       al,""
         call      OutChr
         pop       cx
         pop       dx
         inc       dh                       ; zven ukazatele dku

; ------ zobrazen vnitnch linek

         mov       bl,0                     ; ukazatel sla strany
ZobrPod2:push      dx
         push      cx

         sub       dl,9
         mov       si,offset StranTxt
         call      OutTxt

         mov       al,bl                    ; slo strany
         add       al,"0"
         call      OutChr
         mov       al," "
         call      OutChr
         mov       al,""
         call      OutChr
         mov       ch,0
ZobrPod3:mov       ax,"" + 7*HI
         call      OutChr
         loop      ZobrPod3
         mov       ax,"" + 70h*HI
         call      OutChr

         pop       cx
         pop       dx
         inc       dh
         inc       bx
         cmp       bl,es:[Stran+KORIG]
         jb        ZobrPod2

; ------ zobrazen spodn linky jednoho dku

         push      dx
         push      cx

         mov       al,bh                    ; AL <- slo stopy
         mov       ah,0
         mov       ch,5
         div       ch                       ; vpoet posunu
         mov       bl,ah

         mov       ch,0
         mov       ah,70h
         mov       al,""
         call      OutChr
ZobrPod4:mov       al,""
         dec       bl
         jns       ZobrPod6
         mov       bl,4
         mov       al,""

         push      ax
         push      dx
         inc       dh
         mov       al,bh                    ; slo stopy
         cmp       al,10
         jb        ZobrPod5
         dec       dx
ZobrPod5:call      OutNumB                  ; zobrazen sla stopy
         pop       dx
         pop       ax

ZobrPod6:call      OutChr
         inc       bh
         loop      ZobrPod4
         mov       al,""
         call      OutChr

         pop       cx
         pop       dx
         inc       dh                       ; zven ukazatele dku



; ------ pprava k zobrazen dalho dku

         pop       dx
         add       dh,ds:[DPosun]
         dec       ch
         jz        ZobrPod9                 ; konec
         jmp       ZobrPod0
ZobrPod9:ret

ZobrPod  ENDP

; -----------------------------------------------------------------------------
;        inicializace zobrazen
; -----------------------------------------------------------------------------
;
InitZobr PROC      NEAR

; ------ poet dk mapy

         mov       es,ds:[RezSegm]          ; rezidentn segment
         mov       ax,word ptr es:[Stop+KORIG] ; poet stop celkem
         mov       cx,52                    ; asi tak maximln ka
         div       cl                       ; vpoet potu dk
         inc       ax                       ; poet dk
         mov       ds:[DRadku],al           ; poet dk mapy

; ------ poet pozic mapy

         mov       ax,word ptr es:[Stop+KORIG] ; poet stop celkem
         div       byte ptr ds:[DRadku]     ; vpoet potu pozic
         mov       ds:[DPozic],al           ; poet pozic na dek mapy

; ------ odsazen jednotlivch dk mapy

         mov       al,es:[Stran+KORIG]      ; poet stran
         add       al,4                     ; odsazen dk
         cmp       byte ptr ds:[DRadku],2
         jbe       InitZob1
         dec       ax                       ; snen mezery mezi dky
InitZob1:mov       ds:[DPosun],al           ; odsazen dk
         mul       byte ptr ds:[DRadku]     ; celkov poet dk
         sub       ax,3                     ; bez okraj
         xchg      ax,cx                    ; CX <- vka okna

; ------ horizontln poten pozice

         mov       al,54                    ; ka displeje
         sub       al,ds:[DPozic]           ; odeten ky mapy
         shr       al,1                     ; poten pozice mapy
         add       al,9
         mov       byte ptr ds:[DTopPoz],al ; poten pozice mapy

; ------ vertikln poten pozice

         mov       al,22                    ; vka displeje
         sub       al,cl                    ; odeten vky mapy
         shr       al,1                     ; poten dek mapy
         add       al,3
         mov       byte ptr ds:[DTopPoz+1],al ; poten dek mapy
         ret

InitZobr ENDP

; -----------------------------------------------------------------------------
;        vymazn obrazovky
; -----------------------------------------------------------------------------

Clear    PROC      NEAR

         push      ax
         push      cx
         push      dx
         push      di
         push      es

         cld
         mov       es,ds:[AdrVRAM]
         xor       di,di

; ------ horn okraj

         mov       si,offset StavTxt
         mov       cx,offset(StavTxt0-StavTxt)
         mov       ah,70h
Clear1:  lodsb
         stosw
         loop      Clear1

; ------ stedn dky

         mov       dx,25-7-1
Clear2:  mov       al,""
         stosw
         mov       al," "
         mov       cl,78
         rep       stosw
         mov       al,""
         stosw
         dec       dx
         jnz       Clear2

; ------ spodn okraj

         mov       al,""
         stosw
         mov       cl,78
         mov       al,""
         rep       stosw
         mov       al,""
         stosw

         pop       es
         pop       di
         pop       dx
         pop       cx
         pop       ax
         ret

Clear    ENDP

; -----------------------------------------------------------------------------
;        zobrazen sla AX (barva BH) od pozice DX zpt
; -----------------------------------------------------------------------------

OutNumW  PROC      NEAR

         push      ax
         push      cx
         push      dx
         push      si

         mov       si,10
OutNumW1:mov       cx,dx                    ; CX <- pozice
         xor       dx,dx                    ; DX <- 0
         div       si                       ; AX <- nov podl, DX <- slice

         xchg      ax,cx                    ; CX <- podl, AX <- pozice
         xchg      ax,dx                    ; AX <- slice, DX <- pozice
         add       al,"0"                   ; korekce na znak ASCII
         mov       ah,bh                    ; barva znaku
         call      OutChr                   ; zobrazen znaku AL
         dec       dx
         dec       dx                       ; posun pozice

         xchg      ax,cx                    ; AX <- podl
         or        ax,ax                    ; je jet slo ?
         jnz       OutNumW1                 ; dal slice

         pop       si
         pop       dx
         pop       cx
         pop       ax
         ret

OutNumW  ENDP

; -----------------------------------------------------------------------------
;        zobrazen sla AL (barva AH) na pozici DX
; -----------------------------------------------------------------------------

OutNumB  PROC      NEAR

         push      ax
         push      bx
         push      cx

         mov       bh,ah
         mov       bl,10
         xor       cx,cx
OutNumB1:mov       ah,0
         div       bl
         push      ax
         inc       cx
         cmp       al,0
         jne       OutNumB1

OutNumB2:pop       ax
         mov       al,ah
         add       al,"0"
         mov       ah,bh
         call      OutChr
         loop      OutNumB2

         pop       cx
         pop       bx
         pop       ax
         ret

OutNumB  ENDP

; -----------------------------------------------------------------------------
;        zobrazen textu ASCIIZ DS:SI na pozici DX, barva AH
; -----------------------------------------------------------------------------

OutTxt   PROC      NEAR

         push      ax

OutTxt2: cld
         lodsb
         cmp       al,0
         je        OutTxt9
         call      OutChr
         jmp       short OutTxt2

OutTxt9: pop       ax
         ret

OutTxt   ENDP

; -----------------------------------------------------------------------------
;        zobrazen bajtu AL v HEX kdu (pozice DX, barva AH)
; -----------------------------------------------------------------------------

OutHex   PROC      NEAR

         push      ax
         shr       al,1
         shr       al,1
         shr       al,1
         shr       al,1
         call      OutHx
         pop       ax

OutHx:   push      ax
         and       al,0fh
         cmp       al,9
         jbe       OutHx2
         add       al,7
OutHx2:  add       al,"0"
         call      OutChr
         pop       ax
         ret

OutHex   ENDP

; -----------------------------------------------------------------------------
;        zobrazen znaku AX na pozici DX
; -----------------------------------------------------------------------------

OutChr   PROC      NEAR

         push      di
         push      es

         push      ax
         mov       al,80                    ; poet pozic na dek
         mul       dh                       ; pepoet adku na pozice
         add       al,dl                    ; piten pozice
         adc       ah,0
         shl       ax,1                     ; offset ve videopamti
         xchg      ax,di                    ; DI <- offset ve videopamti
         pop       ax
         mov       es,ds:[AdrVRAM]
         cld
         stosw

         pop       es
         pop       di
         inc       dx                       ; zven ukazatele dku
         ret

OutChr   ENDP

; -----------------------------------------------------------------------------
;        vypnut kurzoru
; -----------------------------------------------------------------------------

KurzOff  PROC      NEAR

         push      ax
         push      bx
         push      dx

         xor       bx,bx
         mov       dx,25*HI + 0
         mov       ah,2
         call      Int10

         pop       dx
         pop       bx
         pop       ax
         ret

KurzOff  ENDP

; -----------------------------------------------------------------------------
;        inicializace videomdu
; -----------------------------------------------------------------------------

InitVMod PROC      NEAR

         push      ax
         push      bx
         push      cx
         push      dx

         mov       ah,0fh
         call      Int10
         mov       word ptr ds:[AdrVRAM],0b000h
         cmp       al,7
         je        InitVMd2
         mov       word ptr ds:[AdrVRAM],0b800h
         mov       al,3
InitVMd2:mov       ah,0
         call      Int10

         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

InitVMod ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 10h
; -----------------------------------------------------------------------------

Int10    PROC      NEAR

         pushf
         push      si
         push      di
         push      bp
         push      ds
         push      es

         int       10h

         pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         popf
         ret

Int10    ENDP

; 
;
;                        Data pro instalaci
;
; 
;

; ------ obsluha zobrazen

AdrVRAM  dw        0b800h                   ; adresa videopamti

DTopPoz  dw        0                        ; poten pozice mapy
DRadku   db        1                        ; poet dk mapy stop
DPozic   db        1                        ; poet pozic na mapu (ka stop)
DPosun   db        1                        ; odsun jednotlivch dk mapy

StranTxt db        'strana ',0
;LastETxt db        'posledni stav I/O: ',0
;
;LastETab db        1,'TIME-OUT od preruseni INT 0Eh',0
;         db        2,'TIME-OUT prijmu stavu od radice',0
;         db        3,'TIME-OUT vyslani povelu k radici',0
;         db        4,'prekrocen pocet bajtu stavu od radice',0
;         db        5,'chyba vystaveni hlav',0
;         db        6,'mechanika nepripravena',0
;         db        7,'nenalezena stopa 0',0
;         db        8,'sektor nenalezen',0
;         db        9,'disketa chranena proti zapisu',0
;         db        10,'preteceni prenosu DMA',0
;         db        11,'chyba kontrolniho souctu dat CRC',0
;         db        12,'nesouhlasi hlavicka sektoru',0
;         db        13,'chyba resetovani radice',0
;         db        255,'chyba operace',0
;         db        0,'-',0

IFDEF    DEMO
StavTxt  db        ' A:  XFORM V1.00 DEMO ͻ'
         db        ' F kapacita         X posun stran     C alok. blok      U neverifikovat    '
         db        ' T stop             Y posun stop      R pol. ROOT       V jmeno            '
         db        ' N sektoru          I prokladani      M popisovac       S ulozit XFLOP     '
         db        ' H stran            G mezera          L vypln dat       E indikace         '
         db        ' J krokovani        O rychlost        W zapisu          P vice disket      '
         db        ' DEMONSTRACNI verze programu -- formatuje pouze polovinu diskety !!! ͹'
StavTxt0 label     byte
ELSE

IFDEF    SHARE
StavTxt  db        ' A:  XFORM V1.00 ͻ'
         db        ' F kapacita         X posun stran     C alok. blok      U neverifikovat    '
         db        ' T stop             Y posun stop      R pol. ROOT       V jmeno            '
         db        ' N sektoru          I prokladani      M popisovac       S ulozit XFLOP     '
         db        ' H stran            G mezera          L vypln dat       E indikace         '
         db        ' J krokovani        O rychlost        W zapisu          P vice disket      '
         db        ' SHAREWARE verze !!!  Druha polovina diskety s pomalym pristupem !!! ͹'
StavTxt0 label     byte
ELSE
StavTxt  db        ' A:  XFORM V1.00 ͻ'
         db        ' F kapacita         X posun stran     C alok. blok      U neverifikovat    '
         db        ' T stop             Y posun stop      R pol. ROOT       V jmeno            '
         db        ' N sektoru          I prokladani      M popisovac       S ulozit XFLOP     '
         db        ' H stran            G mezera          L vypln dat       E indikace         '
         db        ' J krokovani        O rychlost        W zapisu          P vice disket      '
         db        '͹'
StavTxt0 label     byte
ENDIF
ENDIF

SerNTxt  db        'Seriove cislo',0

ErrTxt   db        'BOOT ...... ',0
         db        'FAT1 ...... ',0
         db        'FAT2 ...... ',0
         db        'ROOT ...... ',0

Param    db        0                        ; parametry
                                            ;   bit 0: 1=je rezidentn st
                                            ;   bit 1: 1=poadovno odinstalovn
                                            ;   bit 2: 1=poadovno peruen
                                            ;   bit 3: 1=neekat na potvrzen
                                            ;   bit 4: 1=poadovno zobrazen operace
                                            ;   bit 5: 1=zadn popisova mdia
                                            ;   bit 6: 1=zadno krokovn
                                            ;   bit 7: 1=zadna mezera GAP

RezSegm  dw        0                        ; adresa rezidentn sti

UvTxt    db        'XFORM v1.00 - rezidentni formatovani disket; (c) Miroslav Nemecek',13,10
IFDEF    SHARE
         db        '*** Toto je SHAREWARE verze - zpomaluje rychlost 1/2 diskety ! ***',13,10
ENDIF
IFDEF    DEMO
         db        '*** Toto je DEMONSTRACNI verze - formatuje jen polovinu diskety ! ***',13,10
ENDIF
         db        0

DInsTxt  db        'Program byl odinstalovan z pameti.',13,10,0
DInsTxt1 db        'Program nelze odinstalovat, nebyl dosud nainstalovan !',13,10,0
DInsTxt2 db        'Je nutno odinstalovat nejdrive programy nainstalovane po programu XFORM !',13,10,0
VerzeTxt db        'V pameti je nainstalovana jina verze programu XFORM !',13,10,0
JedeTxt  db        'Probihajici formatovani je nutno nejdrive prerusit parametrem "Q" !',13,10,0

VarTxt   db        13,10,'Vlozte do mechaniky '
VarTxt1  db        'A: novou disketu a stisknete ENTER.',13,10
         db        'VAROVANI - puvodni obsah diskety bude formatovanim znicen !',13,10,0

NDiskTxt db        'Disk '
NDiskTx1 db        'A: neni nainstalovan v pocitaci !',13,10,0

InstTxt  db        'Program byl nainstalovan do pameti.',13,10,0

; ------ zobrazen formtu diskety

ParTxt   db        13,10
ParTxtF  db        'F',0
ParTxtT  db        ' T',0
ParTxtN  db        ' N',0
ParTxtH  db        ' H',0
ParTxtJ  db        ' J',0
ParTxtX  db        ' X',0
ParTxtY  db        ' Y',0
ParTxtI  db        ' I',0
ParTxtG  db        ' G',0
ParTxtO  db        ' O',0
ParTxtC  db        ' C',0
ParTxtR  db        ' R',0
ParTxtM  db        ' M',0
ParTxtL  db        ' L',0
ParTxtW  db        ' W',0
ParTxtU  db        ' U',0
ParTxtV  db        ' V"'
ParTxtV1 db        11 dup(" "),'"',0
ParTxtS  db        ' S',0
ParTxtE  db        ' E',0
ParTxtP  db        ' P',0

ParTxtFA db        13,10,'sektoru FAT=',0
ParTxtZB db        ', nevyuzito=',0
ParTxtVO db        ', volne=',0
ParTxtBL db        ' B, bloku=',0
ParTxt0  db        13,10,0

BuffNum  db        20 dup(" ")              ; buffer k dekdovn sla

TextKap1 db        'Kapacita ',0
TextKap2 db        ' B, volne ',0
TextKap3 db        ' B, vadne ',0

IFDEF    DEMO
TextKap9 db        ' B, demo ',0
ENDIF

TextKap4 db        ' B.',0
BuffText db        2*80 dup(" ")            ; buffer k dekdovn textu

HelpTxt  db        'Zadejte:   A: nebo B: ........ oznaceni disku A: nebo B: k formatovani',13,10
         db        ' Fyzicke parametry diskety  Logicke parametry diskety ͻ',13,10
         db        ' F kapacita . jmenovita kapacita       C sektoru .. sektoru na alokacni blok',13,10
         db        ' T stop ..... pocet stop (valcu)       R polozek .. pocet polozek ROOT      ',13,10
         db        ' N sektoru .. pocet sektoru na stopu   M bajt ..... popisovac media         ',13,10
         db        ' H hlav ..... pocet hlav (stran) (1-2) L bajt ..... plnici bajt dat diskety ',13,10
         db        ' J kroku .... krokovani posunu (1-2)                                        ',13,10
         db        ' X sektoru .. posun pri zmene strany   Rizeni formatovani ͹',13,10
         db        ' Y sektoru .. posun pri zmene stopy    W zapisu ... pocet testovacich zapisu',13,10
         db        ' I interleave prokladani sektoru       U .......... neprovadet verifikaci   ',13,10
         db        ' G bajtu .... mezisektorova mezera     V "label" .. jmenovka disku          ',13,10
         db        ' O rate ..... prenos 250/300/500/1000  S .......... ulozit na disk XFLOP.COM',13,10
         db        ' 1 .......... 1 strana (jako H1)       E .......... zvukova indikace konce  ',13,10
         db        ' 4 .......... 40 stop (jako T40)       P .......... formatovat vice disket  ',13,10
         db        ' 8 .......... 8 sektoru (jako N8)      K .......... nepotvrzovat klavesnici ',13,10
         db        ' Ovladaci povely ͹',13,10
         db        ' D ........... zobrazeni prubehu operace formatovani                         ',13,10
         db        ' Q ........... preruseni probihajiciho formatovani                           ',13,10
         db        ' ! ........... odinstalovani programu z pameti                               ',13,10
         db        'ͼ',13,10
         db        'Cisla lze zadat jako HEX uvedenim znaku "$" pred cislem.',13,10
         db        0

Code     ENDS
         END       Start
